-- name=common_impl
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Init()

  ----------------------------------------------------------------------------------
  private.LoadStandardCursors();
  private.AchievementsInit();
  private.CollectiblesInit();
  private.Collectibles2Init();
  private.MorphInit();
  ----------------------------------------------------------------------------------
  common.SetCheaterKeyF( 1, "level1" );
  common.SetCheaterKeyF( 2, "level2" );
  common.SetCheaterKeyF( 3, "level3" );
  common.SetCheaterKeyF( 4, "levelext" );
  common.SetCheaterKeyF( 5, "levelscr" );
  public.subscribers_included = true;
  private.timers = {};
  ----------------------------------------------------------------------------------
  private.is_openbrowser_enabled = false; --разрешение открытия браузера
  ----------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------
  public.animtime = 0.3;
  -------------------note-----------------------------------------------------------
  public.note = {};
  private.note_scale = {};
  private.note_scale.pos_x = 0;
  private.note_scale.pos_y = 0;
 -------------------hint-----------------------------------------------------------
  public.show_hint = {};
  public.save_autohide = 1;
  ----------------------------------------------------------------------------------
  public.hint ={};
  public.hint.res = "assets/interface/resources/fx/hint/anm_hint";
  public.hint.res_inv = "assets/interface/resources/fx/hint/anm_hint_inventory"; -- ресурс для хинта на инвентарь
  public.hint.big_R = 500;
  public.hint.big_R_zz = 500;
  public.hint.small_R = 40;
  public.hint.partsys_count = 6; -- количество систем частиц
  public.hint.time_fly = 1.0;    -- время, за которое частицы долетят до цели
  public.hint.time_fly_zz = 0.8; -- время для зум-зоны
  public.hint.time_circle = 3.0; -- время на один сдвиг по кругу
  public.hint.circle_cnt = 0.5;     -- количество сдвигов частиц по кругу
  public.hint.tme_show = 0.4;
  public.hint.tme_hide = 0.4;
  public.hint.tme_circle_fx = 1.0 --время показа центральной частицы
  public.hint.sinus_offset = 70 --амплитуда синусоиды
  public.hint.sinus_points_cnt = 50 --количество точек синусоиды
  public.hint.sinus_points_extrems = 2; --количество экстремумов синусоиды
  public.hint.play_sfx=true; --звук хинта в сложном объекте
  public.hint.target = {}
  public.hint.position_zz = {}
  ----------------------------------------------------------------------------------
  public.dialog_character_loc = "";
  public.dialog_character_select = 0; --номер выбранной фразы/войса
  public.save_all_env = {}; --массив сохраненных энвов
  private.lipsing_name = ""; --название видоса липсинга
  private.aud_name = ""; -- название звука
  ----------------------------------------------------------------------------------

  cmn.SetEventDone            = public.SetEventDone;
  cmn.IsEventDone             = public.IsEventDone;
  cmn.SetEventStart           = public.SetEventStart;
  cmn.IsEventStart            = public.IsEventStart;
  cmn.HoTaskFind              = public.HoTaskFind;
  cmn.HoItemFind              = public.HoItemFind;
  cmn.MiniGameHide            = public.MiniGameHide;
  cmn.MiniGameShow            = public.MiniGameShow;
  cmn.SetMarkedTask           = public.SetMarkedTask;
  cmn.UnmarkTask              = public.UnmarkTask;
  cmn.IsUnmarkedTask          = public.IsUnmarkedTask;
  cmn.InitHo                  = public.InitHo;
  cmn.Lock                    = public.Lock;
  cmn.ApplyObj                = public.ApplyObj;
  cmn.NoteScale               = public.NoteScale;
  cmn.NoteScaleClose          = public.NoteScaleClose;
  cmn.GotoRoom                = common.GotoRoom;
  cmn.GotoSubRoom             = common.GotoSubRoom;
  cmn.GetInvObjectSfx         = private.GetInvObjectSfx;
  cmn.ItemFly                 = public.ItemFly;
  cmn.PlayMusEnv              = public.PlayMusEnv;
  cmn.StopMusEnv              = public.StopMusEnv;
  cmn.SetInvPlusRGB           = public.SetInvPlusRGB;
  cmn.CheckGiveCustomAchiev   = public.CheckGiveCustomAchiev;
  cmn.PlayDialogVideo         = public.PlayDialogVideo;
  cmn.IsGetCollect2           = public.IsGetCollect2
  cmn.AnimForCur              = public.AnimForCur
  cmn.PlayMusDanger           = public.PlayMusDanger
  cmn.GetAudio                = public.GetAudio
  cmn.EnterRmWithoutInterface = public.EnterRmWithoutInterface
  cmn.ExitRmWithoutInterface  = public.ExitRmWithoutInterface

  private.audio = {};
  private.audio["sfx"] = {};
  private.audio["env"] = {};
  private.audio["mus"] = {};
  private.audio["voc"] = {};
  private.audio["mus_env"] = {};
  ----------------------------------------------------------------------------------

  private.volume_fade = false;
  private.dialog_voice = 0;
  private.dialog_soundtrack = 0;
  private.dialog_env = 0;
  
  ----------------------------------------------------------------------------------

  private.print = {};

  ----------------------------------------------------------------------------------

  private.COLLECT_ANIM_TIME = 0.8;
  private.COLLECT_VISIBLE_TIME = 3.0;  

end;
--*********************************************************************************************************************
--***function *** CURSOR *** () end************************************************************************************
--*********************************************************************************************************************
  function private.LoadStandardCursors()

    --[[
    case 0:  pWinCursor = NULL; break;
    case 1:  pWinCursor = IDC_APPSTARTING; break;
    case 2:  pWinCursor = IDC_ARROW; break;
    case 3:  pWinCursor = IDC_CROSS; break;
    case 4:  pWinCursor = IDC_HAND; break;
    case 5:  pWinCursor = IDC_HELP; break;
    case 6:  pWinCursor = IDC_IBEAM; break;
    case 7:  pWinCursor = IDC_ICON; break;
    case 8:  pWinCursor = IDC_NO; break;
    case 9:  pWinCursor = IDC_SIZE; break;
    case 10: pWinCursor = IDC_SIZEALL; break;
    case 11: pWinCursor = IDC_SIZENESW; break;
    case 12: pWinCursor = IDC_SIZENS; break;
    case 13: pWinCursor = IDC_SIZEWE; break;
    case 14: pWinCursor = IDC_UPARROW; break;
    case 15: pWinCursor = IDC_WAIT; break;
    ]]

    common.CursorLoad( "CURSOR_NULL",    "",                            0  );
    common.CursorLoad( "CURSOR_DEFAULT", "assets/cursors/cursor",       2  );
    common.CursorLoad( "CURSOR_LOUPE",   "assets/cursors/cursor_loupe", 10 );
    common.CursorLoad( "CURSOR_GET",     "assets/cursors/cursor_get",   4  );
    common.CursorLoad( "CURSOR_HAND",    "assets/cursors/cursor_hand",  4  );
    common.CursorLoad( "CURSOR_USE",     "assets/cursors/cursor_use",   4  );
    common.CursorLoad( "CURSOR_DOWN",    "assets/cursors/cursor_down",  10 );
    common.CursorLoad( "CURSOR_UP",      "assets/cursors/cursor_up",    10 );
    common.CursorLoad( "CURSOR_LEFT",    "assets/cursors/cursor_left",  10 );
    common.CursorLoad( "CURSOR_RIGHT",   "assets/cursors/cursor_right", 10 );
    common.CursorLoad( "CURSOR_FINGER",  "assets/cursors/cursor_finger",10 );
    common.CursorLoad( "CURSOR_DIALOG",  "assets/cursors/cursor_dialog",10 );

  end;

  function public.IsSubscribersIncluded ()

    return public.subscribers_included;

  end;
--*********************************************************************************************************************
--***function *** HINT *** () end************************************************************************************
--*********************************************************************************************************************
  function private.CreateSinglePartySys( target_name, obj_name )

    local hint_name  = "anm_hint_"..target_name;
    local obj_hint_name  = obj_name or "obj_hint_"..target_name;
    local index_anim_array = {};
    index_anim_array["x"] = {};
    index_anim_array["y"] = {};

    if ObjGet( hint_name ) then

      public.DeleteHintFx()

    end;

    ObjCreate( hint_name, "anim" );

    ObjSet( hint_name,
    {
      res = public.hint.res;
      pos_x = 0, pos_y = 0, alp = 1
    } );
    if not( public.hint.target[1] == 0 ) then

      public.hint.target[1] = obj_hint_name;

    else

      public.hint.target[2] = obj_hint_name;

    end;

    ObjAttach( hint_name, obj_hint_name );
    AnimPlay( hint_name, "DoAnim", function() ObjDelete( hint_name ); end );

  end;
  --*********************************************************************************************************************
  function private.GetCircleCoord( number, radius, ang_shift )

    local ang = 360 / number;
    local R  = radius or 70;
    local ang_num = ang_shift or 0;
    local pos = {};

    for i=1,number,1 do

      local cur_ang = math.rad(ang * ( i + ang_num ));   

      pos[ i ] = {}
      pos[ i ][ "x" ] = math.cos( cur_ang ) * R ;--math.ceil(
      pos[ i ][ "y" ] = math.sin( cur_ang ) * R ;

    end;

    return pos;

  end;
  --*********************************************************************************************************************
  function private.CreateHintObj( target_name, room )

    local obj_hint_name  = "obj_hint_"..target_name;
    local pos = GetObjPosByObj(target_name, room);
    local hint_pos_beg = {};
    local hint_pos_end = {}; 
    local partsys_R = public.hint.big_R;
    local tme = public.hint.time_fly;
    local timer_name = "tmr_"..target_name;

    if common.GetObjectPrefix( room ) == "zz" and target_name ~= "obj_int_frame_subroom_button" then

      partsys_R = public.hint.big_R_zz;
      tme = public.hint.time_fly_zz;

    elseif room == "obj_int_button_providence" then

      interface.InventoryOpen();

    end;

    hint_pos_beg = private.GetCircleCoord( public.hint.partsys_count, partsys_R, -1 );

    hint_pos_end = private.GetCircleCoord( public.hint.partsys_count, public.hint.small_R );

    public.show_hint[ room ] = target_name;

    ObjCreate( obj_hint_name, "obj" );

    ObjSet( obj_hint_name,
    {
      pos_x = pos[1], pos_y = pos[2], pos_z = 1000,
      active = 1, visible = 1, input = false, alp = 0
    } );

  --  for i=1,public.hint.partsys_count,1 do
  --
      private.CreateSinglePartySys( target_name, obj_hint_name );
  --
  --  end;

    if target_name == "obj_int_frame_subroom_button" then

      ObjSet( obj_hint_name,
      {
       pos_x = 0, pos_y = 0
      } );

      ObjAttach( obj_hint_name, target_name );

    elseif ( target_name == "right" or target_name == "left" ) then

      ObjAttach( obj_hint_name, "spr_focus_arrow_"..target_name );

    elseif ( string.find( target_name, "deploy_inv" ) ) then

      ObjSet( obj_hint_name,
      { 
        pos_x = GetObjPosByObj( room, "int_deploy_inv" )[ 1 ], pos_y = GetObjPosByObj( room, "int_deploy_inv" )[ 2 ]
      } );

      ObjAttach( obj_hint_name, "int_deploy_inv" );

    else

      ObjAttach( obj_hint_name, room );

    end;

    local alp_tme = tme + public.hint.time_circle*public.hint.circle_cnt;

    ObjAnimate(obj_hint_name, "alp",0,0, function() common_impl.HintShowAnimEnd( target_name, room ); end, 
      {
      0.0,0,0, 
      public.hint.tme_show,0,1,
      alp_tme,0,1,
      (alp_tme + public.hint.tme_hide),0,0
      });

  end;
  --*********************************************************************************************************************
  function public.DeleteHintFx()

    for i = 1,#public.hint.target do

      ObjDelete( public.hint.target[i] );

      if ( common.GetObjectPrefix( GetCurrentRoom() ) == "ho" ) and ( GetCurrentRoom() ~= currentroom ) then

        local target = string.sub( public.hint.target[i], 24,string.len( public.hint.target[i] ));
        interface.effects.ho_hint[target] = nil;

      else

        local target = string.sub( public.hint.target[i], 10,string.len( public.hint.target[i] ));
        public.show_hint[ target ] = nil;

        if string.find( public.hint.target[i], "inv_" ) then
          ObjDelete( "tmr_inv_"..target );
        else
          ObjDelete( "tmr_"..target );
        end;

      end;

    end;  

    public.hint.target = {}
    
  end;
  --*********************************************************************************************************************
  function private.CreateInvHintPartSys( target_name, room )

    local obj_hint_name  = "obj_hint_"..target_name;
    local hint_name  = "anm_hint_"..target_name;
    local timer_inv_name = "tmr_inv_"..target_name;

    interface.InventoryOpen();

    if ObjGet( hint_name ) then

      public.DeleteHintFx()

    end;
    if not( public.hint.target[1] == 0 ) then

      public.hint.target[1] = obj_hint_name;

    else

      public.hint.target[2] = obj_hint_name;

    end;

    interface.InventoryShowObject( target_name );

    ObjCreate( obj_hint_name, "obj" );

    ObjSet( obj_hint_name,
    {
      pos_x = 0, pos_y = 0
    } );

    ObjAttach( obj_hint_name, target_name );

    ObjCreate( hint_name, "anim" );

    ObjSet( hint_name,
    {
      animfunc = "DoAnim",
      playing = true,
      res = public.hint.res_inv,
      pos_x = 0, pos_y = 0
    } );

    ObjAttach( hint_name, obj_hint_name );

    ObjCreate( timer_inv_name, "timer" );
    ObjAttach( timer_inv_name, InterfaceWidget_Top_Name );


    ObjAnimate( obj_hint_name, "alp",0 ,0 , "", { 0,0,1,  2.5,0,1,  2.8,0,0 }  );

    ObjSet( timer_inv_name, 
    {
      endtrig = "common_impl.HintHideInventoryEnd( '"..target_name.."');common_impl.HintShowAnimEnd( '"..target_name.."','"..room.."');",
      time    = 2.8,
      playing = 1
    } ); 

  end;
  --*********************************************************************************************************************
  function private.HintShowAnim( target_name, deploy, prg_name )

    local room = common.GetCurrentRoom();

    if deploy then

      room = target_name;

    elseif ObjGet(room).input == false and common.GetCurrentSubRoom() and ObjGet(common.GetCurrentSubRoom()).input == true then

      if prg_name and public.hint[ prg_name ].room ~= common.GetCurrentRoom() then

        room = public.hint[ prg_name ].room;

      else

        room = common.GetCurrentSubRoom();

      end;

    elseif prg_name then

      room = public.hint[ prg_name ].room;

    end;
    --DbgTrace( room );
    --common.LogTrace( common.logtrace_message, "[ H ] Hint object < "..target_name.." >." );

    if ( not public.show_hint[ target_name ] ) then

      if ObjGet( target_name ).name then 

        public.show_hint[ target_name ] = 1;

        if string.match(target_name, "^in._") then

          private.CreateInvHintPartSys( target_name, room );

          if not prg_name then
            common_impl.PlayAudio( "sfx", "aud_hint_sfx", 0, "", 0 );
          end;


        else

          private.CreateHintObj( target_name, room );
          common_impl.PlayAudio( "sfx", "aud_hint_sfx", 0, "", 0 );

        end;

      end;

    else

      --common.LogTrace( ld.logtrace_message, "[ H ] No object < "..target_name.." >!" );    

    end;

  end;
  --*********************************************************************************************************************
  function public.HintShowAnimEnd( target_name, room )

    local obj_hint_name  = "obj_hint_"..target_name;

    ObjDelete( obj_hint_name );

    public.show_hint[ target_name ] = nil;
    public.show_hint[ room ] = nil;

  end;
  --*********************************************************************************************************************
  function public.HintHideInventoryEnd( target_name )

    local inv_timer_name = "tmr_inv_"..target_name;

    ObjDelete( inv_timer_name );

    if string.find(target_name, "inv") and public.save_autohide == 1 and ng_global.progress[ ng_global.currentprogress ].common.buttonlock ~= 1 then

      --interface.InventoryAutoHideSet( true );
      public.save_autohide = 0;
      
    end;

    public.hint.play_sfx=true;

  end;
  --*********************************************************************************************************************
  function private.CheckHintType(prg_name, deploy)

    if public.hint[ prg_name ].type == "use" then

      -- показать инвентарь
      if interface.InventoryAutoHideGet() == 1 and not( string.find(prg_name, "isis") ) then

      public.save_autohide = 1;
      interface.InventoryAutoHideSet( false );

      else
      
      public.save_autohide = 0;

      end;

      public.hint.play_sfx = false;  
      private.HintShowAnim(public.hint[ prg_name ].inv_obj, deploy, prg_name );
      private.HintShowAnim(public.hint[ prg_name ].use_place, deploy, prg_name);

    elseif public.hint[ prg_name ].type == "get" then
      -- показать на подбираемый предмет

      private.HintShowAnim(public.hint[ prg_name ].get_obj, deploy);

    elseif public.hint[ prg_name ].type == "click" then

      --показать на место клика
      private.HintShowAnim(public.hint[ prg_name ].use_place, deploy, prg_name);
      if ( public.hint[ prg_name ].inv_obj ) then
        private.HintShowAnim(public.hint[ prg_name ].inv_obj, deploy, prg_name);
      end;

    elseif public.hint[ prg_name ].type == "win" then

    -- показать на место клика

      private.HintShowAnim(public.hint[ prg_name ].use_place, deploy);

    end; 

    int_button_hint_impl.StartAnimReloadBegin();
    interface.ButtonHintReload( 1 );



  end;
  --*********************************************************************************************************************
  function private.CheckRoomState(prg_name, currentroom)

    if ObjGet(currentroom).input == false and public.hint[ prg_name ].zz == common.GetCurrentSubRoom() then
      --DbgTrace("show_action_subroom");
      private.CheckHintType(prg_name);

    elseif ObjGet(currentroom).input == false and public.hint[ prg_name ].zz ~= common.GetCurrentSubRoom() then

      --DbgTrace("show_close_subroom");                    
      private.HintShowAnim("obj_int_frame_subroom_button");                          

    elseif public.hint[ prg_name ].zz == "int_button_providence" then

      private.HintShowAnim(public.hint[ prg_name ].zz_gate );  

    elseif public.hint[ prg_name ].zz == "int_button_providence" then

      private.CheckHintType(prg_name);

    else

      local new_place = private.CheckPositionZzHint( public.hint[ prg_name ].zz_gate )

      private.HintShowAnim( new_place );

    end;

  end;
  --*********************************************************************************************************************
  function private.CheckPositionZzHint( place )

    local position = place;
    local need_hint = true;
    local pos = "";
    local room = GetCurrentRoom();

    if public.hint.position_zz[ place ] ~= nil then

      for i = 1, #public.hint.position_zz[ place ] do

        if public.hint.position_zz[ place ][ i ] == int_slider.current_pos then

          return position;
      
        end;

      end;

      for i=1,#public.hint.position_zz[ place ] do
      
        pos = pos..public.hint.position_zz[ place ][ i ];

      end;

      if ( string.find( pos, "left" ) ) then

        position = "left";

      elseif pos == "mid" then

        if int_slider.current_pos == "left" then

          position = "right";

        elseif int_slider.current_pos == "right" then

          position = "left";

        end;

      elseif ( string.find( pos, "right" ) ) then

        position = "right";

      end;

      return "spr_focus_arrow_"..position;
      
    end;

    return position;

  end;

--*********************************************************************************************************************
function private.CheckPositionSliderHint( prg_name )

  if not common.IsInSubRoom() then

    local pos = common.GetObjectName( public.hint[ prg_name ].zz );

    if ( string.find( pos, int_slider.current_pos ) ) then
      return false;
    end;

    if ( string.find( pos, "left" ) ) then

      position = "left";

    elseif pos == "mid" then

      if int_slider.current_pos == "left" then

        position = "right";

      elseif int_slider.current_pos == "right" then

        position = "left";


      end;

    elseif ( string.find( pos, "right" ) ) then

      position = "right";

    end;

    private.HintShowAnim( "spr_focus_arrow_"..position );
    
    return true;

  end;

end;
  --*********************************************************************************************************************
  function common.HintAdditionalFunc( room_current )

    if public.show_hint[ room_current ] then

      local hint_name  = "pfx_hint_"..public.show_hint[ room_current ];

      ObjDelete( hint_name );

      public.show_hint[ public.show_hint[ room_current ] ] = nil;
      public.show_hint[ room_current ] = nil;

    end;

    if interface.effects.ho_hint[room_current] then

      for key, value in pairs( interface.effects.ho_hint ) do

      local obj_hint_name  = "obj_int_effects_ho_hint_"..key;

      ObjDelete( obj_hint_name );
      interface.effects.ho_hint[ key ] = nil;
      interface.effects.ho_hint[room_current] = nil;

      end;

    end;

  end;
--*********************************************************************************************************************
--***function *** DIALOG *** () end************************************************************************************
--*********************************************************************************************************************
  function public.DialogButtonMouseDown( dialog_name, dialog_button, param )

    DbgTrace( "[ EXAMPLE ] Проигран звук клика для диалога < "..dialog_name.." > по кнопке < "..dialog_button.." >." );

    common_impl.PlayAudio( "sfx", "aud_click_menu", 0, "", 0 );

  end;
  --------------------------------------------------------------------
  function public.DialogButtonMouseEnter( but_name )
    
    SetCursor( CURSOR_HAND );

    local focus_name = "spr_"..but_name.."_focus";
    local focus_alp = ObjGet( focus_name ).alp;

    ObjAnimate( focus_name, "alp", 0, 0, "", 
    { 

      0, 0, focus_alp, 
      ( public.animtime * ( 1 - focus_alp ) ), 0, 1 
    
    });

  end;
  --------------------------------------------------------------------
  function public.DialogButtonMouseLeave( but_name )

    SetCursor( CURSOR_DEFAULT );

    local focus_name = "spr_"..but_name.."_focus";
    local focus_alp = ObjGet( focus_name ).alp;

    ObjAnimate( focus_name, "alp", 0, 0, "", 
    {

     0, 0, focus_alp, 
     ( public.animtime * focus_alp ), 0, 0 

    } );


  end;
  --------------------------------------------------------------------
  function public.DialogCheckMouseEnter( sender_name )

    local txt_name   = "txt_dialog_"..sender_name;
    local spr_name   = "spr_dialog_"..sender_name.."_active";
    local light_name = "spr_dialog_"..sender_name.."_portrait_glow";

    ObjSet( txt_name,   { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );
    ObjSet( spr_name,   { active = true, visible = true } );
    ObjSet( light_name, { active = true, visible = true } );

    SetCursor( CURSOR_HAND );   
   
    local but_name = "spr_dialog_"..sender_name.."_check_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * ( 1 - but_alp ) ), 0, 1 } );

  end;
  --------------------------------------------------------------------
  function public.DialogCheckMouseLeave( sender_name )

    local txt_name   = "txt_dialog_"..sender_name;
    local spr_name   = "spr_dialog_"..sender_name.."_active";
    local light_name = "spr_dialog_"..sender_name.."_portrait_glow";
      
    ObjSet( txt_name,   { fontcolor_r = 0.8945, fontcolor_g = 0.875, fontcolor_b = 0.6328 } );
    ObjSet( spr_name,   { active = false, visible = false } );
    ObjSet( light_name, { active = false, visible = false } );

    SetCursor( CURSOR_DEFAULT );

    local but_name = "spr_dialog_"..sender_name.."_check_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * but_alp ), 0, 0 } );

  end;
  --------------------------------------------------------------------
  function public.DialogScrollMouseEnter( sender_name, scroll_name )
    
    SetCursor( CURSOR_HAND );    
    local but_name = "spr_dialog_"..sender_name.."_"..scroll_name.."_scroll_slider_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * ( 1 - but_alp ) ), 0, 1 } );
    
    local txt_name  = "txt_dialog_"..sender_name.."_"..scroll_name.."_percent";
    local txt_name2 = "txt_dialog_"..sender_name.."_"..scroll_name.."_header";
    local txt_name3 = "txt_dialog_"..sender_name.."_"..scroll_name;
    ObjSet( txt_name, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );
    ObjSet( txt_name2, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );
    ObjSet( txt_name3, { fontcolor_r = 1, fontcolor_g = 1, fontcolor_b = 1 } );

  end;
  --------------------------------------------------------------------

  function public.DialogScrollMouseLeave( sender_name, scroll_name )

    SetCursor( CURSOR_DEFAULT );
    local but_name = "spr_dialog_"..sender_name.."_"..scroll_name.."_scroll_slider_focus";
    local but_alp = ObjGet( but_name ).alp;
    ObjAnimate( but_name, "alp", 0, 0, "", { 0, 0, but_alp, ( public.animtime * but_alp ), 0, 0 } );
    
    local txt_name = "txt_dialog_"..sender_name.."_"..scroll_name.."_percent";
    local txt_name2 = "txt_dialog_"..sender_name.."_"..scroll_name.."_header";
    local txt_name3 = "txt_dialog_"..sender_name.."_"..scroll_name;
    ObjSet( txt_name,  { fontcolor_r = 0.8945, fontcolor_g = 0.875, fontcolor_b = 0.6328 } );
    ObjSet( txt_name2, { fontcolor_r = 0.8945, fontcolor_g = 0.875, fontcolor_b = 0.6328 } );
    ObjSet( txt_name3, { fontcolor_r = 0.8945, fontcolor_g = 0.875, fontcolor_b = 0.6328 } );

  end;
  ----------------------------------------------------------------------------
  function public.DialogProfileMouseEnter(number)

    SetCursor( CURSOR_HAND );

    local obj = "spr_dialog_profile_names_"..number.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = ( 1 - alp ) * public.animtime;

    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 2, alp,
      tme, 2, 1
    } );

  end;
  ---------------------------------------------------------------------------------
  function public.DialogProfileMouseLeave(number)

    SetCursor( CURSOR_DEFAULT );

    local obj = "spr_dialog_profile_names_"..number.."_focus";
    local alp = ObjGet( obj ).alp;
    local tme = alp * public.animtime;
    
    ObjAnimate( obj, "alp", 0, 0, "",
    {
      0.0, 1, alp,
      tme, 1, 0
    } );
    
  end;
--*********************************************************************************************************************
--***function *** PROFILE *** () end***********************************************************************************
--*********************************************************************************************************************
  function public.ProgressReset( prg, save )

    if ( prg == "std" ) then

      ng_global.progress[ prg ].common.chapter = "level1";
      ng_global.progress[ prg ].common.diary = {};
      ng_global.progress[ prg ].common.diary.pages = 
      {
        0, 0, 0, 0,
      };
      ng_global.progress[ prg ].common.diary.last_page = 0;
      ng_global.progress[ prg ].common.diary.current = 1;
      ng_global.progress[ prg ].common.diary.bookmarks = {};
      ng_global.progress[ prg ].common.diary.last_bookmark = 0;
      ng_global.progress[ prg ].common.diary.last_location = 0; --  events = 0, participants = 1

    elseif( prg == "ext" ) then

      ng_global.progress[ prg ].common.chapter = "levelext";
    
    elseif( prg == "scr" ) then

      ng_global.progress[ prg ].common.chapter = "levelscr";

    end;

    ng_global.investigation = 1;

  end;
  --*********************************************************************************************************************
  function public.ProfileInit()

    private.AchievementsInit();
    private.Collectibles2Init();
    private.MorphInit();

  end;
--*********************************************************************************************************************
--***function *** ROOM - SUBROOM *** () end****************************************************************************
--*********************************************************************************************************************
  function public.GotoRoom( room_object, need_fade, dontsave )

    public.DeleteHintFx()
    ObjSet( "obj_int_slider_root", { input = false } );
    ObjSet( "obj_int_slider", { input = false } );

  end;
  --------------------------------------------------------------------
  function public.GotoSubRoom( zz_object, pos_beg, pos_end )

    local room_current = GetCurrentRoom();

    public.DeleteHintFx()
    ObjDelete( "obj_hint_obj_int_frame_subroom_button" );
    public.show_hint[ "obj_int_frame_subroom_button" ] = nil;

    if ( "zz" == common.GetObjectPrefix( room_current ) ) then
      
      common.previouszz = room_current;

    end;

    common.currentzz = zz_object;

    interface.CheaterUpdateSubroom( zz_object );

    local zz_params = ObjGet( zz_object );

    pos_beg = pos_beg or GetZoomCursorPos();

    pos_end = pos_end or { zz_params.pos_x, zz_params.pos_y };

    subroom.Open( zz_object, { x = pos_beg[ 1 ], y = pos_beg[ 2 ] }, { x = pos_end[ 1 ], y = pos_end[ 2 ] } );

  end;
--*********************************************************************************************************************
--***function *** SETTINGS *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.UpdateGameMode( gamemode )

    if game then

      if game.room_names then
      
        for i = 1, #game.room_names do
            cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( game.room_names[i] ) );

        end;

      end;

    end;
    ------------------------------------------------------------------------------------
    local visible = true;
  local res = "assets/levels/common/common_res/backlight";
    if ( ( ng_global.gamemode == 3 ) and ( not ng_global.gamemode_custom[ "plus_inv" ] ) ) then
      visible = false;
    res = "";
    end;  
    local parent = ng_global.progress[ ng_global.currentprogress ].common.chapter.."_inv_deploy";
    if ( not ObjGet( parent ) ) then
      return;
    end;
    local relations = ObjGetRelations( parent );
    local table_multiset = {};

    for i = 1, #relations.childs do

      local obj = "spr_"..common.GetObjectName( common.GetObjectName( relations.childs[ i ] ) ).."_plus";      
      table.insert( table_multiset, { obj, { visible = visible } } );
      table.insert( table_multiset, { obj.."_light", { visible = visible } } );

    end;
    ObjMultiSet( table_multiset );

  end;
  --------------------------------------------------------------------
  function public.SaveInterfaceTimers()

  end;
  --------------------------------------------------------------------
  function public.UpdatePerformanceMode ()

    if game then

      if game.room_names then

        for i = 1, #game.room_names do

          if ( common.GetObjectPrefix( game.room_names[i] ) == "rm" ) then

            cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( game.room_names[i] ) );

          end;

        end;

      end;

    end; 

  end;
--*********************************************************************************************************************
--***function *** MINIGAME *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.MiniGameShow( minigame_name, skip_multiplier )

    common_impl.PlayAudio( "sfx", "aud_opn_mg", 0, "", 0 );

    if ( skip_multiplier ) then

      if ( common.GetGamemode() == 0 ) then

        skip_multiplier = 3.333333;

      elseif ( common.GetGamemode() > 0 ) then

        skip_multiplier = 3.5;

      end;

    end;

    minigame_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    local result = false;

    private.current_mg_name = minigame_name;
    local event_name = "win_"..minigame_name;
    
    if port.isPortable() == 1 then
      port.LogEvent(event_name, "open");
    end;
    
    if ( not cmn.IsEventStart( event_name ) ) then

      cmn.SetEventStart( event_name );
      private.SetSkipTimer( minigame_name, 1 );

      result = true;

    end;

    interface.ButtonHintHide();

    interface.ButtonInfoShow();
    interface.ButtonResetShow();
    interface.ButtonSkipShow();

    interface.ButtonSkipReload( private.GetSkipTimer( minigame_name ), skip_multiplier or 1 );

    return result;

  end;
  -------------------------------------------------------------------------------------
  function public.MiniGameHide( minigame_name )

    minigame_name = minigame_name or common.GetObjectName( GetCurrentRoom() );

    private.current_mg_name = nil;

    local result = false;

    local event_name = "win_"..minigame_name;

    if  (     cmn.IsEventStart( event_name ) )
    and ( not cmn.IsEventDone( event_name )  )
    then

      private.SetSkipTimer( minigame_name, interface.ButtonSkipGetTime() );
      --DbgTrace( "save skip for < "..prg_name.." > =  "..current_progress[ prg_name ].skiptimer );

      interface.ButtonInfoHide();
      interface.ButtonResetHide();
      interface.ButtonSkipHide();

      interface.ButtonHintShow();

      result = true;

    end;

    return result;

  end;
  --------------------------------------------------------------------------------------
  function private.GetSkipTimer( minigame_name )

    local prg = prg.current;
    local event_name = "win_"..minigame_name;
    return ng_global.progress[ prg ][ event_name ].skiptimer;

  end;
  --------------------------------------------------------------------------------------
  function private.SetSkipTimer( minigame_name, time_relative )

    local prg = prg.current;
    local event_name = "win_"..minigame_name;
    ng_global.progress[ prg ][ event_name ].skiptimer = time_relative;

  end;
--*********************************************************************************************************************
--***function *** HO *** () end****************************************************************************************
--*********************************************************************************************************************
  function public.ProcessHoStart( ho_name )

    local ho_found = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;

    for i = 1, #ho_found, 1 do

      if ( ho_found[ i ][ "task" ] ) then

        ObjDelete( ho_found[ i ][ "object" ] );

      end;

      if ( ho_found[ i ][ "item" ] ) then

        ObjDelete( ho_found[ i ][ "item" ] );

      end;

    end;

  end;
  -----------------------------------------------------------------------------------
  function public.HoItemFind( sender )

    local ho_name          = common.GetObjectName( GetCurrentRoom() );
    local item_name        = sender;
    local item_object_name = "obj_"..common.GetObjectName( item_name );

    if ( ApplyObj( item_name, item_object_name ) ) then

      ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 1;

      local item_found = { item = item_name, object = item_object_name };

      table.insert( ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found, item_found );

      interface.ItemPanelItemRemove( item_name );
      ObjSet( item_object_name, { input = false } );

      _G[ "ho_"..ho_name ].ItemFound( item_name );
      public.PassingHoCheck();

    end;

  end;
  -----------------------------------------------------------------------------------
  function public.HoTaskFind( sender, task, no_anim )

    local ho_name          = common.GetObjectName( GetCurrentRoom() );
    local task_name        = task;
    local task_object_name = sender;

    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].start = 1;

    local task_found = { task = task_name, object = task_object_name };

    table.insert( ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found, task_found );

    interface.TaskPanelTaskComplete( ho_name, task_name, task_object_name, no_anim );
    public.PassingHoCheck();

  end;
  --------------------------------------------------------------------
  function public.SetMarkedTask( ho_name, task )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;

    ng_global.progress[ prg ][ event_win_ho ].unmark[ task ] = {};
    ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done = 0;

  end
  --------------------------------------------------------------------------------------
  function public.UnmarkTask( ho_name, task )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;

    ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done = 1;
    ng_global.progress[ prg ][ event_win_ho ].start = 1;

    interface.TaskPanelTaskUnmark( ho_name, task );

  end
  --------------------------------------------------------------------------------------
  function public.IsUnmarkedTask( ho_name, task )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;

    if ( ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done == 1 ) then

      return true;

    else

      return false;

    end;

  end
  --------------------------------------------------------------------------------------
  function public.InitHo( ho_name )

    local prg = prg.current;

    local event_win_ho = "win_"..ho_name;
    
      if port.isPortable() == 1 then
        port.LogEvent("win_"..ho_name, "open");
      end;
      
    ng_global.progress[ prg ][ event_win_ho ].start = 1;
    ng_global.progress[ prg ][ event_win_ho ].unmark = {};
    ng_global.progress[ prg ][ event_win_ho ].found = {};

  end
--*********************************************************************************************************************
--***function *** DEPLOY INV *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.ShowDeployInv( inv_obj ) 
    
    if ( interface.GetCurrentInv() == "" ) then

      common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );
      public.DeleteHintFx();
      common.CallRoomEventHandlers( inv_obj );
      interface.DeployInvShow( inv_obj );
      common.CloseSubRoom();

    else

      public.HideDeployInv();

    end;

  end
  --****************************************************************************************************************
  function public.HideDeployInv( ) 
    
    local inv_name = interface.GetCurrentInv();
    if ( inv_name ~= "" ) then

      local mg_name = string.sub( inv_name, 12, string.len( inv_name ) );

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ] ) then

        public.MiniGameHide( mg_name );

      end;

    end;

    interface.DeployInvHide();

  end;
  --****************************************************************************************************************
  function public.SetInvPlusRGB ( deploy_inv, bool )


    if ( bool ) then

      ObjSet( "spr_"..deploy_inv.."_plus", { color_r = 1, color_b = 1, color_g = 1 } );
      ObjSet( "spr_"..deploy_inv.."_plus_light", { color_r = 1, color_b = 1, color_g = 1 } );

    else

      ObjSet( "spr_"..deploy_inv.."_plus", { color_r = 0.5, color_b = 0.5, color_g = 0.5 } );
      ObjSet( "spr_"..deploy_inv.."_plus_light", { color_r = 0.5, color_b = 0.5, color_g = 0.5 } );  

    end;

  end;
--*********************************************************************************************************************
--***function *** MAP *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.VisitMapRoom( room_name )

    int_map_impl.VisitMapRoom( room_name );

  end;
  --*********************************************************************************************************************
  function public.LockMapRoom( room_name, lock )

    int_map_impl.LockMapRoom( room_name, lock );

  end;
  --*********************************************************************************************************************
  function private.ActiveTaskRoom( room_name, active )

    int_map_impl.ActiveTaskRoom( room_name, active );

  end;
  --*********************************************************************************************************************
  function private.MapSetTask()

    local prg = ng_global.currentprogress;

    local active_task_rooms = {};

    for i = 1, #game.progress_names_room do 

      local main_task = game.progress_names_room[ i ][ 1 ];  
      if ( ( common_impl.hint[ main_task ] )and( #game.progress_names_room[ i ] > 2 ) ) then 

        local name_room = game.progress_names_room[ i ][ 2 ];
        if ( not active_task_rooms[ name_room ] ) then

          active_task_rooms[ name_room ] = 0;

        end;

        if ( ( ng_global.gamemode < 3 ) or ( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "tasks" ] ) ) then
          
          if ( not cmn.IsEventDone( main_task ) ) then 

            local done_sub_event = true; 
            for j = 1, #game.progress_names_room[ i ][ 3 ] do 

              if ( not cmn.IsEventDone( game.progress_names_room[ i ][ 3 ][ j ] ) ) then 

                done_sub_event = false;
                break;

              end;

            end;                            
            if ( done_sub_event ) then 

              --DbgTrace( "map task = "..main_task );
              active_task_rooms[ name_room ] = active_task_rooms[ name_room ] + 1;                  

            end;

          end;

        end;

      end;

    end;
    
    for room, value in pairs( active_task_rooms ) do

      if ( active_task_rooms[ room ] > 0 ) then 
        private.ActiveTaskRoom( common.GetObjectName( room ), true );
      else
        private.ActiveTaskRoom( common.GetObjectName( room ), false );
      end;

    end;
    
  end;
--*********************************************************************************************************************
--***function *** SET CURSOR *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.SetCursor( cursor_name )

    if ( not ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "cursor" ] ) ) then
      SetCursor( cursor_name );
    end;

  end
--*********************************************************************************************************************
--***function *** PROGRESS *** () end**********************************************************************************
--*********************************************************************************************************************
  function public.SetEventDone( event_name )

    ng_global.progress[ prg.current ][ event_name ].done = 1;

  end;
  --------------------------------------------------------------------------------------
  function public.IsEventDone( event_name )

    return ng_global.progress[ prg.current ][ event_name ].done == 1;

  end;
  --------------------------------------------------------------------------------------
  function public.SetEventStart( event_name )

    ng_global.progress[ prg.current ][ event_name ].start = 1;

  end;
  --------------------------------------------------------------------------------------
  function public.IsEventStart( event_name )

    return ng_global.progress[ prg.current ][ event_name ].start > 0;

  end;
--*********************************************************************************************************************
--***function *** EVENTS *** () end************************************************************************************
--*********************************************************************************************************************
  function public.CheaterKeyPress( keycode )

  end;  
  --------------------------------------------------------------------------------------
  function public.Application_Closing()

    if ( IsSurveyEdition() and private.is_openbrowser_enabled ) then

      local url = GetUrl();
      OpenBrowser( url );

    end;

  end; 
  --------------------------------------------------------------------------------------
  function public.PanelNotification_Click( notification_type )

    DbgTrace( "Notification Panel Clicked. Notification type: "..notification_type );

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonGuide_Click()

    private.StopDialogTimer();

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonHint_Click( hint_state )

    local type = ng_global.currentprogress;
    
    if ( ( ng_global.gamemode < 2 ) or ( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "hint" ] ) ) then

      if ( hint_state ) then

        local currentroom = GetCurrentRoom();
        
        if  ( common.GetObjectPrefix( currentroom ) == "ho") and ( ng_global.progress[ type ][ "win_"..common.GetObjectName( currentroom ) ].use_object == nil )  then

          if ( GetCurrentRoom() == currentroom ) then

            common_impl.PlayAudio( "sfx", "aud_hint_sfx", 0, "", 0 );
            interface.TaskPanelHoHintShow();
            interface.ItemPanelHoHintShow();

          end;

          int_button_hint_impl.StartAnimReloadBegin();
          interface.ButtonHintReload( 1 );          

        else

            for i = 1, #game.progress_names, 1 do

              local prg_name = game.progress_names[ i ];

              if  ( not cmn.IsEventDone( prg_name ) ) and ( public.hint[ prg_name ] ) then

                --реализация хинта для локации, отличная от стандартной
                common.LogTrace( common.LogTrace_message, "[ H ] Hint show for < "..prg_name.." >. " );

                 if common.GetCurrentRoom() == public.hint[ prg_name ].room or common.GetCurrentRoom() == public.hint[ prg_name ].zz then
                      
                  if public.hint[ prg_name ].zz and string.find( public.hint[ prg_name ].zz, "slider" ) and private.CheckPositionSliderHint( prg_name ) then

                    -->EE
                    -- значит это смещенная АЗ

                  elseif public.hint[ prg_name ].zz and not string.find( public.hint[ prg_name ].zz, "slider" ) then

                    private.CheckRoomState(prg_name, currentroom)

                    else
                        
                        if currentroom == public.hint[ prg_name ].room and ObjGet( currentroom ).input == true then

                          --DbgTrace("show_action_rm");
                          private.CheckHintType(prg_name); 

                        elseif currentroom == public.hint[ prg_name ].room and ObjGet( currentroom ).input == true then

                          private.HintShowAnim( "obj_int_button_providence" );

                        else

                          --DbgTrace("show_close_subroom");                    
                          private.HintShowAnim( "obj_int_frame_subroom_button" );

                        end;
                
                    end;

                    interface.DeployInvHide();

                   ---------------для активных инв предметов
                elseif public.hint[ prg_name ].room == "int_deploy_inv" then                

                    --DbgTrace( "name = "..tostring(int_deploy_inv.GetCurrentName()) )

                    if public.hint[ prg_name ].zz == int_deploy_inv.GetCurrentName() then

                        if ( not int_deploy_inv.IsOnScreen() ) then

                           int_inventory_impl.ShowAnim("show")
                           interface.InventoryItemAdd( public.hint[ prg_name ].zz_gate,"" );
                           private.HintShowAnim( public.hint[ prg_name ].zz_gate );  
       
                        else 
                           
                           private.CheckHintType(prg_name, true);                            

                        end;

                    else 

                      interface.DeployInvHide();
                      int_inventory_impl.ShowAnim("show")
                      interface.InventoryItemAdd( public.hint[ prg_name ].zz_gate,"" );
                      private.HintShowAnim( public.hint[ prg_name ].zz_gate ); 
          
                    end;

                   ---------------для дедукции
                elseif public.hint[ prg_name ].room == "int_investigation_button" then  

                      private.HintShowAnim( public.hint[ prg_name ].use_place, false, prg_name ); 

                else

                    if ( not public.show_hint.dialog ) then 

                      public.show_hint.dialog = prg_name;
                      --показать диалог со ссылкой
                      interface.DeployInvHide();
                      common.CloseSubRoom();

                      interface.DialogHintShow( public.hint[ prg_name ].room );
                      common_impl.PlayAudio( "sfx", "aud_clk_teleport", 0, "", 0 );

                    end;

                end;

                break;

             end;

           end;

        end;

      else
        
        interface.DialogShow( "hnt_not_ready", 512, 384 );
        --public.PlayAudio( "sfx", "common/audio/aud_hint_txt_sfx", 0 );

      end;

    elseif ( ng_global.gamemode == 2 ) then

      interface.DialogShow( "hnt_hardcore", 512, 384 );

    else 
    
      interface.DialogShow( "hnt_custommode", 512, 384 );

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonInfo_Click( mg_name )

    local mg_name = private.current_mg_name or mg_name;
    local postfix = "";

    if ( not mg_name ) and common.GetCurrentSubRoom() and common.GetObjectPrefix( mg_name ) ~= "mg" then

      mg_name = common.GetObjectName( common.GetCurrentSubRoom());

    elseif ( not mg_name ) then

      mg_name =  common.GetObjectName( GetCurrentRoom() );

    end;

    if ( _G[ "mg_"..mg_name ] and _G[ "mg_"..mg_name ].GetInfo ) then
      postfix = "_".._G[ "mg_"..mg_name ].GetInfo();
    end;

    ObjSet( "obj_dialog_transpanent_focus", { input = true } );

    interface.DialogShow( "ifo_"..mg_name..postfix );

     public.PlayAudio( "assets/audio/aud_hint_txt_sfx", 0, "", 0 );

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonLock_Click()

    local autohide = interface.InventoryAutoHideGet();

    if autohide then

      common_impl.PlayAudio( "sfx", "aud_inv_lock", 0, "", 0 );

    else

      common_impl.PlayAudio( "sfx", "aud_inv_lock", 0, "", 0 );

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonMap_Click()

    common_impl.PlayAudio( "sfx", "aud_clk_map", 0, "", 0 );
    public.HideDeployInv();
    int_frame_subroom.ButtonCloseClick();
    private.StopDialogTimer();
    private.MapSetTask();
    interface.MapShow();
    
  end;
  --------------------------------------------------------------------------------------
  function public.ButtonMenu_Click()

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonReset_Click()

    public.PlayAudio( "assets/audio/aud_mgreset", 0, "", 0 );

    local mg_name = GetCurrentRoom();
    local minigame = private.current_mg_name or common.GetObjectName( mg_name );

    if ( common.IsInSubRoom() ) then 

      mg_name = common.GetCurrentSubRoom();      

    elseif ( interface.GetCurrentInv() ~= "" ) then

      local inv = string.sub( interface.GetCurrentInv(), 12, string.len( interface.GetCurrentInv() ) );

      mg_name = inv;      

    end;
    _G[ mg_name ].Reset();

  end;
  --------------------------------------------------------------------------------------
  function public.ButtonSkip_Click( skip_ready )

    if ( ( ng_global.gamemode < 2 ) or ( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "skip" ] ) ) then

      if ( skip_ready ) then

        public.PlayAudio( "assets/audio/aud_skip", 0, "", 0 );
        local mg_name = GetCurrentRoom(); 

        if ( common.IsInSubRoom() ) then

          mg_name = common.GetCurrentSubRoom();

        elseif ( interface.GetCurrentInv() ~= "" ) then

          local inv = string.sub( interface.GetCurrentInv(), 12, string.len( interface.GetCurrentInv() ) );

          mg_name = inv;

        end;

        local minigame = private.current_mg_name or common.GetObjectName( mg_name );
        ng_global.progress[ ng_global.currentprogress ][ "win_"..minigame ].skip_clk = true;

        _G[ mg_name ].Skip();

        int_button_skip_impl.StartAnimReloadBegin();        
        interface.ButtonSkipReload( 1 );
 
      else

        --

      end;

    elseif ( ng_global.gamemode == 2 ) then

      interface.DialogShow( "str_skip_hardcore", 512, 384 );
    
    else

      interface.DialogShow( "str_skip_custommode", 512, 384 );

    end;


  end;
  --------------------------------------------------------------------------------------
  function public.FrameSubroom_Click()

  end;
  --------------------------------------------------------------------------------------
  function public.Tutorial_Click( button_id )

    local type = ng_global.currentprogress;

    local postfix = "";
    if type == "ext" then postfix = "_ext"; end;
    if type == "scr" then postfix = "_scr"; end;

    local tutorial_name = ng_global.progress[ type ][ "see_tutorial"..postfix ].state.currentpage;

    if ( string.find( button_id, "yes" ) ) then

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );
      if (ng_global.progress[ type ][ "see_tutorial"..postfix ].start == 0 ) then
        if type == "std" and ng_global.progress[ "std" ].common.chapter == "level1" then
          public.TutorialShow( "tutorial_page_2" );
        elseif type == "scr" and tutorial_name == "tutorial_page_1_scr" then
          public.TutorialShow( "tutorial_page_2"..postfix );
        end;

      else

        if ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage == "tutorial_page_21" and common.GetCurrentRoom() == "ho_suitcase" then

          public.TutorialShow( "tutorial_page_6" );

        end;

      end;

      ng_global.progress[ type ][ "see_tutorial"..postfix ].start = 1;

    elseif ( ng_global.progress[ type ][ "see_tutorial"..postfix ].start == 1 ) and ( string.find( button_id, "empty" ) ) then

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );

      if ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage == "tutorial_page_21" and common.GetCurrentRoom() == "ho_suitcase" then

        public.TutorialShow( "tutorial_page_6" );

      end;

    elseif ( string.find( button_id, "no" ) ) then

      ng_global.progress[ type ][ "see_tutorial"..postfix ].start = 1;
      ng_global.progress[ type ][ "see_tutorial"..postfix ].state.no = 1;

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );
      ng_global.progress[ type ][ "see_tutorial"..postfix ].done = 1;


    elseif ( string.find( button_id, "skipall" ) ) then

      ng_global.progress[ type ][ "see_tutorial"..postfix ].start = 1;
      ng_global.progress[ type ][ "see_tutorial"..postfix ].state.no = -1;

      interface.TutorialHide();
      public.TutorialSetShown( tutorial_name );
      ng_global.progress[ type ][ "see_tutorial"..postfix ].done = 1;

    else

      --DbgTrace("impossible "..button_id);

    end;

  end;
  --------------------------------------------------------------------------------------
  function public.TutorialShow( tutorial_name )

    local type = ng_global.currentprogress;
    
    if ( ng_global.gamemode == 0 )or( ng_global.gamemode == 3 and ng_global.gamemode_custom[ "tutorial" ] ) then

      if ng_global.currentprogress == "std" then

        local table_multiset = {};
        table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_right", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_left", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_clk", { input = false } } );
        ObjDetach( "obj_int_tutorial_clk" );      

        if ( ng_global.progress[ type ][ "see_tutorial" ].state.no ~= 0 ) then

          table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = false, visible = false } } );

        end;

        ObjMultiSet( table_multiset );
        
        local pages = ng_global.progress[ type ][ "see_tutorial" ].state.pages;
        local currentpage = ng_global.progress[ type ][ "see_tutorial" ].state.currentpage;         
        local no_skip = pages[ tutorial_name ][ "noskip" ];
        
        if ( ng_global.progress[ type ][ "see_tutorial" ].state.no == 0 ) 
        or ( ( ng_global.progress[ type ][ "see_tutorial" ].state.no == -1 ) and ( no_skip == true ) ) then      

          if ( pages[ tutorial_name ][ "shown" ] == 0 ) then        

            ng_global.progress[ type ][ "see_tutorial" ].state.currentpage = tutorial_name;

            local block_input = false;
            local dlg_pos_x = pages[ tutorial_name ][ "posx" ];
            local dlg_pos_y = pages[ tutorial_name ][ "posy" ];
            local arrows    = pages[ tutorial_name ][ "arrows" ];
            local string    = "str_"..tutorial_name;

            interface.TutorialShow( string, block_input, dlg_pos_x, dlg_pos_y, arrows );

          end;
          
        end;

      elseif ng_global.currentprogress == "ext" then

        local table_multiset = {};
        table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_right", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_left", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_clk", { input = false } } );
        ObjDetach( "obj_int_tutorial_clk" );      

        if ( ng_global.progress[ type ][ "see_tutorial_ext" ].state.no ~= 0 ) then

          table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = false, visible = false } } );

        end;

        ObjMultiSet( table_multiset );
        
        local pages = ng_global.progress[ type ][ "see_tutorial_ext" ].state.pages;
        local currentpage = ng_global.progress[ type ][ "see_tutorial_ext" ].state.currentpage;    

        if ( not pages ) then return end;
       
        local no_skip = pages[ tutorial_name ][ "noskip" ];
        
        if ( ng_global.progress[ type ][ "see_tutorial_ext" ].state.no == 0 ) 
        or ( ( ng_global.progress[ type ][ "see_tutorial_ext" ].state.no == -1 ) and ( no_skip == true ) ) then      

          if ( pages[ tutorial_name ][ "shown" ] == 0 ) then        

            ng_global.progress[ type ][ "see_tutorial_ext" ].state.currentpage = tutorial_name;

            local block_input = false;

            if ( tutorial_name == "tutorial_page_1_ext" ) then

              block_input = true;

            end;

            local dlg_pos_x = pages[ tutorial_name ][ "posx" ];
            local dlg_pos_y = pages[ tutorial_name ][ "posy" ];
            local arrows    = pages[ tutorial_name ][ "arrows" ];
            local string    = "str_"..tutorial_name;

            interface.TutorialShow( string, block_input, dlg_pos_x, dlg_pos_y, arrows );

          end;
          
        end;


      elseif ng_global.currentprogress == "scr" then

        local table_multiset = {};
        table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_right", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_buttons_left", { input = true, visible = true } } );
        table.insert( table_multiset, { "obj_int_tutorial_clk", { input = false } } );
        ObjDetach( "obj_int_tutorial_clk" );      

        if ( ng_global.progress[ type ][ "see_tutorial_scr" ].state.no == 1 ) then

          table.insert( table_multiset, { "obj_int_tutorial_buttons_mid", { input = false, visible = false } } );

        end;

        ObjMultiSet( table_multiset );
        
        local pages = ng_global.progress[ type ][ "see_tutorial_scr" ].state.pages;
        local currentpage = ng_global.progress[ type ][ "see_tutorial_scr" ].state.currentpage;    

        if ( not pages ) then return end;
       
        local no_skip = pages[ tutorial_name ][ "noskip" ];
        
        if ( ng_global.progress[ type ][ "see_tutorial_scr" ].state.no == 0 ) 
        or ( ( ng_global.progress[ type ][ "see_tutorial_scr" ].state.no == 1 ) and ( no_skip == true ) ) then      

          if ( pages[ tutorial_name ][ "shown" ] == 0 ) then        

            ng_global.progress[ type ][ "see_tutorial_scr" ].state.currentpage = tutorial_name;

            local block_input = false;

            if ( tutorial_name == "tutorial_page_1_scr" ) then

              block_input = true;

            end;

            local dlg_pos_x = pages[ tutorial_name ][ "posx" ];
            local dlg_pos_y = pages[ tutorial_name ][ "posy" ];
            local arrows    = pages[ tutorial_name ][ "arrows" ];
            local string    = "str_"..tutorial_name;

            interface.TutorialShow( string, block_input, dlg_pos_x, dlg_pos_y, arrows );

          end;
          
        end;

      end;

    end;

  end;

  --------------------------------------------------------------------------------------
  function public.TutorialSetShown( tutorial_name )

    local type = ng_global.currentprogress;
    local postfix = "";
    if type == "ext" then postfix = "_ext"; end;
    if type == "scr" then postfix = "_scr"; end;


    local pages = ng_global.progress[ type ][ "see_tutorial"..postfix ].state.pages;

    pages[ tutorial_name ][ "shown" ] = 1;

  end;
  --------------------------------------------------------------------------------------
  function public.HoHint_NoObjects()

  end;
  --------------------------------------------------------------------------------------
  function public.DialogHo_Show()

    common_impl.Lock( false );

    interface.TaskPanelHide();
    interface.ItemPanelHide();

    local name = GetCurrentRoom();
    local ho_name = common.GetObjectName( GetCurrentRoom() );

      if port.isPortable() == 1 then
        port.LogEvent("win_"..ho_name, "close");
      end;
      
    interface.DialogHoShow();

    local ho_name = common.GetObjectName( GetCurrentRoom() );
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 1;
    ng_global.progress[ ng_global.currentprogress ].common.currentroom = game.relations[ name ].exitroom;

  end;
  --------------------------------------------------------------------------------------
  function public.DialogHo_Hide()

    local ho_name = common.GetObjectName( GetCurrentRoom() );
    cmn.CallEventHandler( "win_"..ho_name, GetCurrentRoom() );
    common.GotoRoom( game.relations[ GetCurrentRoom() ].exitroom );

  end;
  --------------------------------------------------------------------------------------
  function public.PanelNotification_Click( notification_type )

    DbgTrace( "Notification Panel Clicked. Notification type: "..notification_type );

  end;
--------------------------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** GATES *** () end ************************************************************************************
--*********************************************************************************************************************
  function public.GotoRm( rm_name, need_fade )

    local rm_object_name = "rm_"..rm_name;

    need_fade = need_fade or 1;  

    public.DeleteHintFx()

    common.GotoRoom( rm_object_name, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GotoHo( ho_name, need_fade )

    local ho_object_name = "ho_"..ho_name;

    need_fade = need_fade or 1; 
    
    public.DeleteHintFx()  

    common.GotoRoom( ho_object_name, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GotoMg( mg_name, need_fade )

    local mg_object_name = "mg_"..mg_name;

    need_fade = need_fade or 1; 
    
    public.DeleteHintFx()  

    common.GotoRoom( mg_object_name, need_fade );

  end;
  --------------------------------------------------------------------
  function public.GotoZz( zz_name, pos_beg )
    
    local zz_object_name = "zz_"..zz_name;

    public.DeleteHintFx()
    ObjDelete( "obj_hint_obj_int_frame_subroom_button" );

    common.GotoSubRoom( zz_object_name, pos_beg );

  end;
  --------------------------------------------------------------------
  function public.GateMouseEnter( type_cursor, text_obj, sender )
        
    if ( type_cursor ) then
      SetCursor( type_cursor );
    else
      SetCursor( CURSOR_DEFAULT );
    end;
     
    local obj = sender;
    local postfix = "";
    if ( ObjGet( obj ).res == "" ) then
      postfix = "_focus";
    end;
    
    local alp = ObjGet( obj..postfix ).alp;
    local time = 0.3;
    ObjAnimate( obj..postfix, "alp", 0, 0, "", 
    { 
      0.0,              0, alp, 
      time*( 1 - alp ), 0, 1
    } );

    public.PopupShow( text_obj );

  end;
  --------------------------------------------------------------------
  function public.GateMouseLeave( sender )
      
    SetCursor( CURSOR_DEFAULT );

    local obj = sender;
    local postfix = "";
    if ( ObjGet( obj ).res == "" ) then
      postfix = "_focus";
    end;

    local alp = ObjGet( obj..postfix ).alp;
    local time = 0.3;
    ObjAnimate( obj..postfix, "alp", 0, 0, "", 
    { 
      0.0,        0, alp,
      time * alp, 0,   0 
    });
       
    public.PopupHide();

  end;
--*********************************************************************************************************************
--***function *** POPUP *** () end ************************************************************************************
--*********************************************************************************************************************
  function public.PopupShow ( popup_text )

    local prg = ng_global.currentprogress;
    
    if prg == "std" or prg == "scr" then
      popup_text_id = "pop_"..popup_text;
    else
      popup_text_id = "pop_"..popup_text.."_ce";
    end;

    interface.PopupShow( popup_text_id );

  end;
  --*********************************************************************************************************************
  function public.PopupHide()

    interface.PopupHide();
    
  end;
--*********************************************************************************************************************
--***function *** NOTE *** () end *************************************************************************************
--*********************************************************************************************************************
  function public.NoteScale( source_name, big_pic )

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    local small_pic = source_name;
    local big_pic   = big_pic or "spr_"..common.GetObjectName( small_pic ).."_big";

    local pos_array  = {};

    pos_array.start  = {};
    pos_array.finish = {};

    pos_array.start.pos_x = ObjGet( small_pic ).pos_x;
    pos_array.start.pos_y = ObjGet( small_pic ).pos_y;
    pos_array.finish.pos_x = ObjGet( big_pic ).pos_x;
    pos_array.finish.pos_y = ObjGet( big_pic ).pos_y;

    local obj = common.GetObjectName( GetCurrentRoom());

    if not public.note[ obj ] then 

      public.note[ obj ] = {};
      public.note[ obj ].open = false;

    end;

    local func_end = function()

      public.Lock( false );

      if not public.note[ obj ].open then

        public.note[ obj ].open = true;
        ObjSet( big_pic, { input = true } );

      else

        public.note[ obj ].open = false;
        ObjSet( big_pic, { input = false, active = false, alp = 0, pos_x = pos_array.finish.pos_x, pos_y = pos_array.finish.pos_y } );

      end;  

    end;

    if not public.note[ obj ].open then

      public.Lock( true );

      private.note_scale.pos_x = pos_array.start.pos_x;
      private.note_scale.pos_y = pos_array.start.pos_y;

      ObjSet( big_pic, 
      { 
        alp = 1, 
        active = true, input = true, 
        inputrect_init = true, inputrect_x = -1000, inputrect_y = -1000, 
        inputrect_w = 2000, inputrect_h = 2000
      } );

      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
      0.0, 0, 1, 
      0.3, 0, 0 
      } );

      ObjAnimate( small_pic.."_shadow", "alp", 0, 0, "", 
      { 
      0.0, 0, 1, 
      0.3, 0, 0 
      } );

      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      {
      0.0, 3, pos_array.start.pos_x, pos_array.start.pos_y,
      0.3, 3, pos_array.finish.pos_x, pos_array.finish.pos_y 
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, func_end, 
      { 
      0.0, 3, 0, 0,
      0.3, 3, 1, 1 
      } );

      local note_bbt = "bbt_"..common.GetObjectName( small_pic );
      common_impl.ShowBbt( note_bbt );

    else

      public.Lock( true );

      --common_impl.PlayAudio( "sfx", "common/audio/aud_paper_close", 0, "", 0 ); 
  
      ObjAnimate( small_pic, "alp", 0, 0, "", 
      { 
      0.0, 0, 0, 
      0.3, 0, 1 
      } );

      ObjAnimate( small_pic.."_shadow", "alp", 0, 0, "", 
      { 
      0.0, 0, 0, 
      0.3, 0, 1 
      } );

      ObjAnimate( big_pic, "pos_xy", 0, 0, "", 
      { 
      0.0, 3, pos_array.finish.pos_x, pos_array.finish.pos_y,
      0.3, 3, private.note_scale.pos_x, private.note_scale.pos_y
      } );

      ObjAnimate( big_pic, "scale_xy", 0, 0, func_end, 
      {
      0.0, 3, 1, 1,
      0.3, 3, 0, 0
      } );

    end;

  end;
--*********************************************************************************************************************
  function public.NoteScaleClose ( source_name, source_big_pic )

    local obj = common.GetObjectName( GetCurrentRoom() );

    if public.note[ obj ] then 

      public.note[ obj ].open = false; 
    
    end;

    for i = 1, #source_name do

      local small_pic = source_name[ i ];
      local big_pic   = small_pic.."_big";

      if ( source_big_pic ) then

        big_pic = source_big_pic[ i ];

      end;

      ObjSet( small_pic, { input = true, alp = 1 } );
      ObjSet( big_pic,   { input = false, alp = 0 } );

    end;

  end;
--*********************************************************************************************************************
--***function *** Interface *** () end ********************************************************************************
--*********************************************************************************************************************
  -- hide subroom 
  function public.HideCurrentInterface ()

    public.InterfaceSetVisible( false );
    local room = GetCurrentRoom();

    if ( common.IsInSubRoom() and common.GetObjectPrefix( room ) ~= "mg" ) then

      room = common.GetCurrentSubRoom();

    end;

    local trg_after = function()

      ObjSet( room, { active = false } );

    end;
    
    if common.GetObjectPrefix( room ) == "zz" then

      ObjSet( room, { input = false } ); 
      ObjSet( "int_frame_subroom", { input = false } ); 
      ObjSet( "subroom", { input = false } );
      ObjAnimate( "int_frame_subroom", "alp", 0, 0, "", { 0,0,1,  0.3,0,0 } );
      ObjAnimate( "subroom", "alp", 0, 0, "", { 0,0,1,  0.3,0,0 } );
      ObjAnimate( room, "alp", 0, 0, trg_after, { 0,0,1,  0.3,0,0 } );

    else 

      ObjSet( room, { input = false } ); 

    end;

  end;
  --*********************************************************************************************************************
  -- show subroom 
  function public.ShowCurrentInterface ()

    public.Lock( true );  public.InterfaceSetVisible( true );
    local room = GetCurrentRoom();

    if common.GetObjectPrefix( room ) == "mg" then

      ObjSet( room, { input = true, active = true } ); 

    elseif common.GetObjectPrefix( room ) == "rm" then

      if ( common.IsInSubRoom() ) then

          room = common.GetCurrentSubRoom();

          ObjSet( room, { input = true, active = true } ); 
          ObjSet( "int_frame_subroom", { input = true } ); 
          ObjSet( "subroom",           { input = true } );

          ObjAnimate( "int_frame_subroom", "alp", 0, 0, "", { 0, 0, 0,  0.3, 0, 1 } );
          ObjAnimate( "subroom",           "alp", 0, 0, "", { 0, 0, 0,  0.3, 0, 1 } );
          ObjAnimate( room,                "alp", 0, 0, "", { 0, 0, 0,  0.3, 0, 1 } );

      else 

          ObjSet( room, { input = true, active = true } );  

      end;

    end;

  end;
  --*********************************************************************************************************************
  -- show/hide interface 
  function public.InterfaceSetVisible( key )

    local int_widget = 
    {
      "int_inventory",
      "int_button_hint",
      --"int_taskpanel",
      "int_button_map",
      "int_button_menu",
      "int_button_guide",
      "int_investigation_button"
    }

    if ( key == false ) then

      for i = 1, #int_widget do

        ObjSet( int_widget[ i ], { input = false });
        ObjAnimate( int_widget[ i ], "alp", 0, 0, "", { 0,0,1,  0.3,0,0 } );

      end;

      --ObjSet( "subroom", { input = false });

    else 

      for i = 1, #int_widget do

        ObjSet( int_widget[ i ], { input = true, visible = 1, alp = 1 });

      end;

      --ObjSet( "subroom", { input = true });

    end;

  end;
--*********************************************************************************************************************
--***function *** AUDIO *** () end**************************************************************************
--*********************************************************************************************************************
  function public.PlayAudio(type,path,loop,trig,fade)

    if not loop then loop = 0; end;
    if not trig then trig = ""; end;
    if not fade then fade = 0; end;
    
    local needtoplay = true;
    if (type ~= "sfx") and (loop == 1) and (#private.audio[type] > 0) then
      for i = 1, #private.audio[type], 1 do
        if private.audio[type][i] == path then
          needtoplay = false;
        end;
      end;
    end;
    if needtoplay then
      if type == "sfx" then
        PlaySfx("assets/audio/"..path,loop,fade);
      elseif type == "env" then
        PlayEnv("assets/audio/"..path,loop,fade);
        private.audio["env"][ #private.audio["env"] + 1 ] = path;
      elseif type == "mus" then
        public.StopAllMus();
        PlaySoundtrack("assets/audio/"..path,loop,fade);
        private.audio["mus"][ #private.audio["mus"] + 1 ] = path;
      elseif type == "mus_env" then
        PlaySoundtrack("assets/audio/"..path,loop,fade);
        private.audio["mus_env"][ #private.audio["mus_env"] + 1 ] = path;
      elseif type == "voc" then
        PlayVoice("assets/audio/"..path,loop,fade);
        private.audio["voc"][ #private.audio["voc"] + 1 ] = path;
      end;
    end;

  end;
  --*********************************************************************************************************************
  --------------------------------------------------------------------------------------
  --функция проигрывания енвайромента
  function public.EnvPlay(paths,trig,fade)
    if not trig then trig = ""; end;
    if not fade then fade = 0; end;

    local loop = 1;
    local needtoplay = true;
    local shift = 0;
    
    
    for i = 1, #private.audio["env"] do    
      local needtostop = true;
      for j = 1, #paths do
        if private.audio["env"][i] == paths[j] then
          needtostop = false;
        end;
      end;
      if needtostop then
        SndStop("assets/audio/"..private.audio["env"][i],2.0);
        private.audio["env"][i] = nil;
        shift = shift + 1;
      else
        private.audio["env"][i-shift] = private.audio["env"][i];
        if shift ~= 0 then
          private.audio["env"][i] = nil;
        end;
      end;
    end;

    for j = 1, #paths, 1 do
      needtoplay = true;
      for i = 1, #private.audio["env"], 1 do
        if private.audio["env"][i] == paths[j] then
          needtoplay = false;
        end;           
      end; 
      
      if needtoplay then
        PlayEnv("assets/audio/"..paths[j],loop,fade);
        private.audio["env"][ #private.audio["env"] + 1 ] = paths[j];
      end;
    end;
    
  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.PlayMusEnv ( path )

    if IsNoSoundDevice() then

      return;

    end;

    local rnd;
    local rnd_min = 1;
    local rnd_max = 7;
    local time_name = "tmr_mus_env";
    local time = 150;
    local prg = ng_global.currentprogress;
    local level = ng_global.progress[ prg ].common.chapter;
 
    if not ObjGet( time_name ) then

      ObjCreate( time_name, "timer" );
      ObjAttach( time_name, "cmn_timers" );

    end;

    ObjSet( time_name, { playing = true, time = time, endtrig = function() public.PlayMusEnv() end } );

    if not path then

      if level == "level1" then

        if not cmn.IsEventDone( "see_disappearance_professor" ) then

          rnd = 4;

        else

          rnd = 5;

        end;

      elseif level == "level2" then

        rnd = 6;

      elseif level == "levelext" or level == "levelscr" then

        rnd_min = 7
        rnd     = 10;

      else

        rnd = rnd_max;

      end;

      path = "mus_env/aud_track"..math.random( rnd_min, rnd ).."_mus_env";

    end;

    public.StopMusEnv( true );
    public.PlayAudio( "mus_env", path, 0, "", 0.5 )

  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.StopMusEnv ( continuation )

    if not continuation then

      local time_name = "tmr_mus_env";
      ObjSet( time_name, { playing = false } );

    end;

    if ( private.audio["mus_env"][1] ~= nil ) then

      SndStop( "assets/audio/"..private.audio["mus_env"][1], 2 );
      private.audio["mus_env"][1] = nil;

    end;
 
  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.StopAllEnv(path)
    for i = 1, #private.audio["env"], 1 do
      if ( private.audio["env"][i] ~= nil ) and ( private.audio["env"][i] ~= path ) then
        SndStop("assets/audio/"..private.audio["env"][i],0.5);
        private.audio["env"][i] = nil;
      end;
    end;
  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.StopAllMus(path)
    for i = 1, #private.audio["mus"], 1 do
      if ( private.audio["mus"][i] ~= nil ) and ( private.audio["mus"][i] ~= path ) then
        SndStop("assets/audio/"..private.audio["mus"][i],0.5);
        private.audio["mus"][i] = nil;
      end;
    end;
  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.StopAllVoc(path)
    for i = 1, #private.audio["voc"], 1 do
      if ( private.audio["voc"][i] ~= nil ) and ( private.audio["voc"][i] ~= path ) then
        SndStop("assets/audio/"..private.audio["voc"][i],0.5);
        private.audio["voc"][i] = nil;
      end;
    end;
  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.StopAudio(type,path,fade)
    if not fade then fade = 0; end;
    local shift = 0;
    for i = 1, #private.audio[type], 1 do
      if private.audio[type][i] == path then
        private.audio[type][i] = nil;
        shift = shift + 1;
      else
        private.audio["env"][i-shift] = private.audio["env"][i];
        if shift ~= 0 then
          private.audio["env"][i] = nil;
        end;
      end;
    end;
    SndStop("assets/audio/"..path,fade);
  end;
  --------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------
  function public.PlayMusDanger ()

    local number = math.random( 1, 2 );

    public.PlayAudio( "mus", "aud_danger"..number.."_mus", 0, "", 2.0 )

  end;
  --------------------------------------------------------------------------------------
  function public.GetAudio ( type )
  
    local tempAudio = {};

    for i = 1, #private.audio[ type ] do
      
      table.insert( tempAudio, private.audio[ type ][ i ] );

    end;   

    return tempAudio;

  end;
--------------------------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** DIALOG CHARACTER *** () end**************************************************************************
--*********************************************************************************************************************
  function public.DialogCharacterChoiceClk( number_choice )

    public.StopAllVoc();

    common_impl.PlayAudio( "sfx", "aud_clk_dialog", 0, "", 0 );

    local name = tostring( private.object_current );
    local current_room = common.GetObjectName( GetCurrentRoom() );
    public.dialog_character_select = 0;
   
    if public.frases[ number_choice ] then
    
      public.answer_text = "str_"..current_room.."_"..name.."_answer_"..public.frases[ number_choice ];
      private.lipsing_name = "vid_"..current_room.."_"..name.."_answer_"..public.frases[ number_choice ]; 
      public.dialog_character_select = public.frases[ number_choice ];
      private.aud_name = "aud_"..current_room.."_"..name.."_answer_"..public.frases[ number_choice ].."_voc";

    end;

    --if name == "mother_1" and current_room == "park_1" and public.frases[ number_choice ] == 2 then
    --  
    --  public.continue_answer_count = private.dialog_count_txt + 2;
    --  public.continue_answer = true;
    --      
    --end;

    local func_after = function()

      public.Lock( false );
       
      for i = 1, #public.frases do

        ObjSet( "spr_int_dialog_character_choise_"..i, { alp = 0, input = false } );

      end;

      ObjSet( "grd_int_dialog_character_choise", { input = false } );
      ObjSet( "obj_int_dialog_character_input", { event_mdown = function() int_dialog_character.ContinueClick( false ) end; } );

      table.remove( public.frases, number_choice );
      table.remove( public.icons, number_choice );

      if #public.frases == 0 then public.continue_visible = true;
      else public.continue_visible = false;
      end;
    
      int_dialog_character.ContinueClick( true );

    end;

    public.Lock(true);

     ObjAnimate( "grd_int_dialog_character_choise", "pos_x", 0, 0, func_after,
    {
      0, 3, int_dialog_character_impl.CHOISE_POS_X,
      0.5, 3, -500   
    } );

  end;
  --******************************************************************************************
  function public.DialogCharacterSwitchDialogFrase()

    local current_room = GetCurrentRoom();
    local count_txt = private.dialog_count_txt;
    local dlg_name = private.object_current;
    
    _G[current_room].SwitchFrase( dlg_name, count_txt );

  end;
  --******************************************************************************************
  function public.DialogCharacterShowDialogQuestions( number_choice, time )

    name_object = tostring( private.object_current );
    number_choice = tonumber( number_choice );
   
    local current_room = common.GetObjectName( GetCurrentRoom() );
    local text_height = 0;
    ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = function() public.DialogCharacterDialogQuestionsAnim( false ) end } );
    local endtrig = "";

    for i = 1, number_choice do
   
     ObjSet( "txt_int_dialog_character_choise_"..i, { text = "str_"..current_room.."_"..name_object.."_question_"..public.frases[i] } );

     endtrig = function() public.DialogCharacterChoiceClk( i ) end;    

     ObjSet( "spr_int_dialog_character_choise_"..i, { event_mdown = endtrig, alp = 1, input = true } );
     
     text_height = text_height + ObjGet( "txt_int_dialog_character_choise_"..i ).draw_height;

    end;

    local dialog_w = 550;
    local dialog_h = text_height + 150;
    local grid_corner_w = int_dialog_character_impl.GRID_CORNER_W;
    local grid_corner_h = int_dialog_character_impl.GRID_CORNER_H;
    local grid_mid_w = int_dialog_character_impl.GRID_MID_W;
    local grid_mid_h = int_dialog_character_impl.GRID_MID_H;

    interface.FrameGridSet( "int_dialog_character_choise",
    {
      grid_w   = dialog_w,
      grid_h   = dialog_h,
      corner_w = grid_corner_w,
      corner_h = grid_corner_h,
      mid_w    = grid_mid_w,
      mid_h    = grid_mid_h
    } );

    for i = 1, #public.icons do

      ObjSet( "spr_int_dialog_character_choise_"..i.."_icon", { res = "assets/interface/resources/dialog_character/icons/"..public.icons[ i ] } );

    end;

    if number_choice == 3 then

      ObjSet( "spr_int_dialog_character_choise_1", { pos_y = -60 } );
      ObjSet( "spr_int_dialog_character_choise_2", { pos_y = 0 } );
      ObjSet( "spr_int_dialog_character_choise_3", { pos_y = 60 } );

    elseif number_choice == 2 then

      ObjSet( "spr_int_dialog_character_choise_1", { pos_y = -35 } );
      ObjSet( "spr_int_dialog_character_choise_2", { pos_y = 35 } );

    else

      ObjSet( "spr_int_dialog_character_choise_1", { pos_y = 0 } );

    end;

    if not time then time = 1; end; 
   
    ObjSet( "grd_int_dialog_character_choise", { input = false } ); 
    ObjAnimate( "grd_int_dialog_character_choise", "pos_x", 0, 0, public.DialogCharacterDialogQuestionsAnim,
    {
      0, 3, -500,
     ( time - 0.5 ), 3, -500
    } );

  end;
  --******************************************************************************************
  function public.DialogCharacterDialogQuestionsAnim()

    public.Lock(true);

    local func_after = function()

      public.Lock(false);

      ObjSet( "grd_int_dialog_character_choise", { input = true } );
      ObjSet( "obj_int_dialog_character_input", { event_mdown = "" } );

    end;

    ObjSet( "grd_int_dialog_character_choise", { pos_x = -500 } );
    ObjAnimate( "grd_int_dialog_character_choise", "pos_x", 0, 0, func_after,
    {
      0.0, 3, -500,
      0.5, 3, int_dialog_character_impl.CHOISE_POS_X
    });
     

  end;
  --******************************************************************************************
  function public.DialogCharacterChangeCharacters( object_name, current_character, new_character )

      local current_room = common.GetObjectName( GetCurrentRoom() );

      if current_character then

        ObjAnimate( "obj_"..current_room.."_"..object_name.."_"..current_character, "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );
        ObjSet( "obj_"..current_room.."_"..object_name.."_"..current_character, { pos_z = 1 } );

      end;
      
      local relations = ObjGetRelations( "obj_"..current_room.."_"..object_name.."_characters" );

      for i = 1, #relations.childs do

        ObjSet( relations.childs[i], { color_r = 0.4,color_g = 0.4, color_b = 0.4 } );

      end;
         
      ObjSet( "obj_"..current_room.."_"..object_name.."_"..new_character, { pos_z = 10, color_r = 1, color_g = 1, color_b = 1 } );
      ObjAnimate( "obj_"..current_room.."_"..object_name.."_"..new_character, "scale_xy", 0, 0, "", { 0,0,1,1, 0.3,0,1.05,1.05 } );
     
  end;
  --******************************************************************************************
  function public.DialogCharacterStart( object_name, max_number, click_func, skip_func, func_after_frase, end_trigger )
    
     public.InterfaceSetVisible( false );

     public.Lock(true);

     local current_room = common.GetObjectName( GetCurrentRoom() );

     local trg_after = function()
      
      public.Lock(false);

     end;

     ObjAnimate( "dlg_"..current_room.."_"..object_name, "alp", 0, 0, trg_after, { 0,0,0, 0.3,0,1 } );

     if public.dialog_character_loc then
    
      ObjAnimate( public.dialog_character_loc, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

     end;

      
     if object_name == "mother_1" and current_room == "square" then

      public.continue_visible = true;
      public.DialogCharacterChangeCharacters( object_name, false, "mother" );

     elseif object_name == "sheriff" and current_room == "square" then
     
      public.DialogCharacterChangeCharacters( object_name, false, "sheriff" );
      
     end;

     ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = function() int_dialog_character.ContinueClick( false ) end; } );
      
     ObjStopAnimate( "grd_int_dialog_character_choise", "pos_x" );

     ObjSet( "grd_int_dialog_character_choise", { pos_x = -500 } );
     
     interface.DialogCharacterShow( object_name, max_number, click_func, skip_func, func_after_frase, false, end_trigger );

  end;
  --******************************************************************************************
  function public.DialogCharacterShow( object_name, max_number, click_func, skip_func, func_after_frase, answer, end_trigger )

    local prg = ng_global.currentprogress;
    local lvl = ng_global.progress[ prg ].common.chapter;
    local voc_name = object_name;
    local name_aud;

    public.StopAllVoc();
     
    if not ( func_after_frase ) then

      func_after_frase = false;

    end;

    if not ( end_trigger ) then

      end_trigger = false;

    end;

    public.func_after_frase = func_after_frase;
    public.end_trigger = end_trigger;
    public.max_number = max_number;
    private.object_current = object_name;

    if not ( private.dialog_count_txt ) then

      private.dialog_count_txt = 0;

    end;

    local current_room = common.GetObjectName( GetCurrentRoom() );

    ObjAttach( "dlg_"..current_room.."_"..object_name, "obj_int_dialog_character_scene" );

    private.dialog_count_txt = private.dialog_count_txt + 1;
  
    if ( private.dialog_count_txt == max_number ) then

      public.DialogCharacterHide();
      return;

    end;

    if not ( answer and public.continue_answer ~= true ) then

      public.answer_text = "str_"..current_room.."_"..object_name.."_"..private.dialog_count_txt; 
      private.lipsing_name = "vid_"..current_room.."_"..object_name.."_"..private.dialog_count_txt; 
      private.aud_name = "aud_"..current_room.."_"..voc_name.."_"..private.dialog_count_txt.."_voc";

    end;

    if ( public.continue_answer == true and public.continue_answer_count == private.dialog_count_txt ) then

      public.answer_text = "str_"..current_room.."_"..object_name.."_answer_2_2"; 
      private.lipsing_name = "vid_"..current_room.."_"..object_name.."_answer_2_2";  
      public.continue_answer = false;
      public.continue_visible = false;

    elseif ( public.continue_answer == true ) then

      public.continue_visible = true;

    end;

    --войсы

    common_impl.PlayAudio( "voc", lvl.."/voc/"..private.aud_name, 0, "", 0 );

    --липсинг
    
    public.DialogCharacterStopAllVid();
    ObjSet( private.lipsing_name, { alp = 1, playing = true } );
    --DbgTrace( private.lipsing_name );    
      
    int_dialog_character.Show( object_name, click_func, skip_func );

    if ( func_after_frase ) then

      public.DialogCharacterSwitchDialogFrase();

    end;

  end;
  --******************************************************************************************
  function public.DialogCharacterHide( is_skip )

    if not is_skip then

      cmn.CheckGiveCustomAchiev( "dialog_no_skip" );

    end;

    public.StopAllVoc();

    local current_room = common.GetObjectName( GetCurrentRoom() );
      
    interface.DialogCharacterHide();

    ObjSet( "obj_int_dialog_character_input", { input = false } );
   
    public.Lock(true);

    local func_event_done = function()

      public.InterfaceSetVisible( true );
     
      cmn.SetEventDone( "dlg_"..current_room.."_"..private.object_current );
      cmn.CallEventHandler( "dlg_"..current_room.."_"..private.object_current.."_end" );
      
      public.Lock(false); 

      local room = GetCurrentRoom();

      ObjDetach( "dlg_"..current_room.."_"..private.object_current )


      if public.end_trigger then
         
        public.end_trigger();

      end;

      ObjDetach( "dlg_"..current_room.."_"..private.object_current );

      public.func_after_frase = false;
      public.max_number = nil;  
      private.dialog_count_txt = nil; 
      public.answer_text = nil;
     
    end;
    
    ObjAnimate( "dlg_"..current_room.."_"..private.object_current, "alp", 0, 0, func_event_done, { 0,0,1, 0.3,0,0 } );
   
    if public.dialog_character_loc ~= "" then
      ObjAnimate( public.dialog_character_loc, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    end;

      
  end;
  --******************************************************************************************
  function public.DialogCharacterStopAllVid()

    local current_room = common.GetObjectName( GetCurrentRoom() );
    local relations = ObjGetRelations( "obj_"..current_room.."_"..private.object_current.."_characters" );

    if ( relations.childs ) then

      for i = 1, #relations.childs do

        local relations_2 = ObjGetRelations( relations.childs[i] );

          for j = 1, #relations_2.childs do

            if ( common.GetObjectPrefix( relations_2.childs[j] ) == "vid" ) then

              ObjSet( relations_2.childs[j], { alp = 0, playing = 0 } );

            end;

          end;

      end;

    end;

  end;
  --******************************************************************************************
  function public.DialogCharacterContinueClick( answer )

    public.DialogCharacterShow( private.object_current, public.max_number, nil, nil, public.func_after_frase, answer, public.end_trigger );

  end;
  --******************************************************************************************
  function public.DialogCharacterSkipClick()

   for i = 1, 3 do
    ObjSet( "spr_int_dialog_character_choise_"..i, { alp = 0, input = false } ); 
   end;
    
   public.DialogCharacterHide( true );
   public.DialogCharacterStopAllVid();

  end;
--*********************************************************************************************************************
--***function *** VIDEO *** () end*******************************************************************************
--*********************************************************************************************************************
  private.vid_timer_name = {
    { "rm_car",      "tmr_car_bodyguard" },
    { "rm_car",      "tmr_car_trip" },
    { "rm_hall",     "tmr_hall_disappearance_professor" },
    { "rm_bar",      "tmr_bar_close_door" },
    { "rm_examroom", "tmr_examroom_opn_examroom" }
  };
  --******************************************************************************************
  
  function public.PlayDialogVideo ( vid_name, func_end, skip_func, skip_time, block_input )

    skip_func = skip_func or func_end;
    skip_time = skip_time or 3;
    block_input = block_input or 1;

    local env_list = {};

    for i = 1, #private.audio["env"] do

      table.insert( env_list, private.audio["env"][ 1 ] );

    end;

    common_impl.StopMusEnv();
    common_impl.StopAllEnv();

    local func_env_end = function ()

      cmn.CheckGiveCustomAchiev( "vid_no_skip" );

      common_impl.EnvPlay( env_list, "", 2 );
      cmn.PlayMusEnv();
      interface.DialogVideoHide();

      func_end();
      private.ActiveDialogVideoname = nil;
      
    end;

    local func_env_skip = function ()

      common_impl.EnvPlay( env_list, "", 2 );
      cmn.PlayMusEnv();
      interface.DialogVideoHide();

      skip_func();
      private.ActiveDialogVideoname = nil;
      
    end;
    
      interface.DialogVideoShow( vid_name, block_input, func_env_skip, skip_time );
    
    
    if ObjGet(vid_name).scale_x<1.9 then
      ObjSet(vid_name,{ scale_x = ObjGet(vid_name).scale_x*2, scale_y = ObjGet(vid_name).scale_y*2 });
    end;
    
    VidPlay( vid_name, func_env_end );
    port.ActiveDialogVideoname = vid_name;
    
  end;
  --******************************************************************************************
  function private.StopDialogTimer ( tmr_name )

    if tmr_name then

      ObjSet( tmr_name, { active = false } );
      return

    end;

    local room = GetCurrentRoom();

    for i = 1, #private.vid_timer_name do

      if private.vid_timer_name[ i ][ 1 ] == room then

        ObjSet( private.vid_timer_name[ i ][ 2 ], { active = false } );

      end;

    end;

  end;
  --******************************************************************************************
  function public.PlayDialogTimer ( tmr_name )

    if tmr_name then

      ObjSet( tmr_name, { active = true } );
      return

    end;

    local room = GetCurrentRoom();

    for i = 1, #private.vid_timer_name do

      if private.vid_timer_name[ i ][ 1 ] == room then

        ObjSet( private.vid_timer_name[ i ][ 2 ], { active = true } );

      end;

    end;

  end;
--*********************************************************************************************************************
--***function *** ACHIEVEMENTS *** () end*******************************************************************************
--*********************************************************************************************************************
  function public.AchievementsLoad ()

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      ObjSet( "spr_barstand_cookies", { active = true, visible = true, input = true } );
      if ( ng_global.achievements[ "cake" ].done == 1 ) then

        ObjDelete( "spr_barstand_cookies" );

      end;

    else 
      
      ObjSet( "spr_barstand_cookies", { active = false, visible = false, input = false } );

    end;

  end;

  function private.AchievementsInit ()

    private.achievements = {};
    private.achievements.queue = {};
    private.achievements.show  = false;

    -- назкание ачивки, за какое событие, кол-во выполненных событий
    private.achievements.LIST = 
    {
      { "not_skip_mg_1", "win_mg", 3 },--прохождение мг без скипа 
      { "not_skip_mg_2", "win_mg", 5 },
      { "not_skip_mg_3", "win_mg", 10 },
      { "not_skip_mg_4", "win_mg", 39 },

      { "not_skip_ho_1", "win_ho", 3 },--прохождение хо без скипа
      { "not_skip_ho_2", "win_ho", 5 },
      { "not_skip_ho_3", "win_ho", 10 },
      { "not_skip_ho_4", "win_ho", 13 },--

      

      { "ho_three_1", "ho_3", 3 },--прохождение 3-х ХО подряд, меньше чем за 3 минуты каждое    
      { "ho_three_2", "ho_3", 5 },
      { "ho_three_3", "ho_3", 10 },

      { "ho_three_obj_three", "", 1 },--подбор 3-х объектов ХО за 3 секунды 
      { "ho_five_obj_five",   "", 1 },
      { "ho_ten_obj_ten",     "", 1 },

      { "ho_ten_min",     "", 1 },--прохождение 1-го ХО больше чем за 10 минут    

      { "ho_one_min",     "", 1 },--прохождение 1-го ХО меньше чем за 1 минуту   

      { "mg_one_min",     "", 1 },--Прохождение 1-ой МГ меньше чем за 1 минуту

      { "save_professor",   "", 1 },  --спасти профессора
      { "use_teleport",   "", 1 },  --использовать карту для перехода в лок
      { "superpuzzle_no_skip",   "", 1 },  --пройти суперпазл без скипа
      { "vid_no_skip",   "", 42 },   --посмотри видео без скипа
      { "dialog_no_skip",   "", 17 },   --посмотреть диалоги без скипа
      { "wrong_apply",   "", 1 },  --неправильное применение предмета
      { "cake",   "", 1 },   --скупать пироженку
    };

    ng_global.achievements                    = {};
    ng_global.achievements.count              = {};
    ng_global.achievements.count.get_collect  = 0; 
    ng_global.achievements.count.get_glass    = 0; 
    ng_global.achievements.count.get_morph_collect    = 0;
    ng_global.achievements.count.win_mg       = 0;    
    ng_global.achievements.count.win_ho       = 0;
    ng_global.achievements.count.ho_3         = 0;-- сколько хо выигранно за 3 минуты

    ng_global.achievements.custom = {};
    ng_global.achievements.custom.no_skip_vid = 0; -- кол- во проущенные видео
    ng_global.achievements.custom.no_skip_dialog = 0; -- кол-во пропущенные диалоги
    ng_global.achievements.custom.no_skip_superpuzzle = 0; -- кол-во пропущенные суперпазлов

    for j = 1, #private.achievements.LIST  do

      local name_achiev = private.achievements.LIST[ j ][ 1 ];
      ng_global.achievements[ name_achiev ]      = {};
      ng_global.achievements[ name_achiev ].done = 0;
      ng_global.achievements[ name_achiev ].show = 0;

    end;

    ng_global.achievements.found = {};

    if ( not ObjGet( "tmr_int_achievement_give" ) ) then

      ObjCreate( "tmr_int_achievement_give", "timer" );

    end;

  end;
  --------------------------------------------------------
  function private.CheckAnimAchiev ()

    ObjAttach( "tmr_int_achievement_give", "cmn_timers" );
    ObjSet("tmr_int_achievement_give", { playing = true, time = 0.5, endtrig = private.CheckAnimAchiev } );

    if ( not private.achievements.show ) then

      for i = 1, #private.achievements.queue do

        ng_global.achievements[ private.achievements.queue[ i ] ].done = 1;
        interface.ShowAchievements( private.achievements.queue[ i ] );
        table.remove( private.achievements.queue, i );
        break;

      end;
      
      if ( #private.achievements.queue == 0 ) then

        ObjSet("tmr_int_achievement_give", { playing = false } );

      end;

    end;

  end;
  --------------------------------------------------------
  -- получение нестандартных ачивок
  function public.CheckGiveCustomAchiev ( name )

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      if name == "dialog_no_skip" then

        private.CountDlg();

      elseif name == "vid_no_skip" then

        private.CountVid();

      else

        private.GiveAchiev( name );

      end;

    end;

  end;
  --------------------------------------------------------
  function private.GiveAchiev ( name )

    if ( ng_global.achievements[ name ].done == 0 ) then

      local prg = ng_global.currentprogress;
      local level = ng_global.progress[ prg ].common.chapter;

      if level == "level1" then

        if cmn.IsEventStart( "see_tutorial" ) then

          common_impl.TutorialShow( "tutorial_page_21" );

        end;

      end;

      local name_exist = false;
      for i = 1, #private.achievements.queue do

        if ( private.achievements.queue[ i ] == name ) then

          name_exist = true;
          break;
      
        end;

      end;

      if ( not name_exist ) then

        for i = 1, #private.achievements.queue do

          ng_global.achievements[ private.achievements.queue[ i ] ].done = 1;

        end;

        table.insert( private.achievements.queue, name );
        
        if ( not ObjGet( "tmr_int_achievement_give" ).playing ) then
        
          private.CheckAnimAchiev();

        end;

      end;

    end;

  end;
  --------------------------------------------------------
  -- определяем какую из "градационных" ачивок выдать
  function private.CheckGiveAchiev ( name )
     
    if ( not ( IsCollectorsEdition() or IsSurveyEdition() ) ) then
      return;
    end;

    local value_count = {};

    for i = 1, #private.achievements.LIST do

      local prg_name = private.achievements.LIST[ i ][ 2 ];
      if ( prg_name == name ) then

        table.insert( value_count, { private.achievements.LIST[ i ][ 1 ], private.achievements.LIST[ i ][ 3 ]} )

      end;

    end;
    
    for i = 1, #value_count do

      if ( ng_global.achievements.count[ name ] == value_count[ i ][ 2 ] ) then   
          
        private.GiveAchiev( value_count[ i ][ 1 ] );

      end;

    end;

  end;
  --------------------------------------------------------
  -- Увеличение счетчика собранных collectibles
  function public.CountGetCollect ()

    ng_global.achievements.count.get_collect = ng_global.achievements.count.get_collect + 1;
    private.CheckGiveAchiev( "get_collect" ); 
       
  end;
  --------------------------------------------------------
  function public.CountGetMorphCollect ()

    ng_global.achievements.count.get_morph_collect = ng_global.achievements.count.get_morph_collect + 1;
    private.CheckGiveAchiev( "get_morph_collect" ); 
       
  end;
  --------------------------------------------------------
  function private.CountWinMg ( minigame_name )

    local mg_name = minigame_name or cmn.GetObjectName( GetCurrentRoom() );

    if ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].skip_clk ) then

      ng_global.achievements.count.win_mg = ng_global.achievements.count.win_mg + 1;
      private.CheckGiveAchiev( "win_mg" );
     
    end;
         
  end;
  --------------------------------------------------------
  function private.CountWinHo ()

    if ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..common.GetObjectName( GetCurrentRoom() ) ].hint_clk ) then

      ng_global.achievements.count.win_ho = ng_global.achievements.count.win_ho + 1;
      private.CheckGiveAchiev( "win_ho" );

    end;

  end;
  --------------------------------------------------------
  function private.CountDlg ()

    local achiev_name = "dialog_no_skip";

    ng_global.achievements.custom.no_skip_dialog = ng_global.achievements.custom.no_skip_dialog + 1;

    for i = 1, #private.achievements.LIST do

      if private.achievements.LIST[ i ][ 1 ] == achiev_name then

        if ng_global.achievements.custom.no_skip_dialog == private.achievements.LIST[ i ][ 3 ] then

          private.GiveAchiev( achiev_name );
          return;

        end;

      end;

    end;
     
  end;

  --------------------------------------------------------
  function private.CountVid ()

    local achiev_name = "vid_no_skip";

    ng_global.achievements.custom.no_skip_vid = ng_global.achievements.custom.no_skip_vid + 1;

    for i = 1, #private.achievements.LIST do

      if private.achievements.LIST[ i ][ 1 ] == achiev_name then
          
        DbgTrace("name="..tostring(private.achievements.LIST[ i ][ 1 ]).." count="..tostring(ng_global.achievements.custom.no_skip_vid).." count save="..tostring(private.achievements.LIST[ i ][ 3 ]));
        
        if ng_global.achievements.custom.no_skip_vid == private.achievements.LIST[ i ][ 3 ] then

          private.GiveAchiev( achiev_name );
          return;

        end;

      end;

    end;
     
  end;
  --------------------------------------------------------
  ------запускаем секундомер для каждой хо
  function public.PassingHoStart ()  

    local ho_room   = GetCurrentRoom();
    local ho_name   = common.GetObjectName( ho_room );
    local tmr_name  = "tmr_achiev_"..ho_name;

    if ( not ObjGet( tmr_name ) ) then 
   
      ObjCreate( tmr_name, "timer" );
      ObjAttach( tmr_name, ho_room );

      private.achievements[ "count_"..ho_room ] = 0;
      local time_passing = ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].time_passing or 0;        
      ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].time_passing = time_passing;

      ObjSet( tmr_name, { playing = true, time = time_passing, infinite = true } );

    else    

      ObjSet( tmr_name, { playing = true } );

    end;

  end;
  --------------------------------------------------------
  ------запускаем секундомер для каждой мг
  function public.PassingMgStart ( minigame_name )
    
    --ld.PlayAudio( "sfx", "common/audio/aud_mgenter_sfx", 0 );

    local mg_room   = GetCurrentRoom();
    local mg_name   = minigame_name or common.GetObjectName( mg_room );
    local tmr_name  = "tmr_achiev_"..mg_name;
    
    if ( not ObjGet( tmr_name ) ) then   

      ObjCreate( tmr_name, "timer" );
      ObjAttach( tmr_name, mg_room );

      local time_passing = ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].time_passing or 0;
      ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].time_passing = time_passing;  

      ObjSet( tmr_name, { playing = true, time = time_passing, infinite = true } );

    else    

      ObjSet( tmr_name, { playing = true } );

    end;

  end;
  --------------------------------------------------------
  ------проверяем получили ли мы за мг ачивку
  function public.PassingMgWin ( minigame_name )

    
    
    common_impl.PlayAudio( "sfx", "aud_mg_win", 0 );   

    local mg_room   = GetCurrentRoom();
    local mg_name = minigame_name or common.GetObjectName( mg_room );
    
      port.LogEvent("win_"..mg_name, "close", true);
    
    local max_time = 60;
    local tmr_name = "tmr_achiev_"..mg_name;
    
    local time = ObjGet( tmr_name ).time;  
    
    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      private.CountWinMg( mg_name );

      if ( time <= max_time ) and ( not ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].skip_clk ) then   
          
        private.GiveAchiev( "mg_one_min" );
          
      end;

    end;

    ObjDelete( tmr_name );

  end;
  --------------------------------------------------------
  ------стопаем секундомер для каждой мг при выходе из мг
  function public.PassingMgStop ( minigame_name )

     
     
     
    local mg_name = minigame_name or common.GetObjectName( GetCurrentRoom() );
    local tmr_name = "tmr_achiev_"..mg_name;  
    
    port.LogEvent("win_"..mg_name, "close", false);
   
    if ( ObjGet( tmr_name ) ) then

      ng_global.progress[ ng_global.currentprogress ][ "win_"..mg_name ].time_passing = ObjGet( tmr_name ).time;
      ObjSet( tmr_name, { playing = false } );

    end;

  end;

  --------------------------------------------------------
  ------стопаем секундомер для каждой хо при выходе из хо
  function public.PassingHoStop ()

    local ho_name = common.GetObjectName( GetCurrentRoom() );
    local tmr_name = "tmr_achiev_"..ho_name;  

    if ( ObjGet( tmr_name ) ) then

      ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].time_passing = ObjGet( tmr_name ).time;
      ObjSet( tmr_name, { playing = false } );  

    end;

  end;
  --------------------------------------------------------
  ------подбор 3-х объектов ХО за 3 секунды    
  function private.PassingHoGet ()

    local ho_room   = GetCurrentRoom();
    local ho_name   = common.GetObjectName( ho_room );
    local tmr_name  = "tmr_achiev_"..ho_name.."_"..private.achievements[ "count_"..ho_room ]; 

    if ( not ObjGet( tmr_name ) ) then
    
      ObjCreate( tmr_name, "timer" );
      ObjAttach( tmr_name, ho_room );
      
    end; 

    private.achievements[ "count_"..ho_room ] = private.achievements[ "count_"..ho_room ] + 1;
    ObjSet( tmr_name, { playing = true, time = time_passing, infinite = true } );  

  end;
  --------------------------------------------------------
  ------подбор 3-х объектов ХО за 3 секунды   проверка на получение ачивки 
  function private.PassingHoGetCheck ( count_ho_obj, name_achiev )

    local ho_room = GetCurrentRoom();
    local ho_name = common.GetObjectName( ho_room );

    if ( ng_global.achievements[ name_achiev ].done == 0 ) then
      
      if ( count_ho_obj <= private.achievements[ "count_"..ho_room ] ) then
      
        local tmr_name_prev = "tmr_achiev_"..ho_name.."_"..( private.achievements[ "count_"..ho_room ] - count_ho_obj ); 
      
        if ( count_ho_obj == private.achievements[ "count_"..ho_room ] ) then
            
          if ( ObjGet( "tmr_achiev_"..ho_name ).time <= count_ho_obj ) then

            private.GiveAchiev( name_achiev );

          end;
        
        elseif ( ObjGet( tmr_name_prev ).time <= count_ho_obj ) then  
          
          private.GiveAchiev( name_achiev ); 

        end;

      end;

    end;  

  end;
  --------------------------------------------------------
  ------ проверка на получение ачивки при подборе объектов в хо
  function public.PassingHoCheck ()

    if ( ( IsCollectorsEdition() or IsSurveyEdition() ) and ( ng_global.currentprogress ~= "scr" ) ) then

      private.PassingHoGet();--создаем таймер
      private.PassingHoGetCheck( 3, "ho_three_obj_three" );-- проверяем на получение 3 ачивок
      private.PassingHoGetCheck( 5, "ho_five_obj_five" );
      private.PassingHoGetCheck( 10, "ho_ten_obj_ten" );

    end;

  end;
  --------------------------------------------------------
  ------проверяем прошли ли мы хо меньше чем за 3 минуты
  function public.PassingHoWin ()

    private.CountWinHo();

    local ho_name = common.GetObjectName( GetCurrentRoom() );
   
    local max_time    = 3 * 60;   --прохождение хо за 3 мин
    local max_time_2  = 10 * 60;  --прохождение хо больше чем за 10 мин 
    local max_time_3  = 60;       --прохождение хо меньше чем за 10 мин 
    local tmr_name    = "tmr_achiev_"..ho_name;
    
    local time = ObjGet( tmr_name ).time; 
     
    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      --прохождение хо за 3 мин
      if ( time <= max_time ) then

        ng_global.achievements.count.ho_3 = ng_global.achievements.count.ho_3 + 1;           
        private.CheckGiveAchiev( "ho_3" );

      else 
        
        ng_global.achievements.count.ho_3 = 0;

      end;

      --прохождение хо больше чем за 10 мин 
      if time > max_time_2 then        
        
        private.GiveAchiev( "ho_ten_min" );
        
      end;

      --прохождение хо меньше чем за 1 мин 
      if time < max_time_3 then

        private.GiveAchiev( "ho_one_min" );

      end;

    end;

    ObjDelete( tmr_name );

  end;
  --------------------------------------------------------
  function private.Story ( name )

    for i = 1, #private.achievements.LIST do

      local prg_name    = private.achievements.LIST[ i ][ 2 ];
      local achiev_name = private.achievements.LIST[ i ][ 1 ];

      if ( prg_name == name ) then

        private.GiveAchiev( achiev_name ); 

      end;

    end; 

  end;
  --------------------------------------------------------
  function private.CheckStory ( name )

    local find = false;
    
    for i = 1, #private.achievements.LIST do

        local prg_name = private.achievements.LIST[ i ][ 2 ];

        if ( string.find( prg_name, name ) ) then

          find = true;
          break;

        end;

    end;

    if ( find ) then

      return true;

    end;

    return false;

  end;
  --------------------------------------------------------
  ------проверяем получили ли мы за secret room ачивку
  function public.PassingSecretWin ()

    common_impl.PlayAudio( "sfx", "aud_mg_win", 0 );

    private.GiveAchiev( "win_secret_1" ); 
    if ( ng_global.progress[ "secretroom" ].common.btntimer < 720 ) then
      private.GiveAchiev( "win_secret_2" );
    end;

    if ( ng_global.progress[ "secretroom" ].common.btntimer < 420 ) then
      private.GiveAchiev( "win_secret_3" );
    end;

    if ( not ng_global.progress[ "secretroom" ][ "win_secret" ].hint_clk ) then
      private.GiveAchiev( "win_secret_4" );
    end;

  end;
--*********************************************************************************************************************
--***function *** COLLECTIBLES 2 *** () end*****************************************************************************
--*********************************************************************************************************************
  function private.Collectibles2Init ()

    private.collectibles2 = {};
    private.collectibles2.queue = {};
    private.collectibles2.show  = false;

    if not ng_global.collectibles2 then

      ng_global.collectibles2 = {};
      ng_global.collectibles2.count = { 0, 0, 0, 0 };

      local num_collect2_i = 4;
      local num_collect2_j = 5;

      for i = 1, num_collect2_i do 

        for j = 1, num_collect2_j do

          ng_global.collectibles2[ "get_collect2_item_"..i.."_"..j ] = {};
          ng_global.collectibles2[ "get_collect2_item_"..i.."_"..j ].done = false;

        end;

      end;

    end;

    if ( not ObjGet( "tmr_int_collectibles2_give" ) ) then

      ObjCreate( "tmr_int_collectibles2_give", "timer" );

    end;

  end;
  ---------------------------------------------------------
  function public.GetCollect2Done ( event_name )

--    local prg = ng_global.currentprogress;
--    local level = ng_global.progress[ prg ].common.chapter;
--
    if ng_global.progress[ "std" ][ "see_tutorial" ] then

      if ng_global.progress[ "std" ][ "see_tutorial" ].start > 0 then

        common_impl.TutorialShow( "tutorial_page_18" );

      end;

    end;

    common_impl.PlayAudio( "sfx", "aud_clk_morfing", 0, "", 0 );
    --ng_global.collectibles2.coin_count = ng_global.collectibles2.coin_count + 1;
    ng_global.collectibles2[ event_name ].done = true;

    local num_collect2_i = 4;
    local num_collect2_j = 5;

    for i = 1, num_collect2_i do

      local prg = "std";

      if ( i == num_collect2_i ) then

        prg = "ext";

      end;

      for j = 1, num_collect2_j do

        if ( ( ng_global.progress[ prg ][ "get_collect2_item_"..i.."_"..j ] ) and 
             ( ng_global.progress[ prg ][ "get_collect2_item_"..i.."_"..j ].done == 1 ) ) then

          count = count + 1;

        end;

      end;

    end;

    local name = string.sub( event_name, 19, string.len( event_name ) );

    local num = tonumber( string.sub( name, 1, 1 ) );
    ng_global.collectibles2.count[ num ] = ng_global.collectibles2.count[ num ] + 1;

    local name_exist = false;  
    for i = 1, #private.collectibles2.queue do

      if ( private.collectibles2.queue[ i ][ 1 ] == count and 
        private.collectibles2.queue[ i ][ 2 ] == name ) then

        name_exist = true;
        break;

      end;

    end;
    if ( not name_exist ) then
    
      local data = { count, name };
      table.insert( private.collectibles2.queue, data );

      if ( not ObjGet( "tmr_int_collectibles2_give" ).playing ) then

        private.CheckAnimCollect2();

      end;      

    end;

  end;
  ---------------------------------------------------------
  function private.CheckAnimCollect2 ()

    ObjAttach( "tmr_int_collectibles2_give", "cmn_timers" );
    ObjSet("tmr_int_collectibles2_give", { playing = true, time = 0.5, endtrig = private.CheckAnimCollect2 } );

    if ( not private.collectibles2.show ) then

      for i = 1, #private.collectibles2.queue do

        local count = private.collectibles2.queue[ i ][ 1 ];
        local name = private.collectibles2.queue[ i ][ 2 ];

        int_button_collectibles2.Show( count, name );    
        table.remove( private.collectibles2.queue, i );
        break;

      end;

      if ( #private.collectibles2.queue == 0 ) then

        ObjSet("tmr_int_collectibles2_give", { playing = false } );

      end;

    end;

  end;
  ---------------------------------------------------------
  function public.IsGetCollect2 ( event_name )

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      return ng_global.collectibles2[ event_name ].done;

    else

      return true;

    end;

  end;
  ---------------------------------------------------------
  function public.Collectibles2Load ()

    local num_collect2_i = 4;
    local num_collect2_j = 5;

    for i = 1, num_collect2_i do 

      for j = 1, num_collect2_j do

        if ( public.IsGetCollect2( "get_collect2_item_"..i.."_"..j ) ) then

          cmn.CallEventHandler( "get_collect2_item_"..i.."_"..j );

        end;

      end;

    end;

  end;
--*********************************************************************************************************************
--***function *** COLLECTIBLES MORPHING *** () end*********************************************************************
--*********************************************************************************************************************
  function private.CollectiblesInit ()

    private.collectibles = {};
    private.collectibles.queue = {};
    private.collectibles.show  = false;

    if ( not ObjGet( "tmr_int_collectibles_give" ) ) then

      ObjCreate( "tmr_int_collectibles_give", "timer" );

    end;

  end;
  --------------------------------------------------------------------------------------------------------------------
  function public.CollectItemMorphing ()
      
    local room = common.GetObjectName( common.GetCurrentRoom() );
    
    if ( not ObjGet( "obj_"..room.."_collect" ) ) then
      return;
    end;

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      local collect_item = "obj_"..room.."_collect_item";
      local replace_item = "obj_"..room.."_replace_item"; 
      local random_time = math.random( 0, 2 );
      
      ObjSet( collect_item, { alp = 1 } );  
      ObjSet( replace_item, { alp = 0 } );        

      ObjAnimate( collect_item, "alp", 0, 0, function() private.CollectItemActive( collect_item, replace_item ) end, { 
        0, 0, 1,
        random_time + private.COLLECT_ANIM_TIME, 0, 0,
        random_time + private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 0, 0,
        random_time + 2*private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 3, 1 } );

      ObjAnimate( replace_item, "alp", 0, 0, "", { 
        0, 0, 0,
        random_time + private.COLLECT_ANIM_TIME, 0, 1,
        random_time + private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 0, 1,
        random_time + 2*private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 3, 0 } );

    else

      ObjSet( "obj_"..room.."_collect", { visible = false, input = false } );

    end;  

  end;
  --------------------------------------------------------------------------------------------------------------------
  function private.CollectItemActive ( collect_item, replace_item )

    --ObjSet( collect_item, { input = true } ); 
    ObjAnimate( collect_item, "alp", 0, 0, function() public.CollectItemMorphing() end, { 
      0, 3, 1, 
      private.COLLECT_VISIBLE_TIME, 3, 1 } );

    ObjAnimate( replace_item, "alp", 0, 0, "", { 
      0, 3, 0, 
      private.COLLECT_VISIBLE_TIME, 3, 0 } );

  end;
  --------------------------------------------------------------------------------------------------------------------
  function public.GetCollectItem ( event )

    local room = common.GetObjectName( common.GetCurrentRoom() );  
    
    local count_level = 4;
    local count_item = 3;
    local count = 0;
    cmn.SetEventDone( event );  
    
    local replace_item = "obj_"..room.."_replace_item";
    local collect_item = "obj_"..room.."_collect_item";

--    local prg = ng_global.currentprogress;
--    local level = ng_global.progress[ prg ].common.chapter;
--
    if ng_global.progress[ "std" ][ "see_tutorial" ] then

      if ng_global.progress[ "std" ][ "see_tutorial" ].start > 0 then

        common_impl.TutorialShow( "tutorial_page_20" );

      end;

    end;

    ObjStopAnimate( collect_item, "alp" ); 
    ObjStopAnimate( replace_item, "alp" );

    ObjSet( "spr_"..room.."_collect_item", { input = false } );
    ObjSet( collect_item, { alp = 1, input = false } );
    ObjSet( replace_item, { alp = 0 } );
      
    public.PlayEffectHO( "spr_"..room.."_collect_item", 
    function() cmn.CallEventHandler( event ); end )

    --common_impl.CountGetCollect();--achiev

    for i = 1, count_level do

      local prg = "std";
      if ( i == count_level ) then
        prg = "ext";
      end;

      for j = 1, count_item do

        if ( ( ng_global.progress[ prg ][ "get_collect_item_"..i.."_"..j ] ) and 
             ( ng_global.progress[ prg ][ "get_collect_item_"..i.."_"..j ].done == 1 ) ) then
          count = count + 1;
        end;

      end;

    end;

    local name = string.sub( event, 18, string.len( event ) );

    local name_exist = false;  
    for i = 1, #private.collectibles.queue do

      if ( private.collectibles.queue[ i ][ 1 ] == count and 
        private.collectibles.queue[ i ][ 2 ] == name ) then

        name_exist = true;
        break;

      end;

    end;
    if ( not name_exist ) then
    
      local data = { count, name };
      table.insert( private.collectibles.queue, data );

      if ( not ObjGet( "tmr_int_collectibles_give" ).playing ) then

        private.CheckAnimCollect();

      end;      

    end;

  end;
  --------------------------------------------------------------------------------------------------------------------
  function private.CheckAnimCollect ()

    ObjAttach( "tmr_int_collectibles_give", "cmn_timers" );
    ObjSet("tmr_int_collectibles_give", { playing = true, time = 0.5, endtrig = private.CheckAnimCollect } );

    if ( not private.collectibles.show ) then

      for i = 1, #private.collectibles.queue do

        local count = private.collectibles.queue[ i ][ 1 ];
        local name = private.collectibles.queue[ i ][ 2 ];

        int_button_collectibles.Show( count, name );    
        table.remove( private.collectibles.queue, i );
        break;

      end;

      if ( #private.collectibles.queue == 0 ) then

        ObjSet("tmr_int_collectibles_give", { playing = false } );

      end;

    end;    

  end;
  --------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--***function *** COLLECTIBLES 3 *** () end*********************************************************************
--*********************************************************************************************************************
  function private.MorphInit()

      if not ng_global.morph then

        ng_global.morph = {};
        ng_global.morph.objects_count = 0;
           
      end;

  end;
  --------------------------------------------------------
  function public.MorphItemMorphing( )
      
    local room = common.GetObjectName( common.GetCurrentRoom() );
    
    if ( not ObjGet( "obj_"..room.."_morph" ) ) then
      return;
    end;

    if ( IsCollectorsEdition() or IsSurveyEdition() ) then

      local collect_item = "obj_"..room.."_collect_morph_item";
      local replace_item = "obj_"..room.."_replace_morph_item"; 
      local random_time = math.random( 0, 2 );

      ObjSet( collect_item, { alp = 1, input = true } ); 
      ObjSet( replace_item, { alp = 0 } );

      ObjAnimate( collect_item, "alp", 0, 0, function() private.MorphItemActive( collect_item, replace_item ) end, 
      { 
        0, 0, 1,
        random_time + private.COLLECT_ANIM_TIME, 0, 0,
        random_time + private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 0, 0,
        random_time + 2*private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 3, 1 
      } );

      ObjAnimate( replace_item, "alp", 0, 0, "", { 
        0, 0, 0,
        random_time + private.COLLECT_ANIM_TIME, 0, 1,
        random_time + private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 0, 1,
        random_time + 2*private.COLLECT_ANIM_TIME + private.COLLECT_VISIBLE_TIME, 3, 0 } );

    else

      ObjSet( "obj_"..room.."_morph", { visible = false, input = false } );

    end;  

  end;
  --------------------------------------------------------------------------------------------------------------------
  function private.MorphItemActive( collect_item, replace_item )

    --ObjSet( collect_item, { input = true } ); 
    ObjAnimate( collect_item, "alp", 0, 0, function() public.MorphItemMorphing() end, { 
      0, 3, 1, 
      private.COLLECT_VISIBLE_TIME, 3, 1 } );

    ObjAnimate( replace_item, "alp", 0, 0, "", { 
      0, 3, 0, 
      private.COLLECT_VISIBLE_TIME, 3, 0 } );

  end;
  --------------------------------------------------------------------------------------------------------------------
  function public.GetMorphItem( event )

--    local prg = ng_global.currentprogress;
--    local level = ng_global.progress[ prg ].common.chapter;
--
    if ng_global.progress[ "std" ][ "see_tutorial" ] then

      if ng_global.progress[ "std" ][ "see_tutorial" ].start > 0 then

        local prg = ng_global.currentprogress;
        if ng_global.progress[ prg ].common.chapter == "level1" then

          common_impl.TutorialSetShown( "tutorial_page_24" );

        end;

        common_impl.TutorialShow( "tutorial_page_19" );

      end;

    end;

    public.CountGetMorphCollect();

    local count_level = 4;
    local count_item = 7;
    local count = 0;
    cmn.SetEventDone( event );  

    local room = common.GetObjectName( common.GetCurrentRoom() );
    local collect_item = "obj_"..room.."_collect_morph_item";
    local replace_item = "obj_"..room.."_replace_morph_item";

    ObjStopAnimate( collect_item, "alp" ); 
    ObjStopAnimate( replace_item, "alp" );

    ObjSet( collect_item, { alp = 1, input = false } );
    ObjSet( replace_item, { alp = 0 } );
      
    public.PlayEffectHO( "spr_"..room.."_collect_morph_item", 
    function() cmn.CallEventHandler( event ); end )

    --common_impl.CountGetCollect();--achiev

    for i = 1, count_level do

      local prg = "std";
      if ( i == count_level ) then
        prg = "ext";
      end;

      for j = 1, count_item do

        if ( ( ng_global.progress[ prg ][ "get_collect_morph_item_"..i.."_"..j ] ) and 
             ( ng_global.progress[ prg ][ "get_collect_morph_item_"..i.."_"..j ].done == 1 ) ) then
          count = count + 1;
        end;

      end;

    end;

    common_impl.PlayAudio( "sfx", "aud_clk_morph_object", 0, "", 0 );
    int_button_morph.Show( count );  


  end;
--*********************************************************************************************************************
--***function *** EFFECT HO *** () end*****************************************************************************
--*********************************************************************************************************************
  function public.PlayEffectHO ( object_name, func_end )
    
    ObjSet( object_name, { input = false } );
    local pos = GetObjPosByObj( object_name, InterfaceWidget_Top_Name );
    local drawoff_x = ObjGet( object_name ).drawoff_x;
    local drawoff_y = ObjGet( object_name ).drawoff_y;
    
    local partsys_name  = "pfx_effect_ho_"..object_name;

    ObjAttach( object_name, InterfaceWidget_Top_Name );
    ObjSet( object_name, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );
    
    ObjCreate( partsys_name, "partsys" );
    
    ObjSet( partsys_name,
    {
      res = "assets/interface/resources/effects_ho",
      pos_x = drawoff_x, pos_y = drawoff_y,
      input = false, pos_z = 10, blendmode = 2
    } );
    
    ObjAttach( partsys_name, InterfaceWidget_Top_Name );
    
    PartSysSetMaskObj( partsys_name, object_name ); 

    local func = function()

      if ( func_end ) then
        func_end();
      end;
      ObjDelete( partsys_name );
      ObjDelete( object_name );

    end; 

    ObjAnimate( object_name, "alp", 0, 0, func,
    { 
        0.0, 0, 1,
        0.3, 0, 0      
    } );

  end;
--*********************************************************************************************************************
--***function *** DIARY *** () end*****************************************************************************
--*********************************************************************************************************************
  function public.AddPageDiary( name_page )
   
    local prg  = ng_global.currentprogress;
    local num = tonumber( name_page );

    ng_global.progress[ prg ].common.diary.last_page = ng_global.progress[ prg ].common.diary.last_page + 1;
    ng_global.progress[ prg ].common.diary.current = math.ceil( ng_global.progress[ prg ].common.diary.last_page / 2 );
    ng_global.progress[ prg ].common.diary.pages[ ng_global.progress[ prg ].common.diary.last_page ] = num;

  end;
  --------------------------------------------------------
  function public.AddBookmarkDiary( bookmark_number, photo_number, page_content )
    
    local prg  = ng_global.currentprogress;
    
    if ng_global.progress[ prg ].common.diary.bookmarks[bookmark_number] == nil then    
      ng_global.progress[ prg ].common.diary.bookmarks[bookmark_number] = {};     
    end;  
   
    ng_global.progress[ prg ].common.diary.bookmarks[bookmark_number][photo_number] = page_content;
    
  end;
--**************************************************************************************************************
--***function *** TEXT *** () end*******************************************************************************
--**************************************************************************************************************
  function public.PrintText ( obj, text_id, time, func_end )
    
    table.insert( private.print, { time = time or 3, text_id = text_id, obj = obj, func_end = func_end } );
    ObjCreate( "tmr_"..obj, "timer" );
    ObjSet( "tmr_"..obj, { input = false, disprawtext = true } );
    ObjAttach( "tmr_"..obj, obj );
    private.ShowLetter( 1, private.print[ #private.print ] );

  end;
  ---------------------------------------------------------
  function private.ShowLetter ( number, print )

    common_impl.PlayAudio( "sfx", "aud_type", 0, "", 0 );

    number = tonumber( number );    
    local text = StringGet( print.text_id );
    local length = string.len( text );
    if ( number <= length ) then  

      local time = print.time / length;
      local text_sub = string.sub( text, 1, number );    
      ObjSet( print.obj, { text = text_sub } );    
      ObjSet( "tmr_"..print.obj, { 
        time = time,
        endtrig = function() private.ShowLetter( number + 1, print ); end, 
        playing = 1 } );    

    else

      public.ShowText( print.obj )

    end; 
   
  end;
  ---------------------------------------------------------
  function public.ShowText ( obj )

    common_impl.StopAudio( "sfx", "aud_type", 0.2 );

    local print = nil;
    for i = 1, #private.print do

      if ( obj == private.print[ i ].obj ) then

        print = private.print[ i ]; 
        table.remove( private.print, i );      
        break;

      end;

    end;

    if ( print ) then

      ObjDelete( "tmr_"..obj ); 
      common_impl.StopAudio( "sfx", "common/audio/aud_global_task_print", 0 );
      if ( print.func_end ) then
        print.func_end();
      end;    
      ObjSet( obj, { text = print.text_id, disprawtext = false } );     

    end;

  end;
--**************************************************************************************************************
--***function *** CUSTOM GFX *** () end*************************************************************
--***************************************************************************************************************
  function private.GetAllGfx( mas_obj, table_gfx )
   
   local func_get_gfx;

    func_get_gfx = function ( obj )
    
      local rel = ObjGetRelations( obj ).childs;

       if rel ~= nil then

         for i = 1, #rel do

           if common.GetObjectPrefix( rel[i] ) == "gfx" then

             table.insert( table_gfx, rel[i] );

          end;

           func_get_gfx( rel[i] );

         end;

       end;

    end;
    
    for i = 1, #mas_obj do
      
      func_get_gfx( mas_obj[i] );

    end;

  end;
  --***************************************************************************************************************
  function private.TurnMasGfx( table_gfx, state )

    local table_multiset = {};
    
    if ( state ) then

      for i = 1, #table_gfx do

        table.insert( table_multiset, { table_gfx[i], { res = "assets/levels/common/fx/sparkle_effect" } } );

      end;
    
    else

      for i = 1, #table_gfx do

        table.insert( table_multiset, { table_gfx[i], { res = "assets/levels/common/fx/sparkle_empty" } } );

      end;  
      
    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;
    
  end;
  --***************************************************************************************************************
  function public.TurnChildGfx( mas_parent, rm_name, state )

    if not public[rm_name] then 

      public[rm_name] = {};

    end;
    
    if not public[rm_name].AllGfx then 

      public[rm_name].AllGfx = {};
      private.GetAllGfx( mas_parent, public[rm_name].AllGfx );
      private.TurnMasGfx( public[rm_name].AllGfx, state );

    else

      private.TurnMasGfx( public[rm_name].AllGfx, state );

    end;


  end;
--**************************************************************************************************************
--***function *** OTHER *** () end******************************************************************************
--**************************************************************************************************************
  -- заблокировать(true), разблокировать(false)
  function public.Lock( state )

    -- разблокировать  
    if ( not state ) then
      interface.LockHide();
    -- заблокировать
    else
      interface.LockShow();
    end;

  end;
  --*********************************************************************************************************************
  function public.UseItem(funcs)

    --DeleteFx();

    for id, func in pairs( funcs ) do

      if( func() ) then

        break;

      end;
      
    end;
    
  end;
  --*********************************************************************************************************************
  function public.ShowBbt( bbt_text, bbt_cnt, bbt_rnd )

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "text" ] ) then    
      return;
    end; 

    local txtout = bbt_text;
    local cnt = 1;
    local rnd = false;

    local postfix = "";
    local prg = ng_global.currentprogress;

    -- если нет массива
    if not ng_global.bbt then
      ng_global.bbt = {};
    end;
    
    if not ng_global.bbt[txtout] then
      ng_global.bbt[txtout] = 1;
    end;
      
    if prg == "ext" then

      postfix = "_ce";

    elseif prg == "scr" then
      
      postfix = "_sc";
      
      if string.format(txtout..postfix) == StringGet(txtout..postfix) then
        postfix = "_ce";
      end;
    end;
    
    
    
    -- получаем количество
    if bbt_cnt then
      cnt = tonumber(bbt_cnt);
    end;
    if bbt_rnd then
      rnd = true;
    end;

    -- если много
    if cnt > 1 then
      -- если еще нет записи в массиве
      if not ng_global.bbt[txtout] then
        ng_global.bbt[txtout] = 1;
      end;
      -- без рандома
      if not rnd then
        interface.BBTShow(txtout.."_"..ng_global.bbt[txtout]..postfix);
        -- увеличиваем/сбрасываем счетчик
        if ng_global.bbt[txtout] == cnt then
          ng_global.bbt[txtout] = 1;
        else
          ng_global.bbt[txtout] = ng_global.bbt[txtout] + 1;
        end;
      -- рандом
      else
        local new_bbt = ng_global.bbt[txtout];
        --DbgTrace("old "..new_bbt);
        while (new_bbt == ng_global.bbt[txtout]) do
          new_bbt = math.random(1,cnt);
          --DbgTrace("new "..new_bbt);
        end;
        ng_global.bbt[txtout] = new_bbt;
        --DbgTrace("fin "..ng_global.bbt[txtout]);
        interface.BBTShow(txtout.."_"..ng_global.bbt[txtout]..postfix);
      end;
    else
      interface.BBTShow(txtout..postfix);
    end;

  end;
  --*********************************************************************************************************************
  function public.ApplyObj( objname, toobjname )

    local obj = common.GetObjectName( GetCurrentRoom() );

    if ( int_deploy_inv ) then
      return ( common.ApplyObj( objname, toobjname ) and ( not ( public.note[ obj ] and public.note[ obj ].open ) ) and not int_deploy_inv.IsOnScreen() )
    else
      return ( common.ApplyObj( objname, toobjname ) and ( not ( public.note[ obj ] and public.note[ obj ].open ) ) )
    end;

  end;
  --*********************************************************************************************************************
  function public.WrongApply()

    local txtout = "bbt_wrongapply";
    local cnt = 4;
    local sound_cnt = 3

    public.CheckGiveCustomAchiev ( "wrong_apply" )-- получение ачивки за неправильное применение

    if not ng_global.wrongapply then
      ng_global.wrongapply = {};
    end;
    
    local new_wrongapply = ng_global.wrongapply[txtout];
    local new_sound = math.random(1,3);

    while (new_wrongapply == ng_global.wrongapply[txtout]) do
      new_wrongapply = math.random(1,cnt);
    end;

    ng_global.wrongapply[txtout] = new_wrongapply;
    interface.BBTShow(txtout.."_"..ng_global.wrongapply[txtout]);

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

  end;
 --*********************************************************************************************************************
  function private.GetInvObjectSfx ()

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );
    
  end;
--**********************************************************************************************************************
  function public.ItemFly( obj, func, angle, distance, scale, time )
    
    --angle    = angle or 0.0;
    distance = distance or 150;
    scale    = scale or 1;
    time     = time or 1;

    if not angle then

      distance = 0;
      time = 0.3
      angle = 0.0;

    end;
    
    local x_end = ObjGet( obj ).pos_x;
    local y_end = ObjGet( obj ).pos_y;
    local x_start = x_end + distance * math.sin( angle );
    local y_start = y_end - distance * math.cos( angle );

    local func_end = function ()

      if func then

        func();

      end;

    end;

    ObjSet( obj, {

      alp = 0,
      pos_x = x_start,
      pos_y = y_start,
      visible = 1,
      active = 1,
      scale_x = scale,
      scale_y = scale

    } );

    ObjAnimate( obj, "pos_xy", 0, 0, func_end, { 0, 0, x_start, y_start,  time, 2, x_end, y_end } );
    ObjAnimate( obj, "alp", 0, 0, "", { 0,0,0,  time*0.3,0,1,  time,0,1 } );
    ObjAnimate( obj, "scale_xy", 0, 0, "", { 0,2,scale,scale,  time,2,1,1 } );
    
  end;
--**********************************************************************************************************************
  function public.AnimForCur ( anim_obj, x, y )

    local dx = ( 1366 - GetAppWidth() ) / 342;

    local xy = GetZoomCursorPos();
    x = x + ( ( ( xy[ 1 ] - 512 ) / GetAppWidth()) - x ) / 16;
    y = y + ( ( ( xy[ 2 ] - 384) / 768 ) - y ) / 16;

    for i = 1, #anim_obj, 1 do

      local obj = anim_obj[ i ][ 1 ];
      local x_start = anim_obj[ i ][ 2 ];
      local y_start = anim_obj[ i ][ 3 ];
      local k = anim_obj[ i ][ 4 ];
      ObjSet( obj, { pos_x = x_start + dx * anim_obj[ i ][ 5 ] + x * k * 3 } );
      ObjSet( obj, { pos_y = y_start + y * k } );

    end;

    return { x, y }

  end;
--**********************************************************************************************************************
  function public.EnterRmWithoutInterface( rm_name )

    local mas_widgets = {

      InterfaceWidget_BtnMenu
      ,InterfaceWidget_BtnHint
      ,InterfaceWidget_BtnSkip
      ,InterfaceWidget_BtnInfo
      ,InterfaceWidget_BtnReset
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_TaskPanel
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_DialogHo
      ,InterfaceWidget_ItemPanel 
      ,InterfaceWidget_Popup
      ,InterfaceWidget_Window
      ,InterfaceWidget_Map
      ,InterfaceWidget_Deploy_Inv
      ,InterfaceWidget_Dialog_Hint

    };

    if IsCollectorsEdition() then

      table.insert( mas_widgets, InterfaceWidget_BtnGuide );
      table.insert( mas_widgets, InterfaceWidget_collectibles2 );
      table.insert( mas_widgets, InterfaceWidget_collectibles );
      table.insert( mas_widgets, InterfaceWidget_achievements );
      table.insert( mas_widgets, InterfaceWidget_morph );

    end;

    local prg = ng_global.currentprogress;

    if ng_global.progress[ prg ].common.chapter == "levelext" then

      table.insert( mas_widgets, InterfaceWidget_Slider );

    end;

    for i = 1, #mas_widgets do

      interface.WidgetSetVisible( mas_widgets[i], false, true );   
      interface.WidgetSetInput( mas_widgets[i], false );    

    end;

    if string.find( common.GetCurrentRoom(), "ho_" ) then
      ObjSet( "obj_int_inventory_impl_root", { visible = false, input = false } );
    end;

    if  port.tutorial_active == true then
      DbgTrace("tutorial_active");
      int_tutorial.MouseDown('yes');
    end;
  
    common.GotoRoom( rm_name, 0, true );

  end;
--**********************************************************************************************************************
  function public.ExitRmWithoutInterface()

    local mas_widgets = {

      InterfaceWidget_BtnMenu
      ,InterfaceWidget_BtnHint
      ,InterfaceWidget_BtnSkip
      ,InterfaceWidget_BtnInfo
      ,InterfaceWidget_BtnReset
      ,InterfaceWidget_Inventory
      ,InterfaceWidget_TaskPanel
      ,InterfaceWidget_BtnMap
      ,InterfaceWidget_DialogHo
      ,InterfaceWidget_ItemPanel 
      ,InterfaceWidget_Popup
      ,InterfaceWidget_Window
      ,InterfaceWidget_Map
      ,InterfaceWidget_Deploy_Inv
      ,InterfaceWidget_Dialog_Hint

    };

    if IsCollectorsEdition() then

      table.insert( mas_widgets, InterfaceWidget_BtnGuide );
      table.insert( mas_widgets, InterfaceWidget_collectibles2 );
      table.insert( mas_widgets, InterfaceWidget_collectibles );
      table.insert( mas_widgets, InterfaceWidget_achievements );
      table.insert( mas_widgets, InterfaceWidget_morph );

    end;

    local prg = ng_global.currentprogress;

    if ng_global.progress[ prg ].common.chapter == "levelext" then

      table.insert( mas_widgets, InterfaceWidget_Slider );

    end;

    for i = 1, #mas_widgets do

      interface.WidgetSetVisible( mas_widgets[i], true, true );   
      interface.WidgetSetInput( mas_widgets[i], true );    

    end;

    if string.find( common.GetCurrentRoom(), "ho_" ) then
      ObjSet( "obj_int_inventory_impl_root", { visible = true, input = true } );
    end;

  end;
--**************************************************************************************************************
--*********************************************************************************************************************
--***function *** IOS_fucntion *** () end******************************************************************************
--*********************************************************************************************************************



  ObjAttach( "obj_port_tap_down"       ,"ng_level" );
  ObjAttach( "tmr_port_tap_down"       ,"ng_level" );
  ObjAttach( "tmr_common_forbidscale"  ,"ng_level" );
  ObjAttach( "tmr_port_bbt"  ,"ng_level" );

  port = {};
  port.ios = {};
  port.android = {};

  port.tutorial_active = false;
  port.ActiveDialogVideoname = nil;
  
  ---------------------------------
  -----| Это читор для АйОсь |-----
  ---------------------------------
  
  --ModLoad( "assets/levels/common/cheater_ios/mod_cheater_ios" );
  --cheater_ios.Init();
  
  ---------------------------------
  ---------------------------------
  ---------------------------------
  --
  function port.isPortable()

    local isPortable = 1;
    --включение и выкл. ios & android режима

    if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      isPortable = 1;
    end;

    return isPortable;

  end;
---------------------------------

  function port.isTablet()

    local isTablet = 0;
    if IsIpad() == true then  
      isTablet = 1;
    else
      isTablet = 0;
    end;

    
    return isTablet;

  end;


-------------------------------------------------------------
  port.lang_array = {
    "en",
    "ru",
    "de",
    "fr"
  };
-------------------------------------------------------------
  function port.ios_lang()

    local lang = "en";
    
    if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      lang = iOS_GetLang();
    end;
    
    local check = false;
    
    for i=1,#port.lang_array do
      if lang == port.lang_array[i] then check = true; break; end;
    end;
    
    if check ~= true then
      lang = "en";
    end;
    
    return lang;
  end;

-------------------------------------------------------------



  function port.TapDown(tmr)

    local timer = tmr; 
    if timer == "" then
      timer = 0.7
    end;
    ObjSet( "obj_port_tap_down", { input = 1 } );
    ObjSet( "tmr_port_tap_down", { time = timer, playing = 1, endtrig = function() port.TapDownEnd(); end  } );

  end;
------------------------------------------------------------

  function port.TapDownEnd()

    ObjSet( "obj_port_tap_down", { input = 0 } );

  end;

--------------------------------------------------------------
  port.list_video_resize =
  {
   { "level1_inv"     ,{ "vid_deploy_inv_bottle_use_hammer", "1"} ,{ "vid_deploy_inv_saucepan_use_gypsum", "1"} ,{ "vid_deploy_inv_codedpaper_developingliquid", "1"} }
  ,{ "bar"     ,{ "vid_bar_rm_sec_cam", "1"} ,{ "vid_bar_terence", "1.333"} ,{ "vid_bar_close_door", "1.333"} }
  ,{ "car"     ,{ "vid_car_bodyguard", "1.333"} ,{ "vid_car_trip", "1.333"} }
  ,{ "corridor"     ,{ "vid_corridor_outro", "1.333"} }
  ,{ "courtyard"     ,{ "vid_courtyard_flashback_courtyard", "1.333"} ,{ "vid_courtyard_terenec", "1.333"} ,{ "vid_chemicalsshelf_water_green", "1"} ,{ "vid_chemicalsshelf_water_red", "1"} ,{ "vid_floormechanism_water", "1"} ,{ "vid_floormechanism_antirust", "1"} }
  ,{ "hall"     ,{ "vid_hall_disappearance_professor", "1.333"} ,{ "vid_hall_flashback_hall", "1.333"} ,{ "vid_hall_door_open", "1.333"} ,{ "vid_hall_masked_man_1", "1.333"} ,{ "vid_reception_boxwrench", "1"} ,{ "vid_windowsill_hexagon2", "1"} ,{ "vid_lampwall_screwdriver", "1"} ,{ "vid_bodyguardthings_water", "1"} }
  ,{ "lounge"     ,{ "vid_lounge_masked_man_3", "1.333"} ,{ "vid_washbasin_water_light", "1"} ,{ "vid_washbasin_screwdriver", "1"} ,{ "vid_washbasin_water_sink", "1"} }
  ,{ "park_1"     ,{ "vid_park_1_intro", "1.333"} ,{ "vid_park_1_attempt", "1.333"} ,{ "vid_park_1_use_gloves", "1"} }
  ,{ "park_2"     ,{ "vid_park_2_professor_escape", "1.333"} }
  ,{ "porch"     ,{ "vid_porch_screaming_bodyguard", "1.333"} ,{ "vid_porch_leave_bodyguard", "1.333"} }
  ,{ "archivedata"     ,{ "vid_archivedata_terenec", "1.333"} }
  ,{ "archives"     ,{ "vid_archives_outro_lvl2", "1.333"} ,{ "vid_surveillancecamera_hexkey", "1"} }
  ,{ "childrensroom"     ,{ "vid_dollhouse_antirust", "1"} ,{ "vid_parm_tv_noise", "1"} ,{ "vid_parm_masked_man", "1"} ,{ "vid_pram_scorpion", "1"} }
  ,{ "corridorelevator"     ,{ "vid_corridorelevator_corridorelevator_2", "1.333"} ,{ "vid_corridorelevator_flashback_douglas", "1.333"} ,{ "vid_utilityroom_cogwheel", "1"} }
  ,{ "courtyard_2"     ,{ "vid_courtyard_2_courtyard_3", "1.333"} }
  ,{ "lab"     ,{ "vid_lab_gas_1", "1"} ,{ "vid_lab_gas_2", "1"} ,{ "vid_lab_gas_3", "1"} ,{ "vid_distillatingstill_hexkey", "1"} }
  ,{ "lowerlevel"     ,{ "vid_lowerlevel_masked_man", "1.333"} ,{ "vid_lowerlevel_in_refrigerator", "1.333"} ,{ "vid_lowerlevel_hospital_bed_move", "1.333"} ,{ "vid_receptiondesk_antirust", "1"} ,{ "vid_darkcorner_rat", "1"} ,{ "vid_darkcorner_med_clip", "1"} }
  ,{ "receptionroom"     ,{ "vid_receptionroom_horror", "1.333"} ,{ "vid_ratcage_rat_dissappear", "1"} }
  ,{ "archives_3"     ,{ "vid_archives_3_intro", "1.333"} }
  ,{ "examroom"     ,{ "vid_examroom_noise", "1"} ,{ "vid_examroom_net", "1"} ,{ "vid_examroom_monitors_threat_professor", "1.333"} ,{ "vid_monitors_tv_noise", "1"} ,{ "vid_monitors_tv_noise_1", "1"} ,{ "vid_monitors_tv_noise_1", "1"} ,{ "vid_monitors_fork", "1"} }
  ,{ "powerunit"     ,{ "vid_cordedphone_key", "1"} ,{ "vid_cordedphone_pliers", "1"} }
  ,{ "secondfloor"     ,{ "vid_secondfloor_neutralization_2_zap", "1"} ,{ "vid_secondfloor_neutralization_2_zap", "1"} ,{ "vid_secondfloor_terence_loop", "1"} ,{ "vid_secondfloor_fire_loop", "0.945"} ,{ "vid_secondfloor_scare_1", "1.333"} ,{ "vid_secondfloor_terence_appear", "1.333"} ,{ "vid_secondfloor_terence_in_foam", "1.333"} ,{ "vid_secondfloor_neutralization_terence", "1.333"} }
  ,{ "terenceroom"     ,{ "vid_terenceroom_scare_1", "1.333"} ,{ "vid_terenceroom_crack_glass", "1.333"} ,{ "vid_bed_scissors", "1"} ,{ "vid_medicinecabinet_mechanism", "1"} ,{ "vid_showerroom_use_oiler", "1"} }
  ,{ "tortureroom"     ,{ "vid_tortureroom_outro_1", "1.333"} ,{ "vid_tortureroom_outro_2", "1.333"} ,{ "vid_monitorscreen_hammer", "1"} }
  ,{ "ventilationshaft"     ,{ "vid_rustywall_jack", "1"} ,{ "vid_screw_key", "1"} }
  ,{ "apartment"     ,{ "vid_apartment_intro", "1.333"} ,{ "vid_apartment_see_taxi", "1.333"} ,{ "vid_shoeshelf_oil", "1"} }
  ,{ "cafe"     ,{ "vid_cafe_leave_josh_fraser", "1.333"} }
  ,{ "nearcafe"     ,{ "vid_nearcafe_grill_fire_loop", "0.28"} ,{ "vid_grill_fire_loop", "1"} ,{ "vid_grill_use_zip", "1"} }
  ,{ "parkinglot"     ,{ "vid_parkinglot_trip", "1.333"} ,{ "vid_billboard_oil", "1"} }
  ,{ "porch_ext"     ,{ "vid_porch_ext_paper", "1"} ,{ "vid_porch_ext_frontdoor", "1.333"} }
  ,{ "terenceroom_ext"     ,{ "vid_terenceroom_ext_outro_ext", "1.333"} ,{ "vid_terenceroom_ext_fraiser_away_2", "1.333"} }
  ,{ "minelabyrinth_scr"     ,{ "vid_minelabyrinth_scr_exit", "0.7"} ,{ "vid_minelabyrinth_scr_exit_2", "0.7"} }
  ,{ "intro"     ,{ "vid_intro_video", "1.333"} }
  };


  function port.VideoResizeInRoom(room_object)

    local room_current = room_object;
    --DbgTrace("resize room = "..room_object);
    local room_name = room_current;
    if room_current ~= "levelext_inv" and 
       room_current ~= "level1_inv" and 
       room_current ~= "level2_inv" and 
       room_current ~= "level3_inv" then
      room_name = string.sub(room_current,4);
    end;
    local count_room = #port.list_video_resize;
    
    for i=1,#port.list_video_resize do
      if room_name == port.list_video_resize[i][1] then
        --DbgTrace("port.list_video_resize[i][1]="..port.list_video_resize[i][1]);
        for j=2,#port.list_video_resize[i] do
          if ObjGet(port.list_video_resize[i][j][1]) then
            --DbgTrace("port.list_video_resize[i][j][1]="..port.list_video_resize[i][j][1]);
            --DbgTrace("port.list_video_resize[i][j][2]="..port.list_video_resize[i][j][2]);
            local scaleObj = tostring(ObjGet(port.list_video_resize[i][j][1]).scale_x);
            local scaleInTable = port.list_video_resize[i][j][2];
            if string.len(scaleObj) > 3 then
              scaleObj = string.sub(scaleObj,1,3);
            end;
            if string.len(scaleInTable) > 3 then
              scaleInTable = string.sub(scaleInTable,1,3);
            end;
            --DbgTrace("scaleObj="..scaleObj);
            --DbgTrace("scaleInTable="..scaleInTable);
            if  scaleObj == scaleInTable then
              --DbgTrace("resize video="..port.list_video_resize[i][j][1]);
              ObjSet(port.list_video_resize[i][j][1],{ scale_x = ObjGet(port.list_video_resize[i][j][1]).scale_x*2, scale_y = ObjGet(port.list_video_resize[i][j][1]).scale_y*2 });
              if (ObjGet(port.list_video_resize[i][j][1]).drawoff_x ~= 0) then
                ObjSet(port.list_video_resize[i][j][1],{ drawoff_x = ObjGet(port.list_video_resize[i][j][1]).drawoff_x/2 });
              end;    
              if (ObjGet(port.list_video_resize[i][j][1]).drawoff_y ~= 0) then
                ObjSet(port.list_video_resize[i][j][1],{ drawoff_y = ObjGet(port.list_video_resize[i][j][1]).drawoff_y/2 });
              end;
            end;
          end;
        end;
        break;
      end;
    end;
  end;

--------------------------------------------------------------
  port.logevent_array = {};
  port.skip_mg = false;

  function port.LogEvent(event_name, status, win)
    
    local check_event = true;
    local win_check = win or "close"; 
    local name = string.sub(event_name,5,string.len(event_name));

    if #port.logevent_array > 0 then
      for i=1,#port.logevent_array do
        if port.logevent_array[i] == string.format("%s%s%s",event_name,status,tostring(win_check)) then
          check_event = false;
        end;
      end;
    end;

    --DbgTrace("port.LogEvent");
    if check_event then
      
      port.logevent_array[#port.logevent_array] = string.format("%s%s%s",event_name,status,tostring(win_check));
      
      --DbgTrace("port.LogEvent event_name = "..event_name.." || status = "..status.." || name = "..name);

      local current_room = GetCurrentRoom();
      
      local prefix = string.sub(current_room,0,2);
      --DbgTrace("current_room="..current_room.." prefix="..prefix);
      if prefix == "mg" or prefix == "rm" then 
        --DbgTrace("prefix = "..prefix);
        if status == "open" then
          --DbgTrace("mg_"..name.." open");
          iOS_LogEvents(5, "mg_"..name );
        else
                if win_check then
                  if win_check == true or win_check == 1 then

                        if port.skip_mg then
                          iOS_LogEvents(7, "mg_"..name );
                          --DbgTrace("skip_win");
                          port.skip_mg = false;
                        else
                          iOS_LogEvents(6, "mg_"..name );
                          --DbgTrace("win_win");
                        end;
                      
                  else 
                        --DbgTrace("mg no_win");
                  end;
                else
                      --DbgTrace("mg no_win");
                end;


        end;

      end;
      if prefix == "ho" then 
        --DbgTrace("prefix = "..prefix);
        if status == "open" then
          --DbgTrace("ho_open");
          iOS_LogEvents(12, "ho_"..name );
        else
          --DbgTrace("ho_close win");
          iOS_LogEvents(13, "ho_"..name );
        end;      
      end;

    end;

  end;

--------------------------------------------------------------
  function port.InventoryPopupInit( name )
    
    local name_obj = name or "";
    
      local objs_child = ObjGetRelations( name_obj );
      
      for i=1,#objs_child.childs do
          
          if ObjGet(objs_child.childs[i]).event_mdown then 
            local obj_down = ObjGet(objs_child.childs[i]).event_mdown;      
            ObjSet(objs_child.childs[i],{ event_menter = "", event_mleave = "", event_mdown =  function() port.ShowPopUp(objs_child.childs[i]); obj_down(); end });
          else
            ObjSet(objs_child.childs[i],{ event_menter = "", event_mleave = "", event_mdown = function() port.ShowPopUp(objs_child.childs[i]); end });
          end;
      end;
    
    
  end;
  
  port.active_popup = false;
  --------------------------------------------------------------
  function port.ShowPopUp(name_obj)
      
      port.active_popup = true;
      
      local name = string.sub(name_obj,5);
      
      if name == "mapsheet_2" then
        name = "mapsheet";
      elseif name == "glassfigurine_2" then
        name = "glassfigurine";
      elseif name == "glassfigurine" then
        name = "glassfigurine";
      end;
      
      public.PopupShow(name);
      

      local timer = 2;
      local room = common.GetCurrentRoom();
      if "ho" == common.GetObjectPrefix( room ) then
        timer = 0.5;
      end;     
    
      ObjSet( "tmr_port_tap_down", { endtrig = function() port.active_popup = false; interface.PopupHide(); end, time = timer, playing = 1 } );
  end;
-----------------------------------------------------------------
  function port.DebugEndTimer()

  DbgTrace("DebugEndTimer");

  end;

------------------------------------------------------------------------------------

--
  port.list_gates_1 =
  {
    { "ho_suitcase"           ,"grm_suitcase_park_1_focus"                  ,1 }
   ,{ "ho_floorhole"          ,"grm_floorhole_lounge_focus"                 ,1 }
   ,{ "ho_stash"              ,"grm_stash_lounge_focus"                     ,1 }
   ,{ "mg_panel"              ,"grm_panel_bar_focus"                        ,1 }
   ,{ "mg_superpuzzle1"       ,"grm_superpuzzle1_bar_focus"                 ,1 }
   ,{ "rm_park_1"             ,"grm_park_1_park_2_focus"                    ,0 }
   ,{ "rm_park_2"             ,"grm_park_2_park_1_focus"                    ,1 }
   ,{ "rm_park_2"             ,"grm_park_2_car_focus"                       ,0 }
   ,{ "rm_car"                ,"grm_car_porch_focus"                        ,1 }
   ,{ "rm_porch"              ,"grm_porch_hall_focus"                       ,0 }
   ,{ "rm_hall"               ,"grm_hall_porch_focus"                       ,1 }
   ,{ "rm_hall"               ,"grm_hall_courtyard_focus"                   ,0 }
   ,{ "rm_bar"                ,"grm_bar_courtyard_focus"                    ,1 }
   ,{ "rm_bar"                ,"grm_bar_corridor_focus"                     ,0 }
   ,{ "rm_courtyard"          ,"grm_courtyard_hall_focus"                   ,1 }
   ,{ "rm_courtyard"          ,"grm_courtyard_lounge_focus"                 ,0 }
   ,{ "rm_courtyard"          ,"grm_courtyard_bar_focus"                    ,0 }
   ,{ "rm_lounge"             ,"grm_lounge_courtyard_focus"                 ,1 }
  };                                                                          
  --
  --
  --
  port.list_gates_2 =
  {
    { "ho_archivedata"         ,"grm_archivedata_archives_focus"            ,1 }
   ,{ "ho_experimentroom"      ,"grm_experimentroom_lab_focus"              ,1 }
   ,{ "ho_indollhouse"         ,"grm_indollhouse_childrensroom_focus"       ,1 }
   ,{ "mg_distillatingstill"   ,"grm_distillatingstill_lab_focus"           ,1 }
   ,{ "mg_metalcases"          ,"grm_metalcases_corridorelevator_focus"     ,1 }
   ,{ "mg_superpuzzle2"        ,"grm_superpuzzle2_archives_focus"           ,1 }
   ,{ "rm_archives"            ,"grm_archives_lab_focus"                    ,1 }
   ,{ "rm_lounge_2"            ,"grm_lounge_2_courtyard_2_focus"            ,1 }
   ,{ "rm_hall_2"              ,"grm_hall_2_courtyard_2_focus"              ,1 }
   ,{ "rm_bar_2"               ,"grm_bar_2_courtyard_2_focus"               ,1 }
   ,{ "rm_bar_2"               ,"grm_bar_2_corridorelevator_focus"          ,1 }
   ,{ "rm_childrensroom"       ,"grm_childrensroom_courtyard_2_focus"       ,1 }
   ,{ "rm_corridorelevator"    ,"grm_corridorelevator_lowerlevel_focus"     ,0 }
   ,{ "rm_corridorelevator"    ,"grm_corridorelevator_bar_2_focus"          ,1 }
   ,{ "rm_lab"                 ,"grm_lab_lowerlevel_focus"                  ,1 }
   ,{ "rm_lab"                 ,"grm_lab_archives_focus"                    ,0 }
   ,{ "rm_lowerlevel"          ,"grm_lowerlevel_corridorelevator_focus"     ,1 }
   ,{ "rm_lowerlevel"          ,"grm_lowerlevel_receptionroom_focus"        ,0 }
   ,{ "rm_lowerlevel"          ,"grm_lowerlevel_lab_focus"                  ,0 }
   ,{ "rm_receptionroom"       ,"grm_receptionroom_lowerlevel_focus"        ,1 }
   ,{ "rm_courtyard_2"         ,"grm_courtyard_2_bar_2_focus"               ,1 }
   ,{ "rm_courtyard_2"         ,"grm_courtyard_2_childrensroom_focus"       ,0 }
   ,{ "rm_courtyard_2"         ,"grm_courtyard_2_lounge_2_focus"            ,1 }
   ,{ "rm_courtyard_2"         ,"grm_courtyard_2_hall_2_focus"              ,1 }
  };
  port.list_gates_3 =
  {
    { "ho_behindmirror"        ,"grm_behindmirror_terenceroom_focus"        ,1 }
   ,{ "ho_burntwall"           ,"grm_burntwall_secondfloor_focus"           ,1 }
   ,{ "ho_engineerbox"         ,"grm_engineerbox_powerunit_focus"           ,1 }
   ,{ "mg_minelabyrinth"       ,"grm_minelabyrinth_archives_3_focus"        ,1 }
   ,{ "mg_transformer"         ,"grm_transformer_powerunit_focus"           ,1 }
   ,{ "rm_examroom"            ,"grm_examroom_secondfloor_focus"            ,1 }
   ,{ "rm_powerunit"           ,"grm_powerunit_ventilationshaft_focus"      ,1 }
   ,{ "rm_powerunit"           ,"grm_powerunit_terenceroom_focus"           ,1 }
   ,{ "rm_terenceroom"         ,"grm_terenceroom_powerunit_focus"           ,1 }
   ,{ "rm_terenceroom"         ,"grm_terenceroom_secondfloor_focus"         ,0 }
   ,{ "rm_terenceroom"         ,"grm_terenceroom_powerunit_2_focus"         ,1 }
   ,{ "rm_secondfloor"         ,"grm_secondfloor_terenceroom_focus"         ,1 }
   ,{ "rm_secondfloor"         ,"grm_secondfloor_examroom_focus"            ,0 }
   ,{ "rm_secondfloor"         ,"grm_secondfloor_tortureroom_focus"         ,0 }
   ,{ "rm_tortureroom"         ,"grm_tortureroom_secondfloor_focus"         ,1 }
   ,{ "rm_ventilationshaft"    ,"grm_ventilationshaft_powerunit_focus"      ,0 }
  };
  port.list_gates_4 =
  {
    { "ho_bag"                 ,"grm_bag_hall_ext_focus"                    ,1 }
   ,{ "ho_barcounter"          ,"grm_barcounter_cafe_focus"                 ,1 }
   ,{ "ho_droppedtreecrown"    ,"grm_droppedtreecrown_porch_ext_focus"      ,1 }
   ,{ "ho_itemscollecting"     ,"grm_itemscollecting_apartment_focus"       ,1 }
   ,{ "mg_forandagainst"       ,"grm_forandagainst_managerroom_focus"       ,1 }
   ,{ "mg_hoteldoor"           ,"grm_hoteldoor_porch_ext_focus"             ,1 }
   ,{ "mg_shelflock"           ,"grm_shelflock_terenceroom_ext_focus"       ,1 }
   ,{ "mg_superpuzzle4"        ,"grm_superpuzzle4_hall_ext_focus"           ,1 }
   ,{ "rm_apartment"           ,"grm_apartment_parkinglot_focus"            ,0 }
   ,{ "rm_cafe"                ,"grm_cafe_nearcafe_focus"                   ,1 }
   ,{ "rm_cafe"                ,"grm_cafe_nearcafe_1_focus"                 ,1 }
   ,{ "rm_hall_ext"            ,"grm_hall_ext_porch_ext_focus"              ,1 }
   ,{ "rm_hall_ext"            ,"grm_hall_ext_secondfloor_ext_focus"        ,0 }
   ,{ "rm_managerroom"         ,"grm_managerroom_secondfloor_ext_focus"     ,1 }
   ,{ "rm_nearcafe"            ,"grm_nearcafe_porch_ext_focus"              ,1 }
   ,{ "rm_nearcafe"            ,"grm_nearcafe_cafe_focus"                   ,0 }
   ,{ "rm_parkinglot"          ,"grm_parkinglot_apartment_focus"            ,1 }
   ,{ "rm_parkinglot"          ,"grm_parkinglot_porch_ext_focus"            ,0 }
   ,{ "rm_porch_ext"           ,"grm_porch_ext_parkinglot_focus"            ,0 }
   ,{ "rm_porch_ext"           ,"grm_porch_ext_nearcafe_focus"              ,0 }
   ,{ "rm_porch_ext"           ,"grm_porch_ext_hall_ext_focus"              ,0 }
   ,{ "rm_secondfloor_ext"     ,"grm_secondfloor_ext_hall_ext_focus"        ,1 }
   ,{ "rm_secondfloor_ext"     ,"grm_secondfloor_ext_terenceroom_ext_focus" ,0 }
   ,{ "rm_secondfloor_ext"     ,"grm_secondfloor_ext_managerroom_focus"     ,0 }
   ,{ "rm_terenceroom_ext"     ,"grm_terenceroom_ext_secondfloor_ext_focus" ,1 }
  };
    port.list_gates_5 =
  {
    { "rm_mysteryroom"         ,"grm_mysteryroom_menu_focus"                ,1 }
   ,{ "ho_archivedata_scr"     ,"grm_archivedata_scr_mysteryroom_focus"     ,1 }
   ,{ "ho_behindmirror_scr"    ,"grm_behindmirror_scr_mysteryroom_focus"    ,1 }
   ,{ "ho_engineerbox_scr"     ,"grm_engineerbox_scr_mysteryroom_focus"     ,1 }
   ,{ "ho_indollhouse_scr"     ,"grm_indollhouse_scr_mysteryroom_focus"     ,1 }
   ,{ "ho_itemscollecting_scr" ,"grm_itemscollecting_scr_mysteryroom_focus" ,1 }
   ,{ "ho_suitcase_scr"        ,"grm_suitcase_scr_mysteryroom_focus"        ,1 }
   ,{ "mg_forandagainst_scr"   ,"grm_forandagainst_scr_mysteryroom_focus"   ,1 }
   ,{ "mg_hoteldoor_scr"       ,"grm_hoteldoor_scr_mysteryroom_focus"       ,1 }
   ,{ "mg_minelabyrinth_scr"   ,"grm_minelabyrinth_scr_mysteryroom_focus"   ,1 }
   ,{ "mg_panel_scr"           ,"grm_panel_scr_mysteryroom_focus"           ,1 }
   ,{ "mg_shelflock_scr"       ,"grm_shelflock_scr_mysteryroom_focus"       ,1 }
   ,{ "mg_transformer_scr"     ,"grm_transformer_scr_mysteryroom_focus"     ,1 }
  };
--------------------------------------------------------------------
-- выбираем нужный массив гейтов по текущему прогрессу
  function port.GetCurListGates()

    if ng_global.currentprogress ~= nil then
      if ng_global.currentprogress ~= "alt" then
  --------------------------------------------------
        local arr = {{"1",  port.list_gates_1},
                     {"2",  port.list_gates_2},
                     {"3",  port.list_gates_3},   
                     {"t",  port.list_gates_4},
                     {"r",  port.list_gates_5}
                                                  };
        local currentlistgates = arr[1][2];
        
        if ng_global.currentprogress ~= nil then
          local prg = ng_global.currentprogress;
          local lvl = string.sub (ng_global.progress[ prg ].common.chapter, -1)
          --DbgTrace("current_prg_"..prg);
          --DbgTrace("current_level_"..lvl);
          for i=1,#arr do
            if arr[i][1] == tostring(lvl) then
              currentlistgates = arr[i][2];
              break;
            end;
          end;
        end;

          return currentlistgates;    
  -------------------------------------------
      end;
    end;

  end;
--------------------------------------------------------------------
---- включение анимации при загрузке комнаты
  function port.GrmLightOn(room)

    if ng_global.currentprogress ~= nil then
      if ng_global.currentprogress ~= "alt" then
    ----------------------------------------------------------
        local cur_mass = port.GetCurListGates();
        for i=1,#cur_mass do
            if cur_mass[i][1] == room and cur_mass[i][3] == 1 then 
                  local delay = 1.5 + math.random();
                  ObjSet (cur_mass[i][2], {event_menter = "", event_mleave = "", active = 1, visible = 1});
                  ObjAnimate( cur_mass[i][2], 8, 1, 0, "", {  0,         0,0,
                                                                       delay/2,   0,1,
                                                                       delay,     0,1,
                                                                       delay*1.5, 0,0,
                                                                       delay*1.8, 0,0  });

            end;
            if cur_mass[i][1] == room then 
                local count_word = string.len(cur_mass[i][2]);
                local str_name_grm = string.sub(cur_mass[i][2],1,count_word-6);
                ObjSet (str_name_grm,{ event_menter = "", event_mleave = "" }); 
                
            end;
        end;
  -----------------------------------------------------------------
      end;
    end;

  end;
--------------------------------------------------------------------
-- --включение анимации для зон перехода после события
  function port.GrmEventLightOn(gate)
      if port.isPortable() == 1 then
            local cur_mass = port.GetCurListGates();
            for i=1,#cur_mass do
                if cur_mass[i][2] == gate then 
                      local delay = 1.5 + math.random();
                      ObjSet (cur_mass[i][2], {event_menter = "", event_mleave = ""});
                      ObjStopAnimate(cur_mass[i][2], 8);
                      cur_mass[i][3] = 1;
                      ObjAnimate( cur_mass[i][2], 8, 1, 0, "", {  0,         0,0,
                                                                           delay/2,   0,1,
                                                                           delay,     0,1,
                                                                           delay*1.5, 0,0,
                                                                           delay*1.8, 0,0}); 
                end;
            end;
      end;
  end;
------------------------------------------------------------------
-- --выключение анимации для зон перехода после события
  function port.GrmEventLightOff(gate)
      if port.isPortable() == 1 then
              local cur_mass = port.GetCurListGates();
              for i=1,#cur_mass do
                  if cur_mass[i][2] == gate then
                        cur_mass[i][3] = 0; 
                        ObjSet (cur_mass[i][2], {event_menter = "", event_mleave = ""});
                        ObjStopAnimate(cur_mass[i][2], 8);
                        ObjAnimate( cur_mass[i][2], 8, 0, 0, "", {0,0,ObjGet(cur_mass[i][2]).alp, 0.1,0,0}); 
                  end;
              end;
      end;
  end;

------------------------------------------------------------------------------------
  function port.ForbidScaleWidget(cforbid, lforbid)
    ObjSet("tmr_common_forbidscale",{endtrig = "", time = 0.5, playing = 0 });
    if cforbid == 1 and lforbid == 1 then
      iOS_EnableMultiTouch(0);
      MsgSend( Command_Level_ResetZoom, { forbid = 1, luaforbid = lforbid } );
      ObjSet("tmr_common_forbidscale", { time = 0.5, playing = 1, endtrig = function () port.ForbidScale( 1, 1 ); end; }); 
    else
      iOS_EnableMultiTouch(1);
      MsgSend( Command_Level_ResetZoom, { forbid = 0, luaforbid = lforbid } );
      ObjSet("tmr_common_forbidscale",{endtrig = "", time = 0.5, playing = 0 }); 
    end;
  end;

------------------------------------------------------------------------------------
  port.RoomNoZoom = {
    "rm_intro",
    "rm_menu",
    "rm_unlock",
    "rm_collectable",
    "rm_achievements",
    "rm_sequel",
    "rm_extra",
    "rm_credits"
  };

  port.TaskPanelActive = false;

  function port.Scale( enable )
      --if port.TaskPanelActive == true then
      --    DbgTrace("port.TaskPanelActive=1");
      --else
      --    DbgTrace("port.TaskPanelActive=0");
      --end;
    local room = common.GetCurrentRoom();
    local check = false;
      
    if not room then room = "rm_intro" end; 
    if enable == 1 then
      if port.isTablet() == 1 then
        --DbgTrace("isTablet");
        if "ho" == common.GetObjectPrefix( room ) or port.TaskPanelActive == true then
          --DbgTrace("Command_Level_SetZoom = 1");
          MsgSend( Command_Level_SetZoom, { zoom = true } );
          iOS_EnableMultiTouch(1);     
        else
          --DbgTrace("Command_Level_SetZoom = 0");
          MsgSend( Command_Level_SetZoom, { zoom = false } );
          iOS_EnableMultiTouch(0);
        end;
      else 
         --DbgTrace("isIphone");
        if ("ho" == common.GetObjectPrefix( room )) or
           ("mg" == common.GetObjectPrefix( room )) then
          for i=1,#port.RoomNoZoom do
            if room == port.RoomNoZoom[i] then check = true; end;
          end;

          if check then
             iOS_EnableMultiTouch(0);
             MsgSend( Command_Level_SetZoom, { zoom = false } );
             --DbgTrace("Command_Level_SetZoom = 0");
          else
             iOS_EnableMultiTouch(1);
             MsgSend( Command_Level_SetZoom, { zoom = true } );
             --DbgTrace("Command_Level_SetZoom = 1");
          end;
        else 
          iOS_EnableMultiTouch(0);
          MsgSend( Command_Level_SetZoom, { zoom = false } );
          --DbgTrace("Command_Level_SetZoom = 0");
        end;
      end;  
    else
      iOS_EnableMultiTouch(0);
      MsgSend( Command_Level_SetZoom, { zoom = false } );
     -- DbgTrace("Command_Level_SetZoom = 0");
    end;

  end;


--*********************************************************************************************************************
--***function *** Android *** () end**************************************************************************
--*********************************************************************************************************************

  private.enable_android_back_button = true;

  function public.EnableAndroidBackButton ( param )

    private.enable_android_back_button = param;
    DbgTrace("cmn.EnableAndroidBackButton private.enable_android_back_button = "..tostring(private.enable_android_back_button));

  end;
  --*********************************************************************************************************************

  function public.AndroidBackPressed()

    --DbgTrace("[common_impl] cmn.AndroidBackPressed private.enable_android_back_button = "..tostring(private.enable_android_back_button));

    if ( private.enable_android_back_button ) then
--[[ пример кода взять из проекта mc или из вашей кнопки "назад" ]] 

      local loc = GetCurrentRoom();
      local pref = common.GetObjectPrefix( loc );

      --DbgTrace("loc = "..loc);

      

      if ( int_window.GetIntShown() ) then

       
        --DbgTrace("Hide dialog ");


      elseif ( common.GetCurrentSubRoom() ) then

        common.CloseSubRoom();

      elseif ( pref == "rm" ) then

        if ( loc == "rm_achievements" or loc == "rm_collectibles" or loc == "rm_collectibles2" ) then

          local room = common.GetCurrentRoom();
          if ( not room ) then

            room = "rm_extra";

          end; 
          common.GotoRoom( room ); 

        elseif ( loc == "rm_credits" ) then 
          _G[ loc ].QuitClk();
        elseif ( loc == "rm_moregames" or loc == "rm_extra" or loc == "rm_unlock" or loc == "rm_sequel") then 
          common.GotoRoom( "rm_menu" );
        elseif (loc == "rm_menu") then
          --DbgTrace("EXIT GAME ROOM");
          common.MenuQuit();  
          --iOS_Exit();          
        elseif ( game and public.FindIndex( game.room_names, loc ) ) then 
          --common.LevelSwitch( "menu", "game" );
          MsgSend( Event_ButtonMenu_Click, {} );
        end;

      elseif ( pref == "ho" or pref == "mg" ) then

        --local room = common.GetPrevRoom();
        --if ( room ) then
        --  common.GotoRoom( room ); 
        --end;
        MsgSend( Event_ButtonMenu_Click, {} );
      end;      
   
    end; 
  end;

--**************************************************************************************************************
--***function *** operations with arrays *** () end*************************************************************
--**************************************************************************************************************
  function public.FindIndex( arr, elem ) -- поиск по таблице SS
    
    for i = 1, #arr  do
      
      if arr[i] == elem then

        return i;

      end;
      
    end;
    
    return 0;  

  end;  

--*********************************************************************************************************************
--*********************************************************************************************************************