-- name=mg_superpuzzle1
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_superpuzzle1";

  ObjSet( "obj_superpuzzle1_hint", { 
    event_mdown = private.PuszzleHintClk, 
    event_menter = private.PuszzleHintEnter, 
    event_mleave = private.PuszzleHintLeave
  } );

  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_superpuzzle1" ] = {
    type = "win",
    room = "rm_bar",
    zz = "mg_superpuzzle1",
    zz_gate = "gmg_bar_superpuzzle1"
  };

  local win_superpuzzle1_loc = function ()

    if ( cmn.IsEventDone( "win_superpuzzle1" ) ) then  
      
      ObjDelete( "spr_bar_stashwall_mg" );
      ObjDelete( "gmg_bar_superpuzzle1" );
      ObjSet( "grm_bar_corridor", { active = true, input= true, visible = true } );
      if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_bar_corridor_focus");
      end;
    else

    end;

  end;

  cmn.AddSubscriber( "win_superpuzzle1", win_superpuzzle1_loc, "rm_bar" );

  --------------------------------------------------------------------------------------------

  local win_superpuzzle1 = function ()

    local table_multiset = {};

    private.items_done  = ng_global.progress[ "std" ][ "win_superpuzzle1" ].items_done;
    private.clk_done    = ng_global.progress[ "std" ][ "win_superpuzzle1" ].clk_done;

    -----------------------------------------    

    private.circles.win = ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.win;

    for i = 1, #private.circles.current_list do
    
      private.circles.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.current_list[ i ];

    end;

    -----------------------------------------    

    private.squares.win = ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.win;

    for i = 1, #private.squares.current_list do
    
      private.squares.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.current_list[ i ];

    end;

    -----------------------------------------    

    private.ampules.index = ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.index;
    private.ampules.win   = ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.win;

    for i = 1, #private.ampules.current_list do
    
      private.ampules.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.current_list[ i ];

    end;

    -----------------------------------------    

    private.symbols.win = ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.win;

    for i = 1, #private.symbols.pos_x_list do
    
      private.symbols.pos_x_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_x_list[ i ];
      private.symbols.pos_y_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_y_list[ i ];
      private.symbols.done[ i ]       = ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.done[ i ];

    end;

    -----------------------------------------    

    private.tapes.win = ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.win;

    for i = 1, #private.tapes.current_list do
    
      private.tapes.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.current_list[ i ];

    end;

    -----------------------------------------    

    private.pictures.win = ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.win;

    for i = 1, #private.pictures.current_list do
    
      for j = 1, #private.pictures.current_list[ i ] do
        
        private.pictures.current_list[ i ][ j ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list[ i ][ j ];

      end;

    end;

    -----------------------------------------    

    private.hexs.win = ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.win;

    for i = 1, #private.hexs.current_list do
    
      private.hexs.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_list[ i ];

    end;

    --- Mini Progress Begin--------------------------

    private.LoadClkDone( "panel" );
    private.LoadClkDone( "number_1" );

    -----------------------------

    if ( private.circles.win ) then

      private.CirclesWinSet();
      
    end;

    for i = 1, #private.circles.current_list do
      
      local ang = private.circles_ang[ private.circles.current_list[ i ] ]; 
                      
      table.insert( table_multiset, { "spr_superpuzzle1_mg_1_circle_"..i, { ang = ang } } );

    end;

    -----------------------------

    private.LoadItemsDone( "logo_a" );
    private.LoadClkDone( "number_2" );

    -----------------------------

    if ( private.squares.win ) then

      private.SquaresWinSet();
      
    end;

    for i = 1, #private.squares.current_list do
        
      if ( private.squares.current_list[ i ] ) then

        table.insert( table_multiset, { "spr_superpuzzle1_mg_2_square_"..i, { input = false } } );
        table.insert( table_multiset, { "spr_superpuzzle1_mg_2_over_"..i,   { alp = 0 } } );

      end;

    end;

    -----------------------------

    if ( private.ampules.win ) then

      private.AmpulesWinSet();
      
    else

      for i = 1, #private.ampules.current_list do

        if ( private.ampules.current_list[ i ] ~= 0 ) then

          table.insert( table_multiset, { "spr_superpuzzle1_mg_3_ampule_"..private.ampules.current_list[ i ], { pos_y = 320 } } );
      
        end;

      end;

    end;

    -----------------------------

    private.LoadItemsDone( "logo_n" );
    private.LoadClkDone( "number_4" );

    -----------------------------

    if ( private.symbols.win ) then

      private.SymbolsWinSet();
      
    end;

    for i = 1, #private.symbols.pos_x_list do
      
      local pos_x = private.symbols_begin_x + ( private.symbols.pos_x_list[ i ] - 1 ) * private.symbols_step; 
      local pos_y = private.symbols_begin_y + ( private.symbols.pos_y_list[ i ] - 1 ) * private.symbols_step;                     

      table.insert( table_multiset, { "spr_superpuzzle1_mg_4_symbol_"..i, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    for s = 1, #private.symbols.done do
    
      if ( private.symbols.done[ s ] ) then

        local pos_x = private.symbols_pos_x_done[ s ];
        local pos_y = private.symbols_pos_y_done[ s ];

        table.insert( table_multiset, { "spr_superpuzzle1_mg_4_symbol_"..s, { pos_x = pos_x, pos_y = pos_y } } );

      end;

    end;

    -----------------------------

    private.LoadClkDone( "number_6" );

    -----------------------------

    if ( private.tapes.win ) then

      private.TapesWinSet();
      
    end;

    for i = 1, #private.tapes.current_list do
      
      local pos_y = private.tapes_begin_pos_y + ( private.tapes.current_list[ i ] - 1 ) * private.tapes_begin_step ; 
                      
      table.insert( table_multiset, { "obj_superpuzzle1_mg_6_tape_"..i, { pos_y = pos_y } } );

    end;

    -----------------------------

    if ( private.pictures.win ) then

      private.PicturesWinSet();
      
    end;

    for i = 1, #private.pictures.current_list do
    
      for j = 1, #private.pictures.current_list[ i ] do
        
        local pos_x  = private.pictures_begin_x + ( j - 1 ) * private.pictures_step; 
        local pos_y  = private.pictures_begin_y + ( i - 1 ) * private.pictures_step;                     
        local number = private.pictures.current_list[ i ][ j ];

        table.insert( table_multiset, { "spr_superpuzzle1_mg_5_picture_"..number, { pos_x = pos_x, pos_y = pos_y } } );

      end;

    end;

    -----------------------------

    private.LoadItemsDone( "logo_c" );

    -----------------------------

    if ( private.hexs.win ) then

      private.HexsWinSet();
      
    end;

    for i = 1, #private.hex_attach do

      for j = 1, #private.hex_attach[ i ] do
        
        if ( private.hex_attach[ i ][ j ] ~= 0 ) then

          local number_attach = private.hexs.current_list[ private.hex_attach[ i ][ j ] ];

          ObjAttach( "spr_superpuzzle1_mg_7_hex_"..number_attach, "obj_superpuzzle1_mg_7_offset_"..i.."_"..j );

        end

      end;

    end;

    -----------------------------

    private.LoadItemsDone( "logo_e" );

    private.LoadClkDone( "number_7" );

    private.LoadItemsDone( "logo_c_2" );

    --- Mini Progress End --------------------------

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_superpuzzle1", win_superpuzzle1, private.room_objname );
  
  --------------------------------------------------------------------------------------------

  local table_multiset = {};

  --------------------------------------

  private.items_done = {};
  private.items_list = { "logo_a", "logo_n", "logo_c", "logo_e", "logo_c_2" };

  private.items_func_done = {};
  private.items_func_done.logo_a   = private.ItemDoneLogoA;
  private.items_func_done.logo_n   = private.ItemDoneLogoN;
  private.items_func_done.logo_c   = private.ItemDoneLogoC;
  private.items_func_done.logo_e   = private.ItemDoneLogoE;
  private.items_func_done.logo_c_2 = private.ItemDoneLogoC2;

  --------------------------------------

  private.clk_done = {};
  private.clk_list = { "panel", "number_1", "number_2", "number_4", "number_6", "number_7" };

  private.clk_func_done = {};
  private.clk_func_done.panel    = private.ClkDonePanel;
  private.clk_func_done.number_1 = private.ClkDoneNumber1;
  private.clk_func_done.number_2 = private.ClkDoneNumber2;
  private.clk_func_done.number_4 = private.ClkDoneNumber4;
  private.clk_func_done.number_6 = private.ClkDoneNumber6;
  private.clk_func_done.number_7 = private.ClkDoneNumber7;

  --------------------------------------

  private.circles = {};
  private.circles.current_list = { 2, 1, 3 };

  private.circles_derections  = { { 1 }, { -1, 1 }, { 2, -1, 1 } }
  private.circles_ang         = { 0, - 1.57, - 3.14, - 4.71, - 6.28 };
  private.circles_win_list    = { 1, 1, 1 };

  for i = 1, #private.circles.current_list do
    
    local ang = private.circles_ang[ private.circles.current_list[ i ] ]; 
                    
    table.insert( table_multiset, { "spr_superpuzzle1_mg_1_circle_"..i, { ang = ang } } );

  end;

  --------------------------------------

  private.squares = {};
  private.squares.current_list = { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false };

  private.squares_prev_number = "";
  private.squares_list = { 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9 };

  --------------------------------------

  private.ampules = {}
  private.ampules.current_list = { 0, 0, 0, 0, 0 };
  private.ampules.index = 1;

  private.ampules_win_list = { 1, 3, 5, 2, 4 };
  
  --------------------------------------

  private.symbols = {};
  private.symbols.pos_x_list = { 5, 4, 3 };
  private.symbols.pos_y_list = { 4, 5, 4 };
  private.symbols.done = { false, false, false };

  private.symbols_field = {
    { 0, 0, 0, 0, 0, 1, 0 },
    { 0, 0, 1, 1, 0, 1, 0 },
    { 0, 0, 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 1, 0 },
    { 1, 0, 1, 0, 0, 0, 0 },
    { 0, 0, 1, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0, 0 }
  };

  private.symbols_begin_x  = -140;
  private.symbols_begin_y  = -84;
  private.symbols_step     = 30;
  --                                  -1-   -2-      -3-
  private.symbols_pos_x_win     = {    2,    7,       7 };
  private.symbols_pos_y_win     = {    1,    1,       7 };
  private.symbols_direction_win = { "up", "right", "right" };

  private.symbols_pos_x_done = { -110,  79, 79 };
  private.symbols_pos_y_done = { -117, -84, 96 };

  for i = 1, #private.symbols.pos_x_list do
    
    local pos_x = private.symbols_begin_x + ( private.symbols.pos_x_list[ i ] - 1 ) * private.symbols_step; 
    local pos_y = private.symbols_begin_y + ( private.symbols.pos_y_list[ i ] - 1 ) * private.symbols_step;                     

    table.insert( table_multiset, { "spr_superpuzzle1_mg_4_symbol_"..i, { pos_x = pos_x, pos_y = pos_y } } );

  end;

  --------------------------------------

  private.tapes = {};
  private.tapes.current_list = { 1, 1, 1 };

  private.tapes_begin_pos_y = -25;
  private.tapes_begin_step = 78;
  private.tapes_win_list = { 2, 3, 4 };

  for i = 1, #private.tapes.current_list do
    
    local pos_y = private.tapes_begin_pos_y + ( private.tapes.current_list[ i ] - 1 ) * private.tapes_begin_step ; 
                    
    table.insert( table_multiset, { "obj_superpuzzle1_mg_6_tape_"..i, { pos_y = pos_y } } );

  end;

  --------------------------------------

  private.pictures = {};
  private.pictures.current_list = {
    { 7, 12,  5,   4 },
    { 6,  1,  8,  11 },
    { 10, 3,  2,   9 }
  };

  private.pictures_win_list = {
    { 1,  2,  3,  4 },
    { 5,  6,  7,  8 },
    { 9, 10, 11, 12 }
  };

  private.pictures_prev_number = "";
  private.pictures_enabled  = {};
  private.pictures_begin_x  = 556;
  private.pictures_begin_y  = 450;
  private.pictures_step     = 63;

  for i = 1, #private.pictures.current_list do
  
    for j = 1, #private.pictures.current_list[ i ] do
      
      local pos_x  = private.pictures_begin_x + ( j - 1 ) * private.pictures_step; 
      local pos_y  = private.pictures_begin_y + ( i - 1 ) * private.pictures_step;                     
      local number = private.pictures.current_list[ i ][ j ];

      table.insert( table_multiset, { "spr_superpuzzle1_mg_5_picture_"..number, { pos_x = pos_x, pos_y = pos_y } } );

    end;

  end;

  --------------------------------------

  private.hexs = {};
  private.hexs.current_list = { 6, 7, 4, 3, 1, 2, 5 };

  private.hexs_win_list = { 6, 7, 2, 1, 5, 3, 4 };
  private.hexs_ang      = { 0, -2.12, -4.16, -6.28 };

  private.hex_numbers = { { 1, 2, 3 },
                          { 4, 6, 3 },
                          { 5, 6, 7 } };

  private.hex_attach = { { 1, 2, 3 },  
                         { 4, 0, 0 },
                         { 5, 6, 7 } };

  for i = 1, #private.hex_attach do

    for j = 1, #private.hex_attach[ i ] do

      if ( private.hex_attach[ i ][ j ] ~= 0 ) then

        local number_attach = private.hexs.current_list[ private.hex_attach[ i ][ j ] ];
        
        ObjAttach( "spr_superpuzzle1_mg_7_hex_"..number_attach, "obj_superpuzzle1_mg_7_offset_"..i.."_"..j );

      end

    end;

  end;

  --------------------------------------

  table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_panel", { event_mdown = function () private.PlaceClk( "numerals", "panel" ); end } } );

  local buttons_number = { 1, 2, 4, 6, 7 };

  for n = 1, #buttons_number do
    
    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_"..buttons_number[ n ], { event_mdown = function () private.PlaceClk( "numerals", "number_"..buttons_number[ n ] ); end } } );

  end;

  for c = 1, #private.circles.current_list do
    
    table.insert( table_multiset, { "spr_superpuzzle1_mg_1_circle_"..c, { event_mdown = function () private.CirclesClk( c ) end } } );

  end;

  local letters = { "c", "a", "n", "c_2", "e", "r" };

  for let = 1, #letters do

      table.insert( table_multiset, { "spr_superpuzzle1_logo_"..letters[ let ], { event_mdown = function () private.ItemMDown( "logo_"..letters[ let ] ); end, event_dragdrop = function () private.ItemDragDrop( "logo_"..letters[ let ] ); end } } );

  end;

  for s = 1, 18 do
    
    table.insert( table_multiset, { "spr_superpuzzle1_mg_2_square_"..s, { event_mdown = function () private.SquaresClk( s ) end } } );

  end;
 
  for i = 1, 5 do
        
    table.insert( table_multiset, { "spr_superpuzzle1_mg_3_ampule_"..i, { event_mdown = function () private.AmpulesClk( i ); end } } );

  end;

  local directions = { "left", "up", "right", "down" }

  for a = 1, 4 do
    
    table.insert( table_multiset, { "spr_superpuzzle1_mg_4_arrow_"..directions[ a ], { 
      event_mdown  = function () private.SymbolsClk( directions[ a ] ) end,
      event_menter = function () private.SymbolsArrowEnter( directions[ a ] ) end,
      event_mleave = function () private.SymbolsArrowLeave( directions[ a ] ) end,
    } } );

  end;

  for b = 1, #private.tapes.current_list do
    
    table.insert( table_multiset, { "obj_superpuzzle1_mg_6_button_"..b, { event_mdown = function () private.TapesClk( b ) end } } );

  end;

  for p = 1, 12 do
    
    table.insert( table_multiset, { "spr_superpuzzle1_mg_5_picture_"..p, { 
      event_mdown  = function () private.PicturesClk( p ) end,
      event_menter = function () private.PicturesEnter( p ) end,
      event_mleave = function () private.PicturesLeave( p ) end,
    } } );

  end;

  for c = 1, #private.hexs.current_list do
    
    table.insert( table_multiset, { "spr_superpuzzle1_mg_7_circle_"..c, { event_mdown = function () private.HexsClk( c ) end } } );

  end;

  table.insert( table_multiset, { "obj_superpuzzle1_clk_tv", { event_mdown = private.TVClk } } );

  --------------------------------------
  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  if not cmn.IsEventDone( "win_superpuzzle1" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_superpuzzle1" ) ) then

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].items_done = private.items_done;
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].clk_done   = private.clk_done;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.win = private.circles.win;

    for i = 1, #private.circles.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.current_list[ i ] = private.circles.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.win = private.squares.win;

    for i = 1, #private.squares.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.current_list[ i ] = private.squares.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.index = private.ampules.index;
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.win   = private.ampules.win;

    for i = 1, #private.ampules.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.current_list[ i ] = private.ampules.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_x_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_y_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.done = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.win = private.symbols.win;

    for i = 1, #private.symbols.pos_x_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_x_list[ i ] = private.symbols.pos_x_list[ i ];
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_y_list[ i ] = private.symbols.pos_y_list[ i ];
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.done[ i ]       = private.symbols.done[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.win = private.tapes.win;

    for i = 1, #private.tapes.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.current_list[ i ] = private.tapes.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.win = private.pictures.win;

    for i = 1, #private.pictures.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list[ i ] = {};

      for j = 1, #private.pictures.current_list[ i ] do
        
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list[ i ][ j ] = private.pictures.current_list[ i ][ j ];

      end;

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_ang = {};
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.win = private.hexs.win;

    for i = 1, #private.hexs.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_list[ i ] = private.hexs.current_list[ i ];

    end;

  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_superpuzzle1" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  private.ItemResetSet();
  private.ClkResetSet();
  private.CirclesResetSet();
  private.AmpulesResetSet();
  private.SquaresResetSet();
  private.SymbolsResetSet();
  private.TapesResetSet();
  private.PicturesResetSet();
  private.HexsResetSet();

end;
--*********************************************************************************************************************
function public.Skip()

port.skip_mg = true;
  private.circles.win  = true;
  private.ampules.win  = true;
  private.squares.win  = true;
  private.symbols.win  = true;
  private.tapes.win    = true;
  private.pictures.win = true;
  private.hexs.win  = true;

  for i = 1, #private.items_list do
    
    local name = private.items_list[ i ];
    private.items_done[ name ] = true;
    private.items_func_done[ name ]();

  end;

  for i = 1, #private.clk_list do
    
    local name = private.clk_list[ i ];
    private.clk_done[ name ] = true;

  end;

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_superpuzzle1" );
  cmn.CallEventHandler( "win_superpuzzle1" );

  common_impl.PassingMgWin();

  if ( not ng_global.progress[ ng_global.currentprogress ][ "win_superpuzzle1" ].skip_clk ) then

    common_impl.CheckGiveCustomAchiev( "superpuzzle_no_skip" );

  end;

  cmn.GotoRoom( "rm_bar" );  

end;
--*********************************************************************************************************************
function private.Win ()

  func_end = function ()

    common_impl.Lock( false );

    ObjSet( "anm_superpuzzle1_random_maniac", { alp = 0 } );

    private.WinEnd();

  end;

  common_impl.Lock( true );

  ObjSet( "anm_superpuzzle1_random_maniac", { alp = 1 } );

  AnimPlay( "anm_superpuzzle1_random_maniac", "DoAnim", "" );

  common_impl.ShowBbt( 'bbt_superpuzzle1_masked_man_4' );

  common_impl.PlayAudio( "sfx", "level1/voc/aud_superpuzzle1_masked_man_4_voc", 0, "", 0 );

  ObjAnimate( "obj_superpuzzle1_logo_lights", "alp", 0, 0, func_end, { 0,3,0,  0.2,3,0.5, 0.3,3,0, 0.5,3,1, 4.0,3,1 } );

end;
--*********************************************************************************************************************
-- function *** Use Items ***() end
--*********************************************************************************************************************
  function private.ItemMDown ( sender )

    local obj_name = "spr_superpuzzle1_"..sender;

    private.item_parent = ObjGetRelations( obj_name ).parent;
    private.item_pos_z  = ObjGet( obj_name ).pos_z;

    ObjAttach( obj_name, "mg_superpuzzle1" )
    ObjSet( obj_name, { pos_z = 10 } );

    common_impl.PlayAudio( "sfx", "aud_get_inv_in_hand_sfx", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ItemDragDrop ( sender )

    local obj_name = "spr_superpuzzle1_"..sender;

    ObjAttach( obj_name, private.item_parent )
    ObjSet( obj_name, { pos_z = private.item_pos_z } );

    common_impl.PlayAudio( "sfx", "aud_use_inv_in_hand_sfx", 0, "", 0 );

    ----------------------------------------------------------------------------------------------------

    if ( sender == "logo_a" and common.ApplyObj( obj_name, "obj_superpuzzle1_logo_use_letters" ) ) then
    
      private.ItemDoneLogoA();

      if ( private.items_done[ "logo_e" ] ) and 
         ( private.items_done[ "logo_c_2" ] ) then

        private.Win();
    
      else

        private.items_done[ "logo_a" ] = true;
      
      end;

    ----------------------------------------------------------------------------------------------------

    elseif ( sender == "logo_n" and common.ApplyObj( obj_name, "obj_superpuzzle1_logo_use_letters" ) ) then
    
      local func_end = function ()

        private.items_done[ "logo_n" ] = true;
        private.ItemDoneLogoN();

      end;

      local func_step_1 = function ()

        if ( private.items_done[ "logo_c" ] ) and 
           ( private.symbols.win ) then

          private.HexsActiveAnim( func_end );

        else

          func_end();

        end;

      end;

      ObjAttach( "spr_superpuzzle1_logo_n", "obj_superpuzzle1_logo" );
      ObjSet( "spr_superpuzzle1_logo_n", { pos_x = 455, pos_y = 112, input = false } );

      ObjAnimate( "spr_superpuzzle1_red_1", "alp", 0, 0, "", 
      { 
        0,   3, 1,  
        0.4, 3, 0 
      } );  

      ObjAnimate( "spr_superpuzzle1_green_1", "alp", 0, 0, func_step_1, 
      { 
        0,   3, 0,  
        0.4, 3, 1, 
        0.5, 3, 0.5,  
        0.7, 3, 1, 
        0.8, 3, 0.5,  
        1.0, 3, 1, 
      } );  

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_lamp", 0, "", 0 );

    ----------------------------------------------------------------------------------------------------

    elseif ( sender == "logo_c" and common.ApplyObj( obj_name, "obj_superpuzzle1_logo_use_letters" ) ) then
    
      local func_end = function ()

        private.items_done[ "logo_c" ] = true;
        private.ItemDoneLogoC();

      end;

      local func_step_1 = function ()

        if ( private.items_done[ "logo_n" ] ) and 
           ( private.symbols.win ) then

          private.HexsActiveAnim( func_end );

        else

          func_end();

        end;

      end;

      ObjAttach( "spr_superpuzzle1_logo_c", "obj_superpuzzle1_logo" );
      ObjSet( "spr_superpuzzle1_logo_c", { pos_x = 359, pos_y = 112, input = false } );

      ObjAnimate( "spr_superpuzzle1_red_3", "alp", 0, 0, "", 
      { 
        0,   3, 1,  
        0.4, 3, 0 
      } );  

      ObjAnimate( "spr_superpuzzle1_green_3", "alp", 0, 0, func_step_1, 
      { 
        0,   3, 0,  
        0.4, 3, 1, 
        0.5, 3, 0.5,  
        0.7, 3, 1, 
        0.8, 3, 0.5,  
        1.0, 3, 1, 
      } );  

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_lamp", 0, "", 0 );

    ----------------------------------------------------------------------------------------------------

    elseif ( sender == "logo_e" and common.ApplyObj( obj_name, "obj_superpuzzle1_logo_use_letters" ) ) then

      local func_end = function ()

        private.ItemDoneLogoE();

        if ( private.items_done[ "logo_a" ] ) and 
           ( private.items_done[ "logo_c_2" ] ) then

          private.Win();
      
        else

          private.items_done[ "logo_e" ] = true;
        
        end;

      end;

      ObjAttach( "spr_superpuzzle1_logo_e", "obj_superpuzzle1_logo" );
      ObjSet( "spr_superpuzzle1_logo_e", { pos_x = 545, pos_y = 112, input = false } );

      private.HexsHide( func_end );

    ----------------------------------------------------------------------------------------------------

    elseif ( sender == "logo_c_2" and common.ApplyObj( obj_name, "obj_superpuzzle1_logo_use_letters" ) ) then
    
      private.ItemDoneLogoC2();

      if ( private.items_done[ "logo_a" ] ) and 
         ( private.items_done[ "logo_e" ] ) then

        private.Win();
    
      else

        private.items_done[ "logo_c_2" ] = true;
      
      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLogoA ()

    local table_multiset = {};  

    ObjAttach( "spr_superpuzzle1_logo_a", "obj_superpuzzle1_logo" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_a", { pos_x = 402, pos_y = 112, input = false } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLogoN ()

    local table_multiset = {};  

    ObjAttach( "spr_superpuzzle1_logo_n", "obj_superpuzzle1_logo" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_n",       { pos_x = 455, pos_y = 112, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_red_1",        { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_green_1",      { alp = 1 } } );

    if ( private.items_done[ "logo_c" ] ) and 
       ( private.symbols.win ) then

      private.HexsActiveSet();

    end;

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLogoC ()

    local table_multiset = {};  

    ObjAttach( "spr_superpuzzle1_logo_c", "obj_superpuzzle1_logo" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c", { pos_x = 359, pos_y = 112, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_red_3",        { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_green_3",      { alp = 1 } } );

    if ( private.items_done[ "logo_n" ] ) and 
       ( private.symbols.win ) then

      private.HexsActiveSet();

    end;

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLogoE ()

    local table_multiset = {};  

    ObjAttach( "spr_superpuzzle1_logo_e", "obj_superpuzzle1_logo" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_e", { pos_x = 545, pos_y = 112, input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_7",   { pos_y = 270 } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLogoC2 ()

    local table_multiset = {};  

    ObjAttach( "spr_superpuzzle1_logo_c_2", "obj_superpuzzle1_logo" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c_2", { pos_x = 510, pos_y = 112, ang = 0, input = false } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemResetSet ()

    private.items_done[ "logo_a" ]   = false;
    private.items_done[ "logo_n" ]   = false;
    private.items_done[ "logo_c" ]   = false;
    private.items_done[ "logo_e" ]   = false;
    private.items_done[ "logo_c_2" ] = false;

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].items_done = private.items_done;

    local table_multiset = {};

    ObjAttach( "spr_superpuzzle1_logo_a", "obj_superpuzzle1_mg_1_crop" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_a", { pos_x = 2, pos_y = -67, input = false } } );

    ObjAttach( "spr_superpuzzle1_logo_n", "obj_superpuzzle1_mg_3_crop_door" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_n", { pos_x = 0, pos_y = -5, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_red_1",        { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_green_1",      { alp = 0 } } );

    ObjAttach( "spr_superpuzzle1_logo_c", "obj_superpuzzle1_mg_6_crop_catch" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c", { pos_x = 0, pos_y = 0, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_red_3",        { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_green_3",      { alp = 0 } } );

    ObjAttach( "spr_superpuzzle1_logo_e", "obj_superpuzzle1_mg_7_crop_door" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_e", { pos_x = 0, pos_y = 0, input = false } } );

    ObjAttach( "spr_superpuzzle1_logo_c_2", "obj_superpuzzle1_numerals_number_7" );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c_2", { pos_x = 2, pos_y = 150, ang = 1.57, input = false } } );

    ObjMultiSet( table_multiset )

  end;
 --*********************************************************************************************************************
  function private.LoadItemsDone ( event_name )

    if ( private.items_done[ event_name ] ) then

      private.items_func_done[ event_name ]();

    end;

  end;
--*********************************************************************************************************************
-- function *** Clicks ***() end
--*********************************************************************************************************************
  function private.PlaceClk ( window, sender )

    local obj_name = "obj_superpuzzle1_"..window.."_clk_"..sender;

    if ( sender == "panel" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "panel" ] = true;
    
        private.ClkDonePanel();

      end;

      local func_step_1 = function ()
      
        ObjSet( "anm_superpuzzle1_random_maniac", { alp = 0 } );
      
        AnimPlay( "anm_superpuzzle1_button_click", "DoAnim", "" );

        ObjAnimate( "anm_superpuzzle1_button_click", "alp", 0, 0, func_end, { 0,3,0,  0,3,1,  10.0,3,1 } );

        common_impl.ShowBbt( 'bbt_superpuzzle1_masked_man_2' );

        common_impl.PlayAudio( "sfx", "level1/voc/aud_superpuzzle1_masked_man_2_voc", 0, "", 0 );

      end;

      ObjAnimate( "anm_superpuzzle1_random_maniac", "alp", 0, 0, func_step_1, { 0,3,0,  0.0,3,1,  5.0,3,1 } );

      AnimPlay( "anm_superpuzzle1_random_maniac", "DoAnim", "" );

      common_impl.ShowBbt( 'bbt_superpuzzle1_masked_man_1' );

      common_impl.PlayAudio( "sfx", "level1/voc/aud_superpuzzle1_masked_man_1_voc", 0, "", 0 );

    -----------------------------------------------------------------------------------------------------------

    elseif ( sender == "number_1" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "number_1" ] = true;
    
        private.ClkDoneNumber1();
      
      end;

      ObjAnimate( "spr_superpuzzle1_numerals_number_1_1", "alp",   0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_superpuzzle1_mg_1_cover",          "pos_y", 0, 0, func_end, { 0,3,-10,  0.4,3,-10,  1.0,3,-230 } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

    -----------------------------------------------------------------------------------------------------------

    elseif ( sender == "number_2" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "number_2" ] = true;
    
        private.ClkDoneNumber2();
      
      end;

      ObjAnimate( "spr_superpuzzle1_numerals_number_2_1", "alp",   0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_superpuzzle1_mg_2_door",           "pos_y", 0, 0, func_end, { 0,3,23,  0.4,3,23,  1.0,3,-180 } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

    -----------------------------------------------------------------------------------------------------------

    elseif ( sender == "number_4" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "number_4" ] = true;
    
        private.ClkDoneNumber4();
      
      end;

      ObjAnimate( "spr_superpuzzle1_numerals_number_4_1", "alp",     0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_superpuzzle1_mg_4_door",           "alp",     0, 0, "", { 0,3,1,  0.8,3,1,  1.0,3,0 } );
      ObjAnimate( "spr_superpuzzle1_mg_4_door",           "scale_x", 0, 0, func_end, { 0,3,1,  0.4,3,1,  1.0,3,0.1 } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

    -----------------------------------------------------------------------------------------------------------

    elseif ( sender == "number_6" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "number_6" ] = true;
    
        private.ClkDoneNumber6();
      
      end;

      ObjAnimate( "spr_superpuzzle1_numerals_number_6_1", "alp",     0, 0, "", { 0,3,0,  0.4,3,1 } );
      ObjAnimate( "spr_superpuzzle1_mg_6_door",           "alp",     0, 0, "", { 0,3,1,  0.8,3,1,  1.0,3,0 } );
      ObjAnimate( "spr_superpuzzle1_mg_6_door",           "scale_x", 0, 0, "", { 0,3,1,  0.4,3,1,  1.0,3,0.1 } );

      ObjSet( "spr_superpuzzle1_hint_mg_6", { alp = 1 } );
      ObjAnimate( "spr_superpuzzle1_hint_light", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1,  0.6,3,0.5,  0.8,3,0,  1.0,3,1 } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

    -----------------------------------------------------------------------------------------------------------

    elseif ( sender == "number_7" ) then

      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.clk_done[ "number_7" ] = true;
    
        private.ClkDoneNumber7();
      
      end;

      ObjAnimate( "spr_superpuzzle1_numerals_number_7", "pos_y",   0, 0, "", { 0,3,150,  0.8,3,380 } );
      ObjAnimate( "spr_superpuzzle1_numerals_number_7", "scale_y", 0, 0, func_end, { 0,3,1,  0.8,3,0.1 } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk7", 0, "", 0 );

    end;

  end;
  --******************* **************************************************************************************************
  function private.ClkDonePanel ()

    local table_multiset = {};  

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_panel",     { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_numerals_click_buttons", { input = true } } );
    table.insert( table_multiset, { "anm_superpuzzle1_button_click",           { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_clk_tv",                 { input = true } } );


    ObjMultiSet( table_multiset )

  end;
  --******************* **************************************************************************************************
  function private.ClkDoneNumber1 ()

    local table_multiset = {};  

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_1",  { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_1_circles",           { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_1_1",    { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_1_cover",             { pos_y = -320 } } );

    ObjMultiSet( table_multiset )

  end;
  --******************* **************************************************************************************************
  function private.ClkDoneNumber2 ()

    local table_multiset = {};  

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_2",  { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_2_squares",           { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_2_1",    { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_2_door",              { pos_y = -180 } } );

    ObjMultiSet( table_multiset )

  end;
  --******************* **************************************************************************************************
  function private.ClkDoneNumber4 ()

    local table_multiset = {};  

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_4",  { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_4_arrows",            { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_4_1",    { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_4_door",              { alp   = 0 } } );

    ObjMultiSet( table_multiset )

  end;
  --******************* **************************************************************************************************
  function private.ClkDoneNumber6 ()

    local table_multiset = {};  

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_6",  { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_6_buttons",           { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_6_1",    { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_6_door",              { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_6",              { alp   = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_light",             { alp   = 1 } } );

    ObjMultiSet( table_multiset )

  end;
  --******************* **************************************************************************************************
  function private.ClkDoneNumber7 ()

    local table_multiset = {};  

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_7",  { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c_2",               { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_7",      { pos_y = 380 } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ClkResetSet ()

    private.clk_done[ "panel" ]    = false;
    private.clk_done[ "number_1" ] = false;
    private.clk_done[ "number_2" ] = false;
    private.clk_done[ "number_4" ] = false;
    private.clk_done[ "number_6" ] = false;

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].clk_done = private.clk_done;

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_panel",     { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_numerals_click_buttons", { input = false } } );
    table.insert( table_multiset, { "anm_superpuzzle1_button_click",           { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_clk_tv",                 { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_1",  { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_1_circles",           { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_1_1",    { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_1_cover",             { pos_y = -10 } } );

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_2",  { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_2_squares",           { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_2_1",    { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_2_door",              { pos_y = 23 } } );

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_4",  { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_4_arrows",            { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_4_1",    { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_4_door",              { alp   = 1, scale_x = 1 } } );

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_6",  { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_6_buttons",           { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_6_1",    { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_6_door",              { alp   = 1, scale_x = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_6",              { alp   = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_light",             { alp   = 0 } } );

    table.insert( table_multiset, { "obj_superpuzzle1_numerals_clk_number_7",  { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c_2",               { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_numerals_number_7",      { pos_y = 150, scale_y = 1 } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.LoadClkDone ( event_name )

    if ( private.clk_done[ event_name ] ) then

      private.clk_func_done[ event_name ]();

    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Circles ***() end
--*********************************************************************************************************************
  function private.CirclesClk ( number_circle )

    local list_move = private.circles_derections[ number_circle ];
  
    for i = 1, #list_move do
    
      local func_end = nil;

      if ( i == 1 ) then

        func_end = function () private.CirclesClkEnd( list_move ); end;

      end;

      private.CirclesAnim( i, list_move[ i ], func_end );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CirclesAnim ( number_circle, delta, func_end )

    local obj_name = "spr_superpuzzle1_mg_1_circle_"..number_circle;

    local old_number     = private.circles.current_list[ number_circle ];
    local current_number = private.circles.current_list[ number_circle ] + delta;

    if ( current_number < 1 ) then

      current_number = current_number + 4;

    end;

    if ( current_number > 4 ) then

      current_number = current_number - 4;

    end;

    local anm_ang = private.circles_ang[ old_number ] - ( math.pi / 2 ) * delta;

    local old_ang = ObjGet( obj_name ).ang;
    local new_ang = private.circles_ang[ current_number ];

    local func_anim_end = function ()

      common_impl.Lock( false );

      if ( func_end ) then

        func_end();

      end;

    end;

    common_impl.Lock( true );

    ObjAnimate( obj_name, "ang", 0, 0, func_anim_end, 
    { 
      0,   3, old_ang, 
      0.3, 3, anm_ang,
      0.3, 3, new_ang
    } );

  end;
  --*********************************************************************************************************************
  function private.CirclesClkEnd ( list_move )

    for i = 1, #list_move do
    
      local current_number = private.circles.current_list[ i ] + list_move[ i ];

      if ( current_number < 1 ) then

        current_number = current_number + 4;

      end;

      if ( current_number > 4 ) then

        current_number = current_number - 4;

      end;

      private.circles.current_list[ i ] = current_number;

    end;

    local flag_win = true;

    for c = 1, #private.circles.current_list do
    
      if ( private.circles.current_list[ c ] ~= private.circles_win_list[ c ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.CirclesWinAnim();

    else

      for i = 1, #private.circles.current_list do
    
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.current_list[ i ] = private.circles.current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.CirclesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.circles.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.win = true;

      private.CirclesWinSet();

    end;

    ObjAnimate( "spr_superpuzzle1_mg_1_pin",     "pos_y", 0, 0, "", { 0.0,3,182,  0.5,3,60 } );
    ObjAnimate( "obj_superpuzzle1_mg_1_circles", "pos_y", 0, 0, func_end, { 0.0,3,0,  0.5,3,0,  1.2,3,-210 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk8", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CirclesWinSet ()

    local table_multiset = {};

    private.circles.current_list = { 1, 1, 1 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.current_list = { 1, 1, 1 };

    table.insert( table_multiset, { "obj_superpuzzle1_mg_1_circles",    { input = false, pos_y = -210 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_a",          { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_1_pin",        { pos_y = 60 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.CirclesResetSet ()

    local table_multiset = {};

    private.circles.current_list = { 2, 1, 3 };
    private.circles.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.current_list = { 2, 1, 3 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].circles.win = false;

    table.insert( table_multiset, { "obj_superpuzzle1_mg_1_circles",  { input = false, pos_y = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_a",        { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_1_pin",      { pos_y = 182 } } );

    for i = 1, #private.circles.current_list do
      
      local ang = private.circles_ang[ private.circles.current_list[ i ] ]; 
                      
      table.insert( table_multiset, { "spr_superpuzzle1_mg_1_circle_"..i, { ang = ang } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Squares ***() end
--*********************************************************************************************************************
  function private.SquaresClk ( number )

    common_impl.Lock( true );

    local func_unlock = function ()

      common_impl.Lock( false );

    end;

    local obj_name  = "spr_superpuzzle1_mg_2_square_"..number;
    local over_name = "spr_superpuzzle1_mg_2_over_"..number;
   
    local prev_number = private.squares_prev_number;

    if ( private.squares_prev_number == number ) then

      ObjAnimate( obj_name,  "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
      ObjAnimate( over_name, "alp", 0, 0, "", { 0,3,0,  0.2,3,0,  0.2,3,1 } );

      private.squares_prev_number = "";

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    elseif ( private.squares_prev_number ~= "" ) then

      local obj_name_prev  = "spr_superpuzzle1_mg_2_square_"..private.squares_prev_number;
      local over_name_prev = "spr_superpuzzle1_mg_2_over_"..private.squares_prev_number;

      if ( private.squares_list[ number ] == private.squares_list[ private.squares_prev_number ] ) then

        ObjSet( obj_name,      { input = false } );
        ObjSet( obj_name_prev, { input = false } );

        local func_anim_end = function ()

          common_impl.Lock( false );

          private.SquaresCheck( number, prev_number );

        end;

        ObjAnimate( obj_name,  "scale_x", 0, 0, func_anim_end, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
        ObjAnimate( over_name, "alp",     0, 0, "",            { 0,3,1,  0.2,3,1,  0.2,3,0 } );

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

      else

        ObjAnimate( obj_name,  "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1,  1.0,3,1,  1.2,3,0,  1.4,3,1 } );
        ObjAnimate( over_name, "alp",     0, 0, "",          { 0,3,1,  0.2,3,1,  0.2,3,0,  1.2,3,0,  1.2,3,1 } );

        ObjAnimate( obj_name_prev,  "scale_x", 0, 0, "", { 0,3,1,  1.0,3,1,  1.2,3,0,  1.4,3,1 } );
        ObjAnimate( over_name_prev, "alp",     0, 0, "", { 0,3,0,  1.2,3,0,  1.2,3,1 } );

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      end;

      private.squares_prev_number = "";

    else

      ObjAnimate( obj_name,  "scale_x", 0, 0, func_unlock, { 0,3,1,  0.2,3,0,  0.4,3,1 } );
      ObjAnimate( over_name, "alp", 0, 0, "", { 0,3,1,  0.2,3,1,  0.2,3,0 } );

      private.squares_prev_number = number;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.SquaresCheck ( number, prev_number )

    private.squares.current_list[ number ]      = true;
    private.squares.current_list[ prev_number ] = true;

    local flag_win = true;
    
    for i = 1, #private.squares.current_list do
      
      if ( not private.squares.current_list[ i ] ) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.SquaresWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.current_list[ number ]      = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.current_list[ prev_number ] = true;

    end;

  end;
  --*********************************************************************************************************************
  function private.SquaresWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.squares.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.win = true;

      private.SquaresWinSet();

    end;

    ObjAnimate( "obj_superpuzzle1_mg_2_squares", "pos_y", 0, 0, "", { 0,3,-282,  0.4,3,-430 } );
    ObjAnimate( "obj_superpuzzle1_mg_3_ampules", "pos_y", 0, 0, "", { 0,3,140,  0.4,3,0 } );

    ObjSet( "spr_superpuzzle1_hint_mg_3", { alp = 1 } );
    ObjAnimate( "spr_superpuzzle1_hint_light", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1,  0.6,3,0.5, 0.8,3,0, 1.0,3,1  } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SquaresWinSet ()

    local table_multiset = {};

    private.squares.current_list = { true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true, true };

    table.insert( table_multiset, { "obj_superpuzzle1_mg_2_squares", { input = false, pos_y = -430 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_3_ampules", { input = true,  pos_y = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_3",    { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_light",   { alp = 1 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.SquaresResetSet ()

    local table_multiset = {};

    private.squares.current_list = { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false };
    private.squares.win = false;                  

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.current_list = { false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false, false };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].squares.win = false;

    private.squares_prev_number = "";
    
    table.insert( table_multiset, { "obj_superpuzzle1_mg_2_squares", { input = false, pos_y = -282 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_3_ampules", { input = false, pos_y = 140 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_3",    { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_light",   { alp = 0 } } );

    for i = 1, #private.squares.current_list do
        
      table.insert( table_multiset, { "spr_superpuzzle1_mg_2_square_"..i, { input = true } } );
      table.insert( table_multiset, { "spr_superpuzzle1_mg_2_over_"..i, { alp = 1 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Ampules ***() end
--*********************************************************************************************************************
  function private.AmpulesClk ( number )

    common_impl.Lock( true );

    ObjSet( "spr_superpuzzle1_mg_3_ampule_"..number, { input = false } );

    local func_end = function ()

      common_impl.Lock( false );

      private.AmpulesClkEnd( number );

    end;
  
    ObjAnimate( "spr_superpuzzle1_mg_3_ampule_"..number, "pos_y", 0, 0, func_end, 
    { 
      0,   3, 298,  
      0.4, 3, 320 
    } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk5", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.AmpulesClkEnd ( number )

    private.ampules.current_list[ private.ampules.index ] = number;
    
    local flag_win = true;

    for i = 1, #private.ampules_win_list do
      
      if ( private.ampules.current_list[ i ] ~= private.ampules_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.AmpulesWinAnim();

    elseif ( private.ampules.index == #private.ampules_win_list ) then

      private.AmpulesResetAnim();

    else

      private.ampules.index = private.ampules.index + 1;

      ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.index = private.ampules.index;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.current_list[ private.ampules.index ] = number;

    end;

  end;
  --*********************************************************************************************************************
  function private.AmpulesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.ampules.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.win = true;

      private.AmpulesWinSet();

    end;

    ObjAnimate( "spr_superpuzzle1_hint_mg_3", "alp", 0, 0, "", 
    { 
      0,   3, 1,  
      0.4, 3, 0 
    } );  

    ObjAnimate( "obj_superpuzzle1_mg_3_ampules", "pos_y", 0, 0, "", 
    { 
      0,   3, 0,  
      0.7, 3, 140 
    } );    

    ObjAnimate( "spr_superpuzzle1_mg_3_door", "pos_y", 0, 0, func_end, 
    { 
      0,   3, -7,  
      0.7, 3, -7,  
      1.4, 3, -80 
    } );   

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk9", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.AmpulesWinSet ()

    private.ampules.current_list = { 1, 3, 5, 2, 4 };

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle1_mg_3_ampules", { input = false, pos_y = 140 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_3_door",    { pos_y = -80 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_n",       { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_3",    { alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.AmpulesResetAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.ampules.index = 1;
      private.ampules.current_list = { 0, 0, 0 };

      ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.index = 1;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.current_list = { 0, 0, 0 };

      for i = 1, #private.ampules_win_list do 
        
        ObjSet( "spr_superpuzzle1_mg_3_ampule_"..i, { input = true } );

      end;

    end;

    for i = 1, #private.ampules_win_list do

      if ( i ~= 1 ) then

        func_end = "";

      end;

      ObjAnimate( "spr_superpuzzle1_mg_3_ampule_"..i, "pos_y", 0, 0, func_end, 
      { 
        0,   3, 320,  
        0.4, 3, 298 
      } );    

    end;

    common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.AmpulesResetSet ()

    private.ampules.index = 1;
    private.ampules.current_list = { 0, 0, 0 };
    private.ampules.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.index = 1;
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.current_list = { 0, 0, 0 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].ampules.win = false;

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle1_mg_3_ampules", { input = true,  pos_y = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_3_door",    { pos_y = -7 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_n",       { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_3",    { alp = 0 } } );

    for i = 1, #private.ampules_win_list do 
      
      table.insert( table_multiset, { "spr_superpuzzle1_mg_3_ampule_"..i, { input = true, pos_y = 298 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Symbols ***() end
--*********************************************************************************************************************
  function private.SymbolsArrowEnter ( name )

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle1_mg_4_light_"..name, { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.SymbolsArrowLeave ( name )

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle1_mg_4_light_"..name, { alp = 0 } );

  end;
--*********************************************************************************************************************
  function private.SymbolsClk ( direction )

    local offset_x;
    local offset_y;

    if ( direction == "left" ) then

      offset_x = -1;
      offset_y = 0

    elseif ( direction == "up" ) then

      offset_x = 0;
      offset_y = -1

    elseif ( direction == "right" ) then

      offset_x = 1;
      offset_y = 0

    elseif ( direction == "down" ) then

      offset_x = 0;
      offset_y = 1

    end;

    local time_delay = 0;
    local time_delta = 0.003;
    local new_pos_list = {};

    local sequence = private.SymbolsSequence( direction );

    for s = 1,3 do
  
      local index = sequence[ s ];

      if ( not private.symbols.done[ index ] ) then

        local new_pos = private.SymbolsNewPos( index, offset_x, offset_y, new_pos_list );
        local extra_x = 0;
        local extra_y = 0;

        if ( direction == private.symbols_direction_win[ index ] ) and 
           ( new_pos[ 1 ] == private.symbols_pos_x_win[ index ] ) and 
           ( new_pos[ 2 ] == private.symbols_pos_y_win[ index ] ) then

          private.symbols.done[ index ] = true;

          if ( direction == "up" ) then

            extra_y = -1.1;

          elseif ( direction == "right" ) then

            extra_x = 1.3;

          end;

        else

          table.insert( new_pos_list, { index = index, pos_x = new_pos[ 1 ], pos_y = new_pos[ 2 ] } );

        end;

        local obj_name = "spr_superpuzzle1_mg_4_symbol_"..index;

        local old_x = private.symbols_begin_x + ( private.symbols.pos_x_list[ index ] - 1 ) * private.symbols_step; 
        local old_y = private.symbols_begin_y + ( private.symbols.pos_y_list[ index ] - 1 ) * private.symbols_step;                     
        local new_x = private.symbols_begin_x + ( new_pos[ 1 ] - 1 + extra_x ) * private.symbols_step; 
        local new_y = private.symbols_begin_y + ( new_pos[ 2 ] - 1 + extra_y ) * private.symbols_step;                     

        local tme = ( math.abs( old_x - new_x ) + math.abs( old_y - new_y ) ) * time_delta;

        time_delay = math.max( time_delay, tme );

        local func_end = function ()

          common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk5", 0, "", 0 );
          
        end;

        ObjAnimate( obj_name, "pos_xy", 0, 0, func_end, { 
          0.0,  0,  old_x,  old_y,
          tme,  0,  new_x,  new_y
        } );

      end;

    end;

    common_impl.Lock( true );
  
    ObjSet( "tmr_superpuzzle1_mg_4_symbols", { playing = true, time = time_delay, endtrig = function ()

      common_impl.Lock( false );

      private.SymbolsClkEnd( new_pos_list );

    end } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SymbolsNewPos ( index, offset_x, offset_y, busy_list )

    local cur_x = private.symbols.pos_x_list[ index ];
    local cur_y = private.symbols.pos_y_list[ index ];

    local new_x = cur_x;
    local new_y = cur_y;

    for i = 1,6 do

      cur_x = cur_x + offset_x;
      cur_y = cur_y + offset_y;

      local busy_flag = false;

      for b = 1, #busy_list do
  
        if ( cur_x == busy_list[ b ].pos_x ) and ( cur_y == busy_list[ b ].pos_y ) then

          busy_flag = true;

        end;

      end;

      if ( cur_x ~= 0 ) and ( cur_x ~= 8 ) and
         ( cur_y ~= 0 ) and ( cur_y ~= 8 ) and
         ( private.symbols_field[ cur_y ][ cur_x ] ~= 1 ) and
         ( not busy_flag )  then
   
        new_x = cur_x;
        new_y = cur_y;
      else

        break;

      end;

    end;

    return { new_x, new_y }

  end;
  --*********************************************************************************************************************
  function private.SymbolsSequence ( direction )

    local pos_x = { private.symbols.pos_x_list[ 1 ], private.symbols.pos_x_list[ 2 ], private.symbols.pos_x_list[ 3 ] }
    local pos_y = { private.symbols.pos_y_list[ 1 ], private.symbols.pos_y_list[ 2 ], private.symbols.pos_y_list[ 3 ] }

    local ind = { 1, 2, 3 };

    local new_ind = {};

    if ( direction == "left" ) then

      for i = 1,3 do
      
        local current = pos_x[ 1 ];

        for p = 2, #pos_x do

          current = math.min( current, pos_x[ p ] );

        end;

        for p = 1, #pos_x do
      
          if ( pos_x[ p ] == current ) then

            table.insert( new_ind, ind[ p ] );

            table.remove( ind,   p );
            table.remove( pos_x, p );

          end;

        end;

      end;

    elseif ( direction == "up" ) then

      for i = 1,3 do
      
        local current = pos_y[ 1 ];

        for p = 2, #pos_y do

          current = math.min( current, pos_y[ p ] );

        end;

        for p = 1, #pos_y do
      
          if ( pos_y[ p ] == current ) then

            table.insert( new_ind, ind[ p ] );

            table.remove( ind,   p );
            table.remove( pos_y, p );

          end;

        end;

      end;

    elseif ( direction == "right" ) then

      for i = 1,3 do
      
        local current = pos_x[ 1 ];

        for p = 2, #pos_x do

          current = math.max( current, pos_x[ p ] );

        end;

        for p = 1, #pos_x do
      
          if ( pos_x[ p ] == current ) then

            table.insert( new_ind, ind[ p ] );

            table.remove( ind,   p );
            table.remove( pos_x, p );

          end;

        end;

      end;

    elseif ( direction == "down" ) then

      for i = 1,3 do
      
        local current = pos_y[ 1 ];

        for p = 2, #pos_y do

          current = math.max( current, pos_y[ p ] );

        end;

        for p = 1, #pos_y do
      
          if ( pos_y[ p ] == current ) then

            table.insert( new_ind, ind[ p ] );

            table.remove( ind,   p );
            table.remove( pos_y, p );

          end;

        end;

      end;

    end;

    return new_ind;

  end;
  --*********************************************************************************************************************
  function private.SymbolsClkEnd ( new_pos_list )

    for p = 1, #new_pos_list do

      local index = new_pos_list[ p ].index;
      local pos_x = new_pos_list[ p ].pos_x;
      local pos_y = new_pos_list[ p ].pos_y;

      private.symbols.pos_x_list[ index ] = pos_x;
      private.symbols.pos_y_list[ index ] = pos_y;

    end;

    local flag_win = true;

    for s = 1, #private.symbols.done do
    
      if ( not private.symbols.done[ s ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.SymbolsWinAnim();

    else

      for i = 1, #private.symbols.pos_x_list do
    
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_x_list[ i ] = private.symbols.pos_x_list[ i ];
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_y_list[ i ] = private.symbols.pos_y_list[ i ];
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.done[ i ]       = private.symbols.done[ i ]

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.SymbolsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.symbols.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.win = true;

      private.SymbolsWinSet();

    end;

    local func_anim_end = function ()

      if ( private.items_done[ "logo_c" ] ) and 
         ( private.items_done[ "logo_n" ] ) then

        private.HexsActiveAnim( func_end );

      else

        func_end();

      end;

    end;

    ObjAnimate( "spr_superpuzzle1_red_2", "alp", 0, 0, "", 
    { 
      0,   3, 1,  
      0.4, 3, 0 
    } );  

    ObjAnimate( "spr_superpuzzle1_green_2", "alp", 0, 0, func_anim_end, 
    { 
      0,   3, 0,  
      0.4, 3, 1, 
      0.5, 3, 0.5,  
      0.7, 3, 1, 
      0.8, 3, 0.5,  
      1.0, 3, 1, 
    } );  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_lamp", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SymbolsWinSet ()

    local table_multiset = {};

    private.symbols.done = { true, true, true };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.done = { true, true, true };

    table.insert( table_multiset, { "obj_superpuzzle1_mg_4_arrows",    { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_red_2",          { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_green_2",        { alp = 1 } } );

    for i = 1, #private.symbols_pos_x_done do
      
      local pos_x = private.symbols_pos_x_done[ i ]; 
      local pos_y = private.symbols_pos_y_done[ i ];                     

      table.insert( table_multiset, { "spr_superpuzzle1_mg_4_symbol_"..i, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    if ( private.items_done[ "logo_c" ] ) and 
       ( private.items_done[ "logo_n" ] ) then

      private.HexsActiveSet();

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.SymbolsResetSet ()

    local table_multiset = {};

    private.symbols.win = false;
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.win = false;

    private.symbols.done = { false, false, false };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.done = { false, false, false };

    private.symbols.pos_x_list = { 5, 4, 3 };
    private.symbols.pos_y_list = { 4, 5, 4 };

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_x_list = { 5, 4, 3 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].symbols.pos_y_list = { 4, 5, 4 };

    table.insert( table_multiset, { "obj_superpuzzle1_mg_4_arrows",    { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_red_2",          { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_green_2",        { alp = 0 } } );

    for i = 1, #private.symbols.pos_x_list do
      
      local pos_x = private.symbols_begin_x + ( private.symbols.pos_x_list[ i ] - 1 ) * private.symbols_step; 
      local pos_y = private.symbols_begin_y + ( private.symbols.pos_y_list[ i ] - 1 ) * private.symbols_step;                     

      table.insert( table_multiset, { "spr_superpuzzle1_mg_4_symbol_"..i, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Tapes ***() end
--*********************************************************************************************************************
  function private.TapesClk ( number_tape )

    local obj_name = "obj_superpuzzle1_mg_6_tape_"..number_tape;

    local old_number     = private.tapes.current_list[ number_tape ];
    local current_number = private.tapes.current_list[ number_tape ] + 1;

    if ( current_number > 4 ) then

      current_number = 1;

    end;

    local old_y = private.tapes_begin_pos_y + ( old_number - 1 ) * private.tapes_begin_step; 
    local anm_y = old_y + private.tapes_begin_step;
    local new_y = private.tapes_begin_pos_y + ( current_number - 1 ) * private.tapes_begin_step; 

    local func_anim_end = function ()

      common_impl.Lock( false );

      private.TapesClkEnd( number_tape );

    end;

    common_impl.Lock( true );

    ObjAnimate( obj_name, "pos_y", 0, 0, func_anim_end, 
    { 
      0,   3, old_y, 
      0.3, 3, anm_y,
      0.3, 3, new_y
    } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.TapesClkEnd ( number_tape )

    local current_number = private.tapes.current_list[ number_tape ] + 1;

    if ( current_number > 4 ) then

      current_number = 1;

    end;

    private.tapes.current_list[ number_tape ] = current_number;

    local flag_win = true;

    for c = 1, #private.tapes.current_list do
    
      if ( private.tapes.current_list[ c ] ~= private.tapes_win_list[ c ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.TapesWinAnim();

    else

      for i = 1, #private.tapes.current_list do
    
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.current_list[ i ] = private.tapes.current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.TapesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.tapes.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.win = true;

      private.TapesWinSet();

    end;

    ObjAnimate( "spr_superpuzzle1_hint_mg_6",  "alp",   0, 0, "", { 0,3,1,  0.4,3,0 } );
    ObjAnimate( "obj_superpuzzle1_mg_5_field", "pos_y", 0, 0, func_end, { 0.0,3,-240,  0.6,3,0 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.TapesWinSet ()

    local table_multiset = {};

    private.tapes.current_list = { 2, 3, 4 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.current_list = { 2, 3, 4 };

    table.insert( table_multiset, { "obj_superpuzzle1_mg_6_buttons",      { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_pictures",     { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_field",        { pos_y = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle1_hint_mg_6",         { alp   = 0 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.TapesResetSet ()

    local table_multiset = {};

    private.tapes.current_list = { 1, 1, 1 };
    private.tapes.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.current_list = { 1, 1, 1 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].tapes.win = false;

    table.insert( table_multiset, { "obj_superpuzzle1_mg_6_buttons",      { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_pictures",     { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_field",        { pos_y = -240 } } );

    for i = 1, #private.tapes.current_list do
      
      local pos_y = private.tapes_begin_pos_y + ( private.tapes.current_list[ i ] - 1 ) * private.tapes_begin_step; 
                      
      table.insert( table_multiset, { "obj_superpuzzle1_mg_6_tape_"..i, { pos_y = pos_y } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Pictures ***() end
--*********************************************************************************************************************
  function private.PicturesEnter ( number )

    common_impl.SetCursor( CURSOR_HAND );

  end;
--*********************************************************************************************************************
  function private.PicturesLeave ( number )

    common_impl.SetCursor( CURSOR_DEFAULT );

  end;
--*********************************************************************************************************************
  function private.PicturesClk ( number )

    local obj_name = "spr_superpuzzle1_mg_5_picture_"..number;
   
    local prev_number = private.pictures_prev_number;

    if ( private.pictures_prev_number == number ) then

      private.PicturesLightOff();

      private.pictures_enabled     = {};
      private.pictures_prev_number = "";

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk5", 0, "", 0 );

    elseif ( private.pictures_prev_number ~= "" ) then

      local obj_name_prev  = "spr_superpuzzle1_mg_5_picture_"..private.pictures_prev_number;

      local flag_move = false;

      for i = 1, #private.pictures_enabled  do
    
        local number_enabled = private.pictures.current_list[ private.pictures_enabled[ i ][ 1 ] ][ private.pictures_enabled[ i ][ 2 ] ];

        if ( number_enabled == number ) then

          flag_move = true; 

        end;

      end;

      if ( flag_move ) then

        common_impl.Lock( true );

        local func_anim_end = function ()

          common_impl.Lock( false );

          private.PicturesCheck( number, prev_number );

        end;

        local params      = ObjGet( obj_name );
        local params_prev = ObjGet( obj_name_prev );

        ObjAnimate( obj_name,      "pos_xy", 0, 0, "", {
          0,    3,  params.pos_x,      params.pos_y, 
          0.4,  3,  params_prev.pos_x, params_prev.pos_y 
        } );

        ObjAnimate( obj_name_prev, "pos_xy", 0, 0, func_anim_end, { 
          0,    3,  params_prev.pos_x, params_prev.pos_y, 
          0.4,  3,  params.pos_x,      params.pos_y 
        } );

        private.PicturesLightOff();

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

      else

        private.PicturesLightOff();

        private.pictures_enabled     = {};
        private.pictures_prev_number = "";

        common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk5", 0, "", 0 );

      end;

      private.pictures_prev_number = "";

    else

      local enabled = private.PicturesEnabled( number );

      for i = 1, #enabled do
    
        local number_enabled = private.pictures.current_list[ enabled[ i ][ 1 ] ][ enabled[ i ][ 2 ] ];
        ObjSet( "spr_superpuzzle1_mg_5_picture_"..number_enabled.."_light", { alp = 1 } );

      end;

      private.pictures_enabled     = enabled;
      private.pictures_prev_number = number;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk5", 0, "", 0 );

    end;

    --common_impl.PlayAudio( "sfx", "aud_mg_superpuzzle_windmill_click", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PicturesEnabled ( number )

    local enabled = {};

    local current_pos = private.PicturesGetPosArray( number );

    if ( current_pos[ 1 ] > 1 ) then

      table.insert( enabled, { current_pos[ 1 ] - 1, current_pos[ 2 ] } )

    end;

    if ( current_pos[ 1 ] < #private.pictures.current_list ) then

      table.insert( enabled, { current_pos[ 1 ] + 1, current_pos[ 2 ] } )

    end;

    if ( current_pos[ 2 ] > 1 ) then

      table.insert( enabled, { current_pos[ 1 ], current_pos[ 2 ] - 1 } )

    end;

    if ( current_pos[ 2 ] < #private.pictures.current_list[ 1 ] ) then

      table.insert( enabled, { current_pos[ 1 ], current_pos[ 2 ] + 1 } )

    end;

    return enabled;

  end;
  --*********************************************************************************************************************
  function private.PicturesGetPosArray ( number )

    for i = 1, #private.pictures.current_list do
    
      for j = 1, #private.pictures.current_list[ i ] do
        
        if ( private.pictures.current_list[ i ][ j ] == number ) then

          return { i, j };

        end;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesLightOff ()

    for i = 1, 12 do
      
      ObjSet( "spr_superpuzzle1_mg_5_picture_"..i.."_light", { alp = 0 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesCheck ( number, prev_number )

    local pos_cur = private.PicturesGetPosArray( number );
    local pos_pre = private.PicturesGetPosArray( prev_number );

    private.pictures.current_list[ pos_cur[ 1 ] ][ pos_cur[ 2 ] ] = prev_number;
    private.pictures.current_list[ pos_pre[ 1 ] ][ pos_pre[ 2 ] ] = number;

    local flag_win = true;
    
    for i = 1, #private.pictures.current_list do
    
      for j = 1, #private.pictures.current_list[ i ] do
        
        if ( private.pictures.current_list[ i ][ j ] ~= private.pictures_win_list[ i ][ j ] ) then

          flag_win = false;
          break;

        end;

      end;

      if ( not flag_win ) then

        break;

      end;

    end;

    if ( flag_win ) then

      private.PicturesWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list[ pos_cur[ 1 ] ][ pos_cur[ 2 ] ] = prev_number;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list[ pos_pre[ 1 ] ][ pos_pre[ 2 ] ] = number;

    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.pictures.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.win = true;

      private.PicturesWinSet();

    end;

    ObjAnimate( "obj_superpuzzle1_mg_5_field", "pos_y", 0, 0, "", { 0.0,3,0,  0.6,3,-240 } );
    ObjAnimate( "spr_superpuzzle1_mg_6_catch", "pos_y", 0, 0, func_end, { 0.0,3,0,  0.6,3,0,  1.0,3,60 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PicturesWinSet ()

    local table_multiset = {};

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list = {
      { 1,  2,  3,  4 },
      { 5,  6,  7,  8 },
      { 9, 10, 11, 12 }
    };

    table.insert( table_multiset, { "spr_superpuzzle1_mg_6_catch",     { pos_y = 60 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_field",     { pos_y = -240 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_pictures",  { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c",         { input = true } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.PicturesResetSet ()

    local table_multiset = {};

    private.pictures.current_list = {
      { 7, 12,  5,   4 },
      { 6,  1,  8,  11 },
      { 10, 3,  2,   9 }
    };

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.current_list = {
      { 7, 12,  5,   4 },
      { 6,  1,  8,  11 },
      { 10, 3,  2,   9 }
    };

    private.pictures.win = false;                  
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].pictures.win = false;

    private.pictures_prev_number = "";

    table.insert( table_multiset, { "spr_superpuzzle1_mg_6_catch",     { pos_y = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_field",     { pos_y = -240 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_5_pictures",  { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_c",         { input = false } } );

    for i = 1, #private.pictures.current_list do
    
      for j = 1, #private.pictures.current_list[ i ] do
        
        local pos_x  = private.pictures_begin_x + ( j - 1 ) * private.pictures_step; 
        local pos_y  = private.pictures_begin_y + ( i - 1 ) * private.pictures_step;                     
        local number = private.pictures.current_list[ i ][ j ];

        table.insert( table_multiset, { "spr_superpuzzle1_mg_5_picture_"..number, { pos_x = pos_x, pos_y = pos_y } } );

      end;

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Hexs ***() end
--*********************************************************************************************************************
  function private.HexsActiveAnim ( func_end )

    common_impl.Lock( true );

    local func_anim_end = function ()

      common_impl.Lock( false );

      if ( func_end ) then

        func_end();

      end

    end;

    ObjAnimate( "obj_superpuzzle1_mg_7", "pos_y", 0, 0, func_anim_end, { 0,3,270,  0.4,3,-270 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk4", 0, "", 0 );

  end;
--*********************************************************************************************************************
  function private.HexsHide ( func_end )

    common_impl.Lock( true );

    local func_anim_end = function ()

      common_impl.Lock( false );

      if ( func_end ) then

        func_end();

      end

    end;

    ObjAnimate( "obj_superpuzzle1_mg_7", "pos_y", 0, 0, func_anim_end, { 0,3,-270,  0.4,3,270 } );

    --common_impl.PlayAudio( "sfx", "aud_mg_superpuzzle1"_wheel_click", 0, "", 0 );

  end;
--*********************************************************************************************************************
  function private.HexsActiveSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle1_mg_7_buttons",  { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_7",          { pos_y = -270 } } );
      
    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
  function private.HexsClk ( number )

    common_impl.Lock( true );

    local hex_numbers = private.hex_numbers[ number ];

    local func_end = function ()

      private.HexsClkEnd( hex_numbers );

      common_impl.Lock( false );

    end;

    if ( number == 2 ) then

      local obj_name_1 = "spr_superpuzzle1_mg_7_hex_"..private.hexs.current_list[ hex_numbers[ 2 ] ];
      local obj_name_2 = "spr_superpuzzle1_mg_7_hex_"..private.hexs.current_list[ hex_numbers[ 3 ] ];

      ObjAttach( obj_name_1, "obj_superpuzzle1_mg_7_offset_2_2" );
      ObjAttach( obj_name_2, "obj_superpuzzle1_mg_7_offset_2_3" );

    end;

    local new_ang = - 2.12;

    ObjAnimate( "obj_superpuzzle1_mg_7_circle_"..number, "ang", 0, 0, func_end, { 
      0,    3,  0,  
      0.4,  3,  new_ang
    } );

    for i = 1,3 do
    
      local num_hex = private.hexs.current_list[ hex_numbers[ i ] ];

      ObjAnimate( "spr_superpuzzle1_mg_7_hex_"..num_hex, "ang", 0, 0, "", { 
        0,    3,  0,  
        0.4,  3,  - new_ang
      } );

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk10", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.HexsClkEnd ( hex_numbers )

    private.hexs.current_list[ hex_numbers[ 2 ] ],
    private.hexs.current_list[ hex_numbers[ 3 ] ],
    private.hexs.current_list[ hex_numbers[ 1 ] ] =

    private.hexs.current_list[ hex_numbers[ 1 ] ],
    private.hexs.current_list[ hex_numbers[ 2 ] ],
    private.hexs.current_list[ hex_numbers[ 3 ] ];

    for i = 1, #private.hex_attach do

      ObjSet( "obj_superpuzzle1_mg_7_circle_"..i, { ang = 0 } );

      for j = 1, #private.hex_attach[ i ] do

        if ( private.hex_attach[ i ][ j ] ~= 0 ) then

          local number_attach = private.hexs.current_list[ private.hex_attach[ i ][ j ] ];
          
          ObjAttach( "spr_superpuzzle1_mg_7_hex_"..number_attach, "obj_superpuzzle1_mg_7_offset_"..i.."_"..j );

          ObjSet( "spr_superpuzzle1_mg_7_hex_"..number_attach, { ang = 0 } );

        end

      end;

    end;

    local flag_win = true;

    for c = 1, #private.hexs.current_list do
    
      if ( private.hexs.current_list[ c ] ~= private.hexs_win_list[ c ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.HexsWinAnim();

    else

      for i = 1, #private.hexs.current_list do
    
        ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_list[ i ] = private.hexs.current_list[ i ];

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.HexsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.hexs.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.win = true;

      private.HexsWinSet();

    end;

    ObjAnimate( "spr_superpuzzle1_mg_7_door", "pos_x", 0, 0, func_end, { 0.0,3,0,  0.6,3,70 } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.HexsWinSet ()

    local table_multiset = {};

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_list = { 6, 7, 2, 1, 5, 3, 4 };

    table.insert( table_multiset, { "obj_superpuzzle1_mg_7_buttons", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_e",       { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_7_door",     { pos_x = 70 } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.HexsResetSet ()

    local table_multiset = {};

    private.hexs.current_list = { 6, 7, 4, 3, 1, 2, 5 }
    private.hexs.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.current_list = { 6, 7, 4, 3, 1, 2, 5 };
    ng_global.progress[ "std" ][ "win_superpuzzle1" ].hexs.win = false;

    table.insert( table_multiset, { "obj_superpuzzle1_mg_7_buttons", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_logo_e",       { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle1_mg_7_door",    { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle1_mg_7",         { pos_y = 270 } } );

    for i = 1, #private.hex_attach do

      for j = 1, #private.hex_attach[ i ] do

        if ( private.hex_attach[ i ][ j ] ~= 0 ) then

          local number_attach = private.hexs.current_list[ private.hex_attach[ i ][ j ] ];
          
          ObjAttach( "spr_superpuzzle1_mg_7_hex_"..number_attach, "obj_superpuzzle1_mg_7_offset_"..i.."_"..j );

        end

      end;

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
--*********************************************************************************************************************
  function private.PuszzleHintClk ()

    local postfix = private.GetHintPostfix();

    interface.DialogShow( "ifo_superpuzzle1_hint_"..postfix );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_puzzle_hint", 0, "", 0 );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintEnter ()

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle1_hint_1", { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintLeave ()

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle1_hint_1", { alp = 0 } );

  end;
--*********************************************************************************************************************
  function private.GetHintPostfix ()

    local postfix;

    if     ( not private.clk_done[ "number_1" ] ) or ( not private.clk_done[ "number_2" ] ) or ( not private.clk_done[ "number_4" ] ) or ( not private.clk_done[ "number_6" ] ) or ( not private.clk_done[ "number_7" ] ) then postfix = "1";
    elseif ( private.clk_done[ "number_1" ] ) and ( not private.items_done[ "logo_a" ] )     then postfix = "2";
    elseif ( private.clk_done[ "number_2" ] ) and ( not private.squares.win )                then postfix = "3";
    elseif ( private.squares.win )            and ( not private.items_done[ "logo_n" ] )     then postfix = "4";
    elseif ( private.clk_done[ "number_4" ] ) and ( not private.symbols.win )                then postfix = "5";
    elseif ( private.clk_done[ "number_6" ] ) and ( not private.tapes.win )                  then postfix = "6";
    elseif ( private.tapes.win )              and ( not private.items_done[ "logo_c" ] )     then postfix = "7";
    elseif ( private.items_done[ "logo_c" ] ) and ( not private.items_done[ "logo_e" ] )     then postfix = "8";
    end;

    return postfix;

  end;
--*********************************************************************************************************************
-- function *** TV ***() end
--*********************************************************************************************************************
  function private.TVClk ()

    common_impl.Lock( true );

    local func_end = function ()
    
      common_impl.Lock( false );
      ObjSet( "anm_superpuzzle1_free_click", { alp = 0 } );    

    end;

    ObjSet( "anm_superpuzzle1_free_click", { alp = 1 } );

    AnimPlay( "anm_superpuzzle1_free_click", "DoAnim", func_end );

  end;
--*********************************************************************************************************************