-- name=rm_demo
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "rm_demo";
  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet( "btn_demo_buttons", { 
    event_mdown = function () private.ButtonMouseClick(); end,
    event_menter = function () private.ButtonMouseEnter(); end,
    event_mleave = function () private.ButtonMouseLeave(); end 
  });
  
  if IsSurveyEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_survey" } );

  elseif IsDemoEdition() then
    
    ObjSet( "txt_demo_tnx", { text = "str_demo_txt_demo" } );

  end;
  
  common_impl.hint[ "opn_demo" ] = {
    room = private.room_objname
  };

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  --[[if not ( cmn.IsEventDone( "opn_demo" ) ) then
    cmn.SetEventDone( "opn_demo" );
  end;]]


  if not ( ( IsSurveyEdition() ) or ( IsDemoEdition() ) ) then

    SetCursor(CURSOR_DEFAULT);
    local prg = ng_global.currentprogress;
    ng_global.progress[ prg ].common.chapter = "level2";
    ng_global.progress[ prg ].common.currentroom = nil;
    local level = ng_global.progress[ prg ].common.chapter;

    common.LevelSwitch( level );

  else

    if ( IsCollectorsEdition() ) then

      ObjSet( "spr_demo_collectors", { visible = 1 } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()
--    DbgTrace("enter1")
--  if ( (IsSurveyEdition() ) or ( IsDemoEdition()) ) then
--
    ObjAnimate( "rm_demo", "color_rgb", 0, 0, "", 
    { 
      0.0, 0, 0, 0, 0,
      0.3, 0, 0, 0, 0,
      0.5, 0, 1, 1, 1
    } );

    --interface.InterfaceSetInput( 0 ); 
    --interface.InterfaceSetVisible( 0, 0 );

--  else
--
--    DbgTrace("enter")
--    ObjSet( "rm_demo", 
--    { 
--      color_r = 0.0,
--      color_g = 0.0,
--      color_b = 0.0
--    } );
--
--    interface.InterfaceSetInput( 0 ); 
--    interface.InterfaceSetVisible( 0, 0 );
--
--  end;
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.ButtonMouseEnter()

  SetCursor( CURSOR_HAND );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * ( 1 - but_alp ) ), 0, 1 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseLeave()

  SetCursor( CURSOR_DEFAULT );  
  local but_name = "spr_demo_ok_focus";
  local but_alp = ObjGet( but_name ).alp;
  ObjAnimate( but_name, 8, 0, 0, "", { 0, 0, but_alp, ( private.MOUSE_OVER_ANIM_TIME * but_alp ), 0, 0 } );

end;
--*********************************************************************************************************************
function private.ButtonMouseClick()

  if ( IsSurveyEdition() ) then

    --local guide_url = GetGuideUrl();
    --OpenBrowser( guide_url );

    Quit();

  else

    SaveProfiles();
    SaveSettings();

--  common.SaveInterfaceTimers();
    SetCursor( CURSOR_DEFAULT );
    common.LevelSwitch( "menu", "game" );

  end;  

end;
--*********************************************************************************************************************