-- name=rm_bar_2
--*********************************************************************************************************************
function public.Init ()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bar_2";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  private.InitAnimations();
  
  --ObjMultiSet({ 
  --});
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_bar_2 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_bar_2_",
    "gzz_bar_2_"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_bar_2", update_game_mode_bar_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_bar_2 = function ()

  local effects_table = 
  {
    "obj_bar_2_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_bar_2", update_performance_mode_bar_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_bar_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_bar_2_map = function ()

    common_impl.VisitMapRoom( "bar" );

  end;
  cmn.AddSubscriber( "opn_bar_2", opn_bar_2_map );
  

end;
--*********************************************************************************************************************
function public.Load ()
end;
--*********************************************************************************************************************
function private.Init_Subroom ()
end;
--*********************************************************************************************************************
function public.Open ()

  private.opn_bar_2();

  cmn.CallEventHandler( "update_game_mode_"..common.GetObjectName( private.room_objname ) );  
  cmn.CallEventHandler( "update_performance_mode_"..common.GetObjectName( private.room_objname ) );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.MorphItemMorphing();

end;
--*********************************************************************************************************************
function public.Close ()

end;
--*********************************************************************************************************************
function public.PreClose ()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_bar_2 ()

  if not ( cmn.IsEventDone( "opn_bar_2" ) ) then

    cmn.SetEventDone( "opn_bar_2" );

  end;

  cmn.CallEventHandler( "opn_bar_2" ); 

end;
--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_bar_light_2", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 1.0,
      2.1, 0, 0.0,
      2.2, 0, 1.0, 
      2.3, 0, 0.0,
      4.9, 0, 0.0,
      5.0, 0, 1.0
    } );     
  ObjAnimate( "spr_bar_light_1", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      4.5, 0, 0.0,
      9.0, 0, 1.0
    } );    
  ObjAnimate( "spr_bar_light_5", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.1, 0, 0.0,
      3.0, 0, 0.0,
      3.1, 0, 1.0,
      3.2, 0, 0.0,
      3.5, 0, 0.5,
      3.6, 0, 1.0,
      6.0, 0, 1.0,
    } );  
  ObjAnimate( "spr_bar_light_6", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.1, 0, 0.0,
      0.2, 0, 1.0,
      0.3, 0, 0.0,
      0.4, 0, 1.0,
      6.0, 0, 1.0,
    } );
  ObjAnimate( "spr_stashwall_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 0.5,
      4.0, 0, 1.0
    } );   

end;
