-- name=mg_minelabyrinth_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_minelabyrinth_scr";

--  ObjMultiSet({ 
--
--  });

  ObjAnimate( "spr_minelabyrinth_scr_button_light",   "alp", 1, 0, "", { 0,3,0,  0.2,3,1,  0.4,3,0 } );
  ObjAnimate( "spr_minelabyrinth_scr_button_light_2", "alp", 1, 0, "", { 0,3,0,  0.2,3,1,  0.4,3,0 } );

  --------------------------------------------------------------------------------------------
  -- function win_minelabyrinth_scr () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "win_minelabyrinth_scr" ] = {
    type = "win",
    room = "rm_archives_3",
    zz = "mg_minelabyrinth_scr",
    zz_gate = "gmg_archives_3_minelabyrinth_scr"
  };

  local win_minelabyrinth_scr = function ()

    local table_multiset = {};

    if ( cmn.IsEventDone( "win_minelabyrinth_scr" ) ) then  

    else
  
      local room_name = common.GetObjectName( private.room_objname );
      private.random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;

      ObjSet( "spr_minelabyrinth_scr_hand_card_2", { alp = 0 } );
      ObjSet( "spr_minelabyrinth_scr_hand_card_3", { alp = 0 } );
      if ( private.random_index ~= 1 )  then
        ObjSet( "spr_minelabyrinth_scr_hand_card_"..private.random_index, { alp = 1 } );
      end;

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_minelabyrinth_scr" ].current_state ) then
        
        private.current_state = ng_global.progress[ ng_global.currentprogress ][ "win_minelabyrinth_scr" ].current_state;

        private.SetLocation( private.current_state );

      end;

    end;

    -----------------------------

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_minelabyrinth_scr", win_minelabyrinth_scr, private.room_objname );  
   
  --------------------------------------------------------------------------------------------

  local table_multiset = {};

  ------------------------------------------------------------------------------------

  private.current_state = 1;

  private.random_data = {
    { --схема оригинал
      win_state = 36,
      states = {
  --     directions           new state
        { dir = { 2 },        state = { 2 } },
        { dir = { 1,2,3,4 },  state = { 3,11,5,1 } },
        { dir = { 3,4 },      state = { 4,2 } },
        { dir = { 4 },        state = { 3 } },
        { dir = { 1,2,4 },    state = { 6,7,2 } },
        { dir = { 4 },        state = { 5 } },
        { dir = { 1,4 },      state = { 8,5 } },
        { dir = { 1,2,4 },    state = { 10,9,7 } },
        { dir = { 4 },        state = { 8 } },
        { dir = { 4 },        state = { 8 } },
        { dir = { 1,2,3,4 },  state = { 12,13,17,2 } },
        { dir = { 4 },        state = { 11 } },
        { dir = { 1,2,3,4 },  state = { 16,15,14,11 } },
        { dir = { 4 },        state = { 13 } },
        { dir = { 4 },        state = { 13 } },
        { dir = { 4 },        state = { 13 } },
        { dir = { 1,2,3,4 },  state = { 20,19,18,11 } },
        { dir = { 4 },        state = { 17 } },
        { dir = { 4 },        state = { 17 } },
        { dir = { 1,2,3,4 },  state = { 21,26,22,17 } },
        { dir = { 4 },        state = { 20 } },
        { dir = { 1,3,4 },    state = { 24,23,20 } },
        { dir = { 4 },        state = { 22 } },
        { dir = { 1,4 },      state = { 25,22 } },
        { dir = { 4 },        state = { 24 } },
        { dir = { 1,3,4 },    state = { 28,27,20 } },
        { dir = { 4 },        state = { 26 } },
        { dir = { 1,2,4 },    state = { 29,30,26 } },
        { dir = { 4 },        state = { 28 } },
        { dir = { 1,4 },      state = { 31,28 } },
        { dir = { 1,2,4 },    state = { 32,33,30 } },
        { dir = { 4 },        state = { 31 } },
        { dir = { 1,2,3,4 },  state = { 34,35,36,31 } },
        { dir = { 4 },        state = { 33 } },
        { dir = { 4 },        state = { 33 } },
        { dir = { 4 },        state = { 33 } } }
    },
    { --схема 2
      win_state = 36,
      states = {
  --     directions           new state
        { dir = { 2 },        state = { 2 } }, --1
        { dir = { 1,2,3,4 },  state = { 3,11,5,1 } }, --2
        { dir = { 3,4 },      state = { 4,2 } },--3
        { dir = { 4 },        state = { 3 } },--4
        { dir = { 1,2,4 },    state = { 6,7,2 } },--5
        { dir = { 4 },        state = { 5 } },--6
        { dir = { 1,4 },      state = { 8,5 } },--7
        { dir = { 1,2,4 },    state = { 10,9,7 } },--8
        { dir = { 1,2,4 },    state = { 12,13,8 } },--9
        { dir = { 1,2,3,4 },  state = { 14,16,15,8 } },--10
        { dir = { 4 },        state = { 2 } },--11
        { dir = { 4 },        state = { 9 } },--12
        { dir = { 1,4 },      state = { 17,9 } },--13
        { dir = { 4 },        state = { 10 } },--14
        { dir = { 4 },        state = { 10 } },--15
        { dir = { 1,2,3,4 },  state = { 18,19,20,10 } },--16
        { dir = { 1,2,4 },    state = { 22,21,13 } },--17
        { dir = { 4 },        state = { 16 } },--18
        { dir = { 4 },        state = { 16 } },--19
        { dir = { 1,2,3,4 },  state = { 26,27,28,16 } },--20
        { dir = { 1,2,4 },    state = { 29,30,17 } },--21
        { dir = { 1,2,3,4 },  state = { 23,24,25,17 } },--22
        { dir = { 4 },        state = { 22 } },--23
        { dir = { 4 },        state = { 22 } },--24
        { dir = { 4 },        state = { 22 } },--25
        { dir = { 4 },        state = { 20 } },--26
        { dir = { 4 },        state = { 20 } },--27
        { dir = { 4 },        state = { 20 } },--28
        { dir = { 4 },        state = { 21 } },--29
        { dir = { 1,4 },      state = { 31,21 } },--30
        { dir = { 1,2,4 },    state = { 32,33,30 } },--31
        { dir = { 4 },        state = { 31 } },--32
        { dir = { 1,2,3,4 },  state = { 35,34,36,31 } },--33
        { dir = { 4 },        state = { 33 } },--34
        { dir = { 4 },        state = { 33 } },--35
        { dir = { 4 },        state = { 33 } } }--36
    },
    {--схема 3
      win_state = 36,
      states = {
  --     directions           new state
        { dir = { 2 },        state = { 2 } },--1
        { dir = { 1,2,3,4 },  state = { 3,11,5,1 } },--2
        { dir = { 3,4 },      state = { 4,2 } },--3
        { dir = { 4 },        state = { 3 } },--4
        { dir = { 1,2,4 },    state = { 6,7,2 } },--5
        { dir = { 4 },        state = { 5 } },--6
        { dir = { 1,4 },      state = { 8,5 } },--7
        { dir = { 1,2,4 },    state = { 10,9,7 } },--8
        { dir = { 4 },        state = { 8 } },--9
        { dir = { 4 },        state = { 8 } },--10
        { dir = { 1,2,3,4 },  state = { 12,13,17,2 } },--11
        { dir = { 4 },        state = { 11 } },--12
        { dir = { 1,2,3,4 },  state = { 16,15,14,11 } },--13
        { dir = { 1,2,3,4 },  state = { 18,19,20,13 } },--14
        { dir = { 4 },        state = { 13 } },--15
        { dir = { 4 },        state = { 13 } },--16
        { dir = { 1,2,3,4 },  state = { 21,22,23,11 } },--17
        { dir = { 4 },        state = { 14 } },--18
        { dir = { 1,3,4 },    state = { 24,25,14 } },--19
        { dir = { 4 },        state = { 14 } },--20
        { dir = { 4 },        state = { 17 } },--21
        { dir = { 4 },        state = { 17 } },--22
        { dir = { 4 },        state = { 17 } },--23
        { dir = { 1,4 },      state = { 26,19 } },--24
        { dir = { 4 },        state = { 19 } },--25
        { dir = { 1,2,4 },    state = { 27,28,24 } },--26
        { dir = { 4 },        state = { 26 } },--27
        { dir = { 1,2,4 },    state = { 29,30,26 } },--28
        { dir = { 4 },        state = { 28 } },--29
        { dir = { 1,4 },      state = { 31,28 } },--30
        { dir = { 1,2,4 },    state = { 32,33,30 } },--31
        { dir = { 4 },        state = { 31 } },--32
        { dir = { 1,2,3,4 },  state = { 34,35,36,31 } },--33
        { dir = { 4 },        state = { 33 } },--34
        { dir = { 4 },        state = { 33 } },--35
        { dir = { 4 },        state = { 33 } } }--36
    },
  };

  private.zoom_pos = { { 50,-100 }, { -230,-100 }, { -560,-100 } };

  ------------------------------------------------------------------------------------

  for a = 1, 4 do
    
    table.insert( table_multiset, { "obj_minelabyrinth_scr_arrows_"..a, { 
      event_mdown  = function () private.Clk( a ) end
    } } );

  end;

  table.insert( table_multiset, { "obj_minelabyrinth_scr_hand_card", { 
    event_mdown  = function () private.ClkHand() end
  } } );

  --------------------------------------
  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function private.Generate ()
  
  local room_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index = math.random( #private.random_data );
  private.random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;

  ObjSet( "spr_minelabyrinth_scr_hand_card_2", { alp = 0 } );
  ObjSet( "spr_minelabyrinth_scr_hand_card_3", { alp = 0 } );
  if ( private.random_index ~= 1 )  then
      ObjSet( "spr_minelabyrinth_scr_hand_card_"..private.random_index, { alp = 1 } );
  end;  

end;
--*********************************************************************************************************************
function public.Open () 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if ( not cmn.IsEventDone( "win_minelabyrinth_scr" ) ) then

    cmn.MiniGameShow();    
    int_button_timer.Show();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  local room_name = common.GetObjectName( private.room_objname );

  if ( cmn.IsEventDone( "win_"..room_name ) and cmn.IsEventStart( "win_"..room_name ) ) then
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..room_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].start = 0;    

  end;

  if ( not cmn.IsEventDone( "opn_"..room_name ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    cmn.SetEventDone( "opn_"..room_name );
    
    ng_global.progress[ ng_global.currentprogress ][ "win_minelabyrinth_scr" ].current_state = private.current_state;

    private.Generate();

    public.Reset();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_minelabyrinth_scr" ) then

    cmn.MiniGameHide();    

  end;
  int_button_timer.Hide();

end;
--*********************************************************************************************************************
function public.Reset ()

  ObjSet( "obj_minelabyrinth_scr_zoom", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );

  private.current_state = 1;

  ng_global.progress[ ng_global.currentprogress ][ "win_minelabyrinth_scr" ].current_state = 1;

  private.SetLocation( private.current_state );

end;
--*********************************************************************************************************************
function public.Skip ()

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_minelabyrinth_scr" );
  cmn.CallEventHandler( "win_minelabyrinth_scr" );
  
  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function private.Win ()

  local func_end = function ()

    common_impl.Lock( false );

    private.WinEnd();

  end;

  common_impl.Lock( true );

  private.SetLocation( private.random_data[ private.random_index ].win_state );

  ObjAnimate( "obj_minelabyrinth_scr_zoom", "pos_xy", 0, 0, "", { 
    0.0,  3,  0,  0,
    0.4,  3,  0,  0,
    2.0,  3,  private.zoom_pos[ 2 ][ 1 ],  private.zoom_pos[ 2 ][ 2 ],
  } );

  ObjAnimate( "obj_minelabyrinth_scr_zoom", "scale_xy", 0, 0, func_end, { 
    0.0,  3,  1.0,  1.0,
    0.4,  3,  1.0,  1.0,
    2.0,  3,  1.5,  1.5
  } );

  AnimPlay( "anm_minelabyrinth_scr_hands_move", "DoAnim", "" );

end;
--*********************************************************************************************************************
-- function *** MG ***() end
--*********************************************************************************************************************
  function private.Clk ( direction )

    local states = private.random_data[ private.random_index ].states[ private.current_state ].state;
    local dirs   = private.random_data[ private.random_index ].states[ private.current_state ].dir;

    local new_state = 0;
    local new_dir = 0;

    for i = 1, #dirs do
    
      if ( dirs[ i ] == direction ) then

        new_state = states[ i ];
        new_dir   = dirs[ i ];

        break;

      end;

    end;

    if ( new_state ~= 0 ) then

      local func_end = function ()

        common_impl.Lock( false );

        private.SetLocation( new_state );

        ObjSet( "obj_minelabyrinth_scr_zoom", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
        ObjSet( "obj_minelabyrinth_scr_arrows", { alp = 1 } );

        private.ClkEnd( new_state );

      end;

      common_impl.Lock( true );

      if ( new_dir ~= 4 ) then

        ObjAnimate( "obj_minelabyrinth_scr_zoom", "pos_xy", 0, 0, "", { 
          0.0,  3,  0,  0,
          0.6,  3,  private.zoom_pos[ new_dir ][ 1 ],  private.zoom_pos[ new_dir ][ 2 ],
        } );
    
        ObjAnimate( "obj_minelabyrinth_scr_zoom", "scale_xy", 0, 0, "", { 
          0.0,  3,  1.0,  1.0,
          0.6,  3,  1.5,  1.5,
        } );
    
      end;

      private.SetLocation2( new_state );

      ObjSet( "obj_minelabyrinth_scr_arrows", { alp = 0 } );

      ObjAnimate( "obj_minelabyrinth_scr_zoom", "alp", 0, 0, "", { 
        0.0,  3,  1,
        0.4,  3,  1,
        0.6,  3,  0
      } );
    
      ObjAnimate( "spr_minelabyrinth_scr_back_2", "alp", 0, 0, "", { 
        0.0,  3,  0,
        0.2,  3,  0,
        0.6,  3,  1
      } );

      AnimPlay( "anm_minelabyrinth_scr_hands_move", "DoAnim", func_end );

    end;

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_minelabyrinth_scr"_wheel_click", 0, "", 0 );

  end;
--*********************************************************************************************************************
  function private.ClkEnd ( new_state )

    --local func_end = function ()

      private.current_state = new_state;

      if ( private.current_state == private.random_data[ private.random_index ].win_state ) then

        private.Win();

      else

        ng_global.progress[ ng_global.currentprogress ][ "win_minelabyrinth_scr" ].current_state = new_state;

      end;

    --end;

    ObjSet( "obj_minelabyrinth_scr_zoom",   { alp = 1 } );
    ObjSet( "spr_minelabyrinth_scr_back_2", { alp = 0 } );
    --ObjAnimate( "obj_minelabyrinth_scr_zoom", "alp", 0, 0, func_end, { 
    --  0.0,  3,  0,
    --  0.1,  3,  1
    --} );

  end;
--*********************************************************************************************************************
  function private.ClkHand ()

    local func_end = function ()

      common_impl.Lock( false );

      ObjSet( "obj_minelabyrinth_scr_hand_card",    { input = false } );
      ObjSet( "obj_minelabyrinth_scr_arrows",       { input = true } );

    end;

    common_impl.Lock( true );

    ObjAnimate( "obj_minelabyrinth_scr_hand_card", "alp", 0, 0, "", { 
      0.0,  3,  1,
      0.6,  3,  0,
    } );


    ObjAnimate( "obj_minelabyrinth_scr_hands", "alp", 0, 0, "", { 
      0.0,  3,  0,
      0.6,  3,  1,
    } );

    ObjAnimate( "obj_minelabyrinth_scr_arrows", "alp", 0, 0, func_end, { 
      0.0,  3,  0,
      0.6,  3,  1,
    } );
    
  end;
--*********************************************************************************************************************
  function private.SetLocation ( current_state )

    local new_directions = private.random_data[ private.random_index ].states[ current_state ].dir;

    ObjSet( "spr_minelabyrinth_scr_left",         { alp = 0 } );
    ObjSet( "spr_minelabyrinth_scr_block",        { alp = 1 } );
    ObjSet( "spr_minelabyrinth_scr_right",        { alp = 0 } );
    ObjSet( "spr_minelabyrinth_scr_exit",         { alp = 0 } );
    ObjSet( "spr_minelabyrinth_scr_game_up_side", { alp = 0 } );
    ObjSet( "obj_minelabyrinth_scr_hand_card",    { alp = 0, input = false } );
    ObjSet( "obj_minelabyrinth_scr_hands",        { alp = 1 } );
    ObjSet( "obj_minelabyrinth_scr_arrows",       { alp = 1, input = true } );

    for i = 1, #new_directions do

      if ( new_directions[ i ] == 1 ) then

        ObjSet( "spr_minelabyrinth_scr_left", { alp = 1 } );

      end;

      if ( new_directions[ i ] == 2 ) then

        ObjSet( "spr_minelabyrinth_scr_block", { alp = 0 } );

      end;

      if ( new_directions[ i ] == 3 ) then

        ObjSet( "spr_minelabyrinth_scr_right", { alp = 1 } );

      end;

    end;

    if ( current_state == 1 ) then

      ObjSet( "spr_minelabyrinth_scr_game_up_side", { alp = 1 } );
      ObjSet( "obj_minelabyrinth_scr_hand_card",    { alp = 1, input = true } );
      ObjSet( "obj_minelabyrinth_scr_hands",        { alp = 0 } );
      ObjSet( "obj_minelabyrinth_scr_arrows",       { alp = 0, input = false } );      

    end;

    if ( current_state == private.random_data[ private.random_index ].win_state ) then

      ObjSet( "spr_minelabyrinth_scr_exit",   { alp = 1 } );
      ObjSet( "spr_minelabyrinth_scr_block",  { alp = 0 } );
      ObjSet( "obj_minelabyrinth_scr_arrows", { alp = 0, input = false } );

    end;

    private.SetArrow( current_state );

  end;
--*********************************************************************************************************************
  function private.SetLocation2 ( current_state )

    local new_directions = private.random_data[ private.random_index ].states[ current_state ].dir;

    ObjSet( "spr_minelabyrinth_scr_left_2",         { alp = 0 } );
    ObjSet( "spr_minelabyrinth_scr_block_2",        { alp = 1 } );
    ObjSet( "spr_minelabyrinth_scr_right_2",        { alp = 0 } );
    ObjSet( "spr_minelabyrinth_scr_exit_2",         { alp = 0 } );

    for i = 1, #new_directions do

      if ( new_directions[ i ] == 1 ) then

        ObjSet( "spr_minelabyrinth_scr_left_2", { alp = 1 } );

      end;

      if ( new_directions[ i ] == 2 ) then

        ObjSet( "spr_minelabyrinth_scr_block_2", { alp = 0 } );

      end;

      if ( new_directions[ i ] == 3 ) then

        ObjSet( "spr_minelabyrinth_scr_right_2", { alp = 1 } );

      end;

    end;

    if ( current_state == private.random_data[ private.random_index ].win_state ) then

      ObjSet( "spr_minelabyrinth_scr_exit_2",  { alp = 1 } );
      ObjSet( "spr_minelabyrinth_scr_block_2", { alp = 0 } );

    end;

  end;
--*********************************************************************************************************************
  function private.SetArrow ( current_state )

    local dirs = private.random_data[ private.random_index ].states[ current_state ].dir;

    for a = 1, 4 do
    
      ObjSet( "obj_minelabyrinth_scr_arrows_"..a, { alp = 0, input = 0, active = 0 } );

    end;

    for d = 1, #dirs do
    
      local number = dirs[ d ];

      ObjSet( "obj_minelabyrinth_scr_arrows_"..number, { alp = 1, input = 1, active = 1 } );

    end;

  end;
--*********************************************************************************************************************