-- name=mg_panel_scr
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_panel_scr";

  private.random_data = {
  { --схема 1
    rounds = { 1, 2, 1, 3, 2, 1, 3, 2 },    
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_2", scale_x = 1, scale_y = -1, pos_x = 534, pos_y = 172, finish_pos_x = -7 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_2", pos_x = 1, pos_y = 59 },
      cross = {
        { pos_x = -364, pos_y = -71, inputrect_w = 14, inputrect_h = 111 },
        { pos_x = -181, pos_y = -71, inputrect_w = 14, inputrect_h = 111 },
        { pos_x = 10, pos_y = -22, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 190, pos_y = -22, inputrect_w = 14, inputrect_h = 59 } } },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_1", scale_x = 1, scale_y = -1, pos_x = 538, pos_y = 504, finish_pos_x = -7 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_1", pos_x = 2, pos_y = -22 },
      cross = {
        { pos_x = -364, pos_y = -41, inputrect_w = 14, inputrect_h = 111 },
        { pos_x = -179, pos_y = -37, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -76, pos_y = -37, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 112, pos_y = -41, inputrect_w = 14, inputrect_h = 111 } } },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_3", scale_x = 1, scale_y = -1, pos_x = 498, pos_y = 344, finish_pos_x = 958 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_3", pos_x = 1, pos_y = 1 },
      cross = {
        { pos_x = -130, pos_y = 2, inputrect_w = 14, inputrect_h = 89 },
        { pos_x = -24, pos_y = -93, inputrect_w = 14, inputrect_h = 89 },
        { pos_x = 15, pos_y = 2, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 59, pos_y = -54, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 163, pos_y = -92, inputrect_w = 14, inputrect_h = 90 },
        { pos_x = 241, pos_y = 4, inputrect_w = 14, inputrect_h = 90 },
        { pos_x = 342, pos_y = 1, inputrect_w = 14, inputrect_h = 59 } } } },
  { --схема 2
    rounds = { 1, 3, 1, 2, 1, 1, 2, 2 },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_2", scale_x = -1, scale_y = -1, pos_x = 534, pos_y = 172, finish_pos_x = 1019 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_2", pos_x = 1, pos_y = 59 },
      cross = {
        { pos_x = 190, pos_y = -22, inputrect_w = 14, inputrect_h = 59 }, 
        { pos_x = 10, pos_y = -22, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -181, pos_y = -71, inputrect_w = 14, inputrect_h = 111 },
        { pos_x = -364, pos_y = -71, inputrect_w = 14, inputrect_h = 111 } } },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_1", scale_x = -1, scale_y = -1, pos_x = 570, pos_y = 504, finish_pos_x = 945 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_1", pos_x = 2, pos_y = -22 },
      cross = {
        { pos_x = 112, pos_y = -41, inputrect_w = 14, inputrect_h = 111 }, 
        { pos_x = -76, pos_y = -37, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -179, pos_y = -37, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -364, pos_y = -41, inputrect_w = 14, inputrect_h = 111 } } },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_3", scale_x = -1, scale_y = -1, pos_x = 519, pos_y = 344, finish_pos_x = 66 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_3", pos_x = 1, pos_y = 1 },
      cross = {
        { pos_x = 342, pos_y = 1, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 241, pos_y = 4, inputrect_w = 14, inputrect_h = 90 },
        { pos_x = 163, pos_y = -92, inputrect_w = 14, inputrect_h = 90 },
        { pos_x = 59, pos_y = -54, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 15, pos_y = 2, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -24, pos_y = -93, inputrect_w = 14, inputrect_h = 89 },
        { pos_x = -130, pos_y = 2, inputrect_w = 14, inputrect_h = 89 } } } } ,
  { --схема 3
    rounds = { 1, 3, 3, 2, 2, 3, 1, 2 },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_1", scale_x = -1, scale_y = 1, pos_x = 565, pos_y = 172, finish_pos_x = 942 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_1", pos_x = 2, pos_y = -21 },
      cross = {
        { pos_x = 112, pos_y = -41, inputrect_w = 14, inputrect_h = 111 },
        { pos_x = -77, pos_y = -36, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -180, pos_y = -34, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -365, pos_y = -39, inputrect_w = 14, inputrect_h = 111 } } },
    { 
      spr = { res = "assets/levels/level1/mg_panel/layers/key_2", scale_x = -1, scale_y = 1, pos_x = 538, pos_y = 504, finish_pos_x = 1016 },
      light = { res = "assets/levels/level1/mg_panel/anims/light_key_2", pos_x = 1, pos_y = 59 },
      cross = {
        { pos_x = 189, pos_y = -24, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 9, pos_y = -24, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -181, pos_y = -72, inputrect_w = 14, inputrect_h = 111 },
        { pos_x = -365, pos_y = -72, inputrect_w = 14, inputrect_h = 111 } } },
    { 
      spr = { res = "assets/levels/levelscr/mg_panel_scr/key_new", scale_x = 1, scale_y = 1, pos_x = 520, pos_y = 344, finish_pos_x = 156 },
      light = { res = "assets/levels/levelscr/mg_panel_scr/key_new_light", pos_x = 14, pos_y = -1 },
      cross = {
        { pos_x = -355, pos_y = -62, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = -254, pos_y = -96, inputrect_w = 14, inputrect_h = 89 },
        { pos_x = -176, pos_y = -1, inputrect_w = 14, inputrect_h = 93 },
        { pos_x = -71, pos_y = 3, inputrect_w = 14, inputrect_h = 50 },
        { pos_x = -28, pos_y = -63, inputrect_w = 14, inputrect_h = 59 },
        { pos_x = 12, pos_y = 5, inputrect_w = 14, inputrect_h = 90 } } } },
  } ;

  private.move_step = 3.5;
  private.count_rounds = 8;
  private.count_rounds_in_row = 3;
  private.count_keys = 3;

  for i = 1, private.count_rounds do

    for j = 1, private.count_rounds_in_row do

      ObjSet( "obj_panel_scr_col_clk_"..i.."_"..j, 
        { 
          event_mdown  = function () private.ClkCol( i, j ) end,
          event_menter = function () private.Col_Event_Menter( i, j ) end,
          event_mleave = function () private.Col_Event_Mleave( i, j ) end 
        } );
      ObjSet( "spr_panel_scr_col_clk_"..i.."_"..j, { alp = 0 } );

    end;

  end;

  for i = 1, private.count_rounds do

    ObjSet( "spr_panel_scr_key_"..i, 
      { 
        event_mdown  = function () private.ClkKey( i ) end,
        event_menter = function () private.Key_Event_Menter( i ) end,
        event_mleave = function () private.Key_Event_Mleave( i ) end 
      } );

  end;

  private.InitAnimations();

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_uppershelf = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 

    {
      private.room_objname,
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_uppershelf", update_game_mode_uppershelf, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_panel_scr () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_panel_scr" ] = {
    type = "win",
    room = private.room_objname,
    zz = "gmg_bar_panel_scr"
  };
  local win_panel_scr = function ()

    if ( cmn.IsEventDone( "win_panel_scr" ) ) then  

      --ObjSet( "spr_panel_scr_safetylock", { input = true } );
      --ObjSet( "obj_panel_scr_win", { pos_y = 0 } );

    else 

      for i = 1, private.count_keys do

        ObjSet( "spr_panel_scr_key_"..i, 
          {
            pos_x = ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ i ][ 1 ], 
            pos_y = ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ i ][ 2 ], 
          } );

        if ( ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state[ i ] ) then

          ObjSet( "spr_panel_scr_key_"..i, 
            {
              alp = 0 
            } );

        end;

      end;  

      for i = 1, private.count_rounds do

        for j = 1, private.count_rounds_in_row do

          if ( ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ][ j ] ) then

            ObjSet( "obj_panel_scr_col_clk_"..i.."_"..j, { input = false } );
            ObjSet( "obj_panel_scr_col_"..i, { pos_y = ObjGet( "obj_panel_scr_col_clk_"..i.."_"..j ).pos_y } )
      
          else

            ObjSet( "obj_panel_scr_col_clk_"..i.."_"..j, { input = true } );      

          end;

        end;

      end;

    end;

  end;
  cmn.AddSubscriber( "win_panel_scr", win_panel_scr, private.room_objname );

end;
--*********************************************************************************************************************
function private.Generate ()
  
  local room_name = common.GetObjectName( private.room_objname );
  ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index = math.random( #private.random_data )

end;
--*********************************************************************************************************************
function public.Open () 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if ( not cmn.IsEventDone( "win_panel_scr" ) ) then

    cmn.MiniGameShow( "panel_scr" );    
    int_button_timer.Show();

  end;


end;
--*********************************************************************************************************************
function public.PreOpen ()

  local room_name = common.GetObjectName( private.room_objname );

  if ( cmn.IsEventDone( "win_"..room_name ) and cmn.IsEventStart( "win_"..room_name ) ) then
    
    ng_global.progress[ ng_global.currentprogress ][ "opn_"..room_name ].done = 0;
    
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].done = 0;
    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].start = 0;    

  end;

  if ( not cmn.IsEventDone( "opn_"..room_name ) ) then

     cmn.SetEventDone( "opn_"..room_name );

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].timer = { default = 40, time = 40, diff = 20, extra = 0 };

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state = { false, false, false };

    ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index = 0;

    private.Generate();

    private.ResetInit();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Close ()



end;
--*********************************************************************************************************************
function public.PreClose ()

  if ( cmn.IsEventStart( "win_panel_scr" ) and not cmn.IsEventDone( "win_panel_scr" ) ) then

    cmn.MiniGameHide();    

  end;
  int_button_timer.Hide();

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS WUN *** () end;
--*********************************************************************************************************************
function private.ResetInit ()

  local room_name = common.GetObjectName( private.room_objname );
  local random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;
  local data = private.random_data[ random_index ];
  
  local table_multiset = {};
  ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord = {};
  for i = 1, #data do

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ i ] = { data[ i ].spr.pos_x, data[ i ].spr.pos_y };
    table.insert( table_multiset, { "spr_panel_scr_key_"..i, data[ i ].spr } );
    table.insert( table_multiset, { "spr_panel_scr_light_key_"..i, data[ i ].light } );
    for j = 1, #data[ i ].cross do 
      table.insert( table_multiset, { "obj_panel_scr_key_"..i.."_cross_"..j, data[ i ].cross[ j ] } );
    end;

  end;

  ObjMultiSet( table_multiset );

  private.count_cross = { 4, 4, 7 } ;
  if ( random_index == 3 ) then
    private.count_cross = { 4, 4, 6 } ;
  end;
  
  ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round = {};
  for i = 1, #data.rounds do
    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ] = { false, false, false };
    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ][ data.rounds[ i ] ] = true;
  end;

  for i = 1, private.count_rounds do

    for j = 1, private.count_rounds_in_row do

      if ( ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ][ j ] ) then

        ObjSet( "obj_panel_scr_col_clk_"..i.."_"..j, { input = false } );
        ObjSet( "obj_panel_scr_col_"..i, { pos_y = ObjGet( "obj_panel_scr_col_clk_"..i.."_"..j ).pos_y } )
  
      else

        ObjSet( "obj_panel_scr_col_clk_"..i.."_"..j, { input = true } );      

      end;

    end;

  end; 

  for i = 1, #data do

    ObjSet( "spr_panel_scr_key_"..i, { input = true, alp = 1, pos_x = data[ i ].spr.pos_x } );

  end; 
  ObjSet( "obj_panel_scr_mg", { alp = 1 } );

end;
--*********************************************************************************************************************
function public.Reset ()

  cmn.Lock( true );
  local pos_x_keys = {};

  local room_name = common.GetObjectName( private.room_objname );
  local random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;      
  local data = private.random_data[ random_index ];
  for i = 1, #data do
    pos_x_keys[ i ] = data[ i ].spr.pos_x;
  end;

    local round = {};
    for i = 1, #data.rounds do

      ObjAnimate( "obj_panel_scr_col_"..i, "pos_y", 0, 0, "",
        { 
          0.0, 0, ObjGet( "obj_panel_scr_col_"..i ).pos_y,
          0.3, 0, ObjGet( "obj_panel_scr_col_clk_"..i.."_"..data.rounds[ i ] ).pos_y
        } );

    end;

  for i = 1, private.count_keys do

    ObjAnimate( "spr_panel_scr_key_"..i, "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_scr_key_"..i ).alp,
        0.3, 0, 1
      } ); 
    ObjAnimate( "spr_panel_scr_key_"..i, "pos_x", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_scr_key_"..i ).pos_x,
        0.3, 0, pos_x_keys[ i ]
      } ); 

  end;

  local fun_end = function ()

    for i = 1, private.count_keys do

      ObjSet( "spr_panel_scr_key_"..i, { input = true } );

    end;

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord = {};
    local data = private.random_data[ random_index ];
    for i = 1, #data do
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ i ] = { data[ i ].spr.pos_x, data[ i ].spr.pos_y };
    end;

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state = { false, false, false }; 

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round = {};
    for i = 1, #data.rounds do

      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ] = { false, false, false };
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ][ data.rounds[ i ] ] = true;
      ObjSet( "obj_panel_scr_col_clk_"..i.."_1", { input = true } );
      ObjSet( "obj_panel_scr_col_clk_"..i.."_2", { input = true } );
      ObjSet( "obj_panel_scr_col_clk_"..i.."_3", { input = true } );
      ObjSet( "obj_panel_scr_col_clk_"..i.."_"..data.rounds[ i ], { input = false } );

    end;

    cmn.Lock( false );

  end;

  ObjAnimate( "obj_panel_scr_mg", "alp", 0, 0, fun_end,
    { 
      0.0, 0, ObjGet( "obj_panel_scr_mg" ).alp,
      0.3, 0, ObjGet( "obj_panel_scr_mg" ).alp
    } );

end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Skip ()

  cmn.Lock( true );
  local room_name = common.GetObjectName( private.room_objname );
  local random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;      
  local data = private.random_data[ random_index ];

  local pos_x_keys = {};
  for i = 1, #data do 
    pos_x_keys[ i ] = data[ i ].spr.finish_pos_x;
  end;
  
  for i = 1, private.count_keys do

    ObjAnimate( "spr_panel_scr_key_"..i, "alp", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_scr_key_"..i ).alp,
        0.6, 0, 0
      } ); 
    ObjAnimate( "spr_panel_scr_key_"..i, "pos_x", 0, 0, "",
      { 
        0.0, 0, ObjGet( "spr_panel_scr_key_"..i ).pos_x,
        0.6, 0, pos_x_keys[ i ]
      } ); 

  end;

  local func_end = function ()

    private.Win();

  end;

  ObjAnimate( "obj_panel_scr_mg", "alp", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "obj_panel_scr_mg" ).alp,
      0.6, 0, ObjGet( "obj_panel_scr_mg" ).alp
    } );

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_panel_scr" );
  cmn.CallEventHandler( "win_panel_scr" );

  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function private.Win ()

  --local func_end = function ()

    cmn.Lock( false );

    for i = 1, 3 do

      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ i ][ 1 ] = ObjGet( "spr_panel_scr_key_"..i ).pos_x;
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ i ][ 2 ] = ObjGet( "spr_panel_scr_key_"..i ).pos_y;
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state[ i ] = true;

    end;

    private.WinEnd();

  --end;

  --cmn.Lock( true );

end;
--*********************************************************************************************************************
function private.Col_Event_Menter ( i, j )

  common_impl.SetCursor( CURSOR_HAND );
  ObjAnimate( "spr_panel_scr_col_clk_"..i.."_"..j, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_scr_col_clk_"..i.."_"..j ).alp,
      0.2, 0, 1
    } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Col_Event_Mleave ( i, j )

  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( "spr_panel_scr_col_clk_"..i.."_"..j, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_scr_col_clk_"..i.."_"..j ).alp,
      0.2, 0, 0
    } );

end;
--*********************************************************************************************************************
function private.ClkCol ( i, j )

  local func_end = function ()

    cmn.Lock( false );

    for k = 1, private.count_rounds_in_row do

      ObjSet( "obj_panel_scr_col_clk_"..i.."_"..k, { input = true } );

    end;

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ] = { false, false, false };  
    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].round[ i ][ j ] = true;
    ObjSet( "obj_panel_scr_col_clk_"..i.."_"..j, { input = false } );

  end;

  cmn.Lock( true );

  ObjAnimate( "obj_panel_scr_col_"..i, "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, ObjGet( "obj_panel_scr_col_"..i ).pos_x, ObjGet( "obj_panel_scr_col_"..i ).pos_y,
      0.3, 0, ObjGet( "obj_panel_scr_col_clk_"..i.."_"..j ).pos_x, ObjGet( "obj_panel_scr_col_clk_"..i.."_"..j ).pos_y,
    } );  

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_panel_scr_clk1", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Key_Event_Menter ( id )

  common_impl.SetCursor( CURSOR_HAND );
  ObjAnimate( "spr_panel_scr_light_key_"..id, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_scr_light_key_"..id ).alp,
      0.2, 0, 1
    } );

  common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Key_Event_Mleave ( id )

  common_impl.SetCursor( CURSOR_DEFAULT );
  ObjAnimate( "spr_panel_scr_light_key_"..id, "alp", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_scr_light_key_"..id ).alp,
      0.2, 0, 0
    } );

end;
--*********************************************************************************************************************
function private.ClkKey ( id )

  local func_end = function () 

    private.CheckKey( id );

  end;

  cmn.Lock( true );
  ObjSet( "tmr_panel_scr_move_key" , 
    { 
      playing = true, 
      time = 0.000001,  
      endtrig = func_end         
    } );

  if ( not private.flag_sound_clk ) then

    if ( private.CheckKeyCross( id ) ) then

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    else

     common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_panel_scr_clk2", 0, "", 0 );

    end

    private.flag_sound_clk = true;

  end;

end;
--*********************************************************************************************************************
function private.CheckKey ( id )

  local room_name = common.GetObjectName( private.room_objname );
  local random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;      
  local data = private.random_data[ random_index ];
  local pos_x = data[ id ].spr.finish_pos_x;

  local flag = false;
  if ( data[ id ].spr.finish_pos_x - data[ id ].spr.pos_x < 0 ) then
    flag = true;
  end;

  if ( private.CheckKeyCross( id ) ) then

    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ id ][ 1 ] = ObjGet( "spr_panel_scr_key_"..id ).pos_x;
    ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ id ][ 2 ] = ObjGet( "spr_panel_scr_key_"..id ).pos_y;

    ObjSet( "tmr_panel_scr_move_key" , { playing = false } ); 
    cmn.Lock( false ); 

    private.flag_sound_clk = false;

  elseif ( flag ) then

    if ( ObjGet( "spr_panel_scr_key_"..id ).pos_x <= pos_x ) then

      private.WinKeyAnim( id ); 
      cmn.Lock( false ); 

      private.flag_sound_clk = false;

    else   
      
      local curr_pos = ObjGet( "spr_panel_scr_key_"..id ).pos_x;
      ObjSet( "spr_panel_scr_key_"..id, {  pos_x = curr_pos - private.move_step } );
      private.ClkKey( id );

    end;

  else

    if ( ObjGet( "spr_panel_scr_key_"..id ).pos_x >= pos_x ) then

      private.WinKeyAnim( id ); 
      cmn.Lock( false ); 

      private.flag_sound_clk = false;

    else  

      local curr_pos = ObjGet( "spr_panel_scr_key_"..id ).pos_x;
      ObjSet( "spr_panel_scr_key_"..id, {  pos_x = curr_pos + private.move_step } );
      private.ClkKey( id );

    end;

  end;  

end;
--*********************************************************************************************************************
function private.CheckKeyCross ( id )

  local bool = false;

  for i = 1, private.count_cross[ id ] do

    local name_key = "obj_panel_scr_key_"..id.."_cross_"..i;

    for j = 1, private.count_rounds do

      if ( cmn.ApplyObj( name_key, "obj_panel_scr_cross_"..j ) ) then

        bool = true;
        break;            

      end;

    end;

  end;

  return bool;  

end;
--*********************************************************************************************************************
function private.WinKeyAnim ( id )
  
  local room_name = common.GetObjectName( private.room_objname );
  local random_index = ng_global.progress[ ng_global.currentprogress ][ "win_"..room_name ].random_index;      
  local data = private.random_data[ random_index ];

  local end_pos_x = data[ id ].spr.finish_pos_x;

  local fun_end = function ()

    if ( private.HowManyKeys() == 2 ) then 
  
      private.Win();      

    else
      
      ObjSet( "spr_panel_scr_key_"..id, { input = false, alp = 0 } );
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state[ id ] = true;
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ id ][ 1 ] = ObjGet( "spr_panel_scr_key_"..id ).pos_x;
      ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state_coord[ id ][ 2 ] = ObjGet( "spr_panel_scr_key_"..id ).pos_y;

    end;  

  end;

  cmn.Lock( true );
  ObjAnimate( "spr_panel_scr_key_"..id, "pos_x", 0, 0, "",
    { 
      0.0, 0, ObjGet( "spr_panel_scr_key_"..id ).pos_x,
      0.5, 0, end_pos_x
    } );  
  ObjAnimate( "spr_panel_scr_key_"..id, "alp", 0, 0, fun_end,
    { 
      0.0, 0, 1,
      0.5, 0, 0
    } );  

end;
--*********************************************************************************************************************
function private.HowManyKeys ()

  local count = 0;
  for i = 1, private.count_keys do

    if ( ng_global.progress[ ng_global.currentprogress ][ "win_panel_scr" ].state[ i ] ) then

      count = count + 1;

    end;

  end;

  return count;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** ANIMATION *** () end;
--*********************************************************************************************************************
function private.InitAnimations ()

  ObjAnimate( "spr_panel_scr_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0,
    3.0, 0, 0.3,
    6.0, 0, 1.0
  } );  

end;




 