-- name=mg_distillatingstill
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_distillatingstill";

  ObjMultiSet({ 
    { "spr_distillatingstill_seal1", { event_mdown = private.get_seal1 }},
    { "spr_distillatingstill_dnainfinityamulet1", { event_mdown = private.get_dnainfinityamulet1 }},
  });

  --------------------------------------------------------------------------------------------
  -- function get_seal1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_seal1" ] = {
    type = "get",
    get_obj = "spr_distillatingstill_seal1",
    room = private.room_objname
  };
  
  local get_seal1_inv = function ()
  
    interface.InventoryItemAdd( "inv_seal1", "spr_distillatingstill_seal1" );
  
  end;
  
  local get_seal1_closezz = function ()
  
    ObjDelete( "gfx_distillatingstill_seal1" );
  
  end;
  
  local get_seal1_loc = function ()
  
    if ( cmn.IsEventDone( "get_dnainfinityamulet1" ) ) then

      ObjDelete( "gmg_lab_distillatingstill" );
  
    end;

  end;
  
  cmn.AddSubscriber( "get_seal1", get_seal1_inv );
  cmn.AddSubscriber( "get_seal1", get_seal1_closezz, private.room_objname );
  cmn.AddSubscriber( "get_seal1", get_seal1_loc, "rm_lab" );
  --------------------------------------------------------------------------------------------
  -- function get_dnainfinityamulet1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_dnainfinityamulet1" ] = {
    type = "get",
    get_obj = "spr_distillatingstill_dnainfinityamulet1",
    room = private.room_objname
  };
  
  local get_dnainfinityamulet1_inv = function ()
  
    interface.InventoryItemAdd( "inv_dnainfinityamulet1", "spr_distillatingstill_dnainfinityamulet1" );
  
  end;
  
  local get_dnainfinityamulet1_closezz = function ()
  
    ObjDelete( "gfx_distillatingstill_dnainfinityamulet1" );

    ObjSet( "spr_distillatingstill_eternity_1",         { alp = 0 } );
    ObjSet( "spr_distillatingstill_dnainfinityamulet1", { alp = 1 } );

  end;
  
  local get_dnainfinityamulet1_loc = function ()
  
    if ( cmn.IsEventDone( "get_seal1" ) ) then

      ObjDelete( "gmg_lab_distillatingstill" );
  
    end;

  end;
  
  cmn.AddSubscriber( "get_dnainfinityamulet1", get_dnainfinityamulet1_inv );
  cmn.AddSubscriber( "get_dnainfinityamulet1", get_dnainfinityamulet1_closezz, private.room_objname );
  cmn.AddSubscriber( "get_dnainfinityamulet1", get_dnainfinityamulet1_loc, "rm_lab" );
--------------------------------------------------------------------------------------------
  -- function win_distillatingstill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_distillatingstill" ] = {
    type = "win",
    room = "rm_lab",
    zz = "mg_distillatingstill",
    zz_gate = "gmg_lab_distillatingstill"
  };

  local win_distillatingstill = function ()

    local table_multiset = {};

    if ( cmn.IsEventDone( "win_distillatingstill" ) ) then  

      ObjSet( "spr_distillatingstill_seal1", { input = true, active = true } );
      ObjSet( "spr_distillatingstill_dnainfinityamulet1", { input = true, active = true } );
      
      ObjSet( "gfx_distillatingstill_dnainfinityamulet1", { active = true } );

      ObjSet( "spr_distillatingstill_press_plate", { pos_y = 390 } );
      
    else

    end;

    -----------------------------------------    

    private.win           = ng_global.progress[ "std" ][ "win_distillatingstill" ].win;
    private.current_state = ng_global.progress[ "std" ][ "win_distillatingstill" ].current_state;
    private.current_dir   = ng_global.progress[ "std" ][ "win_distillatingstill" ].current_dir;

    table.insert( table_multiset, { "spr_distillatingstill_eternity_1", { 
      pos_x = private.pos[ private.current_state ].x, 
      pos_y = private.pos[ private.current_state ].y,
      ang   = private.angles[ private.current_dir ]
    } } );

    -----------------------------

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_distillatingstill", win_distillatingstill, private.room_objname );
  
  --------------------------------------------------------------------------------------------

  local table_multiset = {};

  ------------------------------------------------------------------------------------

  private.current_state = 37;
  private.current_dir   = 5;

  private.angles = { -0.37, -0.37, -1.18, -1.18, -1.95, -1.95, -2.79, -2.79 };  

  private.states = {};  
  --                      directions         new state
  private.states[ 1 ]  = { dir = { 1 },     state = { 2 } };
  private.states[ 2 ]  = { dir = { 2,3 },   state = { 1,3 } };
  private.states[ 3 ]  = { dir = { 4,1 },   state = { 2,4 } };
  private.states[ 4 ]  = { dir = { 2,5 },   state = { 3,5 } };
  private.states[ 5 ]  = { dir = { 6,2,8 }, state = { 4,6,17 } };
  private.states[ 6 ]  = { dir = { 1,6 },   state = { 5,7 } };
  private.states[ 7 ]  = { dir = { 5,7 },   state = { 6,8 } };
  private.states[ 8 ]  = { dir = { 8,3 },   state = { 7,9 } };
  private.states[ 9 ]  = { dir = { 4,2,1 }, state = { 8,10,11 } };
  private.states[ 10 ] = { dir = { 1 },     state = { 9 } };
  private.states[ 11 ] = { dir = { 2,8 },   state = { 9,12 } };
  private.states[ 12 ] = { dir = { 7,2 },   state = { 11,13 } };
  private.states[ 13 ] = { dir = { 1,8 },   state = { 12,14 } };
  private.states[ 14 ] = { dir = { 7,1 },   state = { 13,15 } };
  private.states[ 15 ] = { dir = { 2,6 },   state = { 14,16 } };
  private.states[ 16 ] = { dir = { 5 },     state = { 15 } };
  private.states[ 17 ] = { dir = { 7,3,8 }, state = { 5,18,19 } };
  private.states[ 18 ] = { dir = { 4 },     state = { 17 } };
  private.states[ 19 ] = { dir = { 7,6,8 }, state = { 17,20,23 } };
  private.states[ 20 ] = { dir = { 5,7 },   state = { 19,21 } };
  private.states[ 21 ] = { dir = { 8,4 },   state = { 20,22 } };
  private.states[ 22 ] = { dir = { 3 },     state = { 21 } };
  private.states[ 23 ] = { dir = { 7,8,1 }, state = { 19,24,26 } };
  private.states[ 24 ] = { dir = { 7,2 },   state = { 23,25 } };
  private.states[ 25 ] = { dir = { 1 },     state = { 24 } };
  private.states[ 26 ] = { dir = { 2,7 },   state = { 23,27 } };
  private.states[ 27 ] = { dir = { 8,2,3 }, state = { 26,28,29 } };
  private.states[ 28 ] = { dir = { 1 },     state = { 27 } };
  private.states[ 29 ] = { dir = { 4,8 },   state = { 27,30 } };
  private.states[ 30 ] = { dir = { 7,8,5 }, state = { 29,31,32 } };
  private.states[ 31 ] = { dir = { 7 },     state = { 30 } };
  private.states[ 32 ] = { dir = { 6,2,1 }, state = { 30,33,36 } };
  private.states[ 33 ] = { dir = { 1,2,5 }, state = { 32,34,35 } };
  private.states[ 34 ] = { dir = { 1 },     state = { 33 } };
  private.states[ 35 ] = { dir = { 6 },     state = { 33 } };
  private.states[ 36 ] = { dir = { 2,6 },   state = { 32,37 } };
  private.states[ 37 ] = { dir = { 5 },     state = { 36 } };

  private.pos = {};  
  private.pos[ 1 ]  = { x = 189,   y = 150 };
  private.pos[ 2 ]  = { x = 265,   y = 161 };
  private.pos[ 3 ]  = { x = 314,   y = 227 };
  private.pos[ 4 ]  = { x = 381,   y = 266 };
  private.pos[ 5 ]  = { x = 326,   y = 371 };
  private.pos[ 6 ]  = { x = 229,   y = 343 };
  private.pos[ 7 ]  = { x = 243,   y = 268 };
  private.pos[ 8 ]  = { x = 141,   y = 310 };
  private.pos[ 9 ]  = { x = 223,   y = 539 };
  private.pos[ 10 ] = { x = 128,   y = 498 };
  private.pos[ 11 ] = { x = 313,   y = 578 };
  private.pos[ 12 ] = { x = 412,   y = 532 };
  private.pos[ 13 ] = { x = 297,   y = 473 };
  private.pos[ 14 ] = { x = 384,   y = 432 };
  private.pos[ 15 ] = { x = 506,   y = 476 };
  private.pos[ 16 ] = { x = 564,   y = 353 };
  private.pos[ 17 ] = { x = 444,   y = 327 };
  private.pos[ 18 ] = { x = 473,   y = 393 };
  private.pos[ 19 ] = { x = 538,   y = 283 };
  private.pos[ 20 ] = { x = 565,   y = 176 };
  private.pos[ 21 ] = { x = 454,   y = 211 };
  private.pos[ 22 ] = { x = 422,   y = 144 };
  private.pos[ 23 ] = { x = 678,   y = 230 };
  private.pos[ 24 ] = { x = 762,   y = 188 };
  private.pos[ 25 ] = { x = 681,   y = 142 };
  private.pos[ 26 ] = { x = 752,   y = 273 };
  private.pos[ 27 ] = { x = 668,   y = 318 };
  private.pos[ 28 ] = { x = 637,   y = 322 };
  private.pos[ 29 ] = { x = 702,   y = 390 };
  private.pos[ 30 ] = { x = 833,   y = 345 };
  private.pos[ 31 ] = { x = 886,   y = 317 };
  private.pos[ 32 ] = { x = 769,   y = 515 };
  private.pos[ 33 ] = { x = 658,   y = 472 };
  private.pos[ 34 ] = { x = 614,   y = 450 };
  private.pos[ 35 ] = { x = 626,   y = 558 };
  private.pos[ 36 ] = { x = 852,   y = 549 };
  private.pos[ 37 ] = { x = 907,   y = 422 };

  table.insert( table_multiset, { "spr_distillatingstill_eternity_1", { 
    pos_x = private.pos[ private.current_state ].x, 
    pos_y = private.pos[ private.current_state ].y,
    ang   = private.angles [ private.current_dir ]
  } } );

  ------------------------------------------------------------------------------------

  for m = 1, 8 do
    
    table.insert( table_multiset, { "spr_distillatingstill_magnet_light_"..m, { 
      event_mdown  = function () private.Clk( m ) end,
      event_menter = function () private.MEnter( m ) end,
      event_mleave = function () private.MLeave( m ) end,
    } } );

  end;

  --------------------------------------
  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open () 

  if not cmn.IsEventDone( "win_distillatingstill" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  if ( not cmn.IsEventStart( "win_distillatingstill" ) ) then

    ng_global.progress[ "std" ][ "win_distillatingstill" ].win           = private.win;
    ng_global.progress[ "std" ][ "win_distillatingstill" ].current_state = private.current_state;
    ng_global.progress[ "std" ][ "win_distillatingstill" ].current_dir   = private.current_dir;

  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  if not cmn.IsEventDone( "win_distillatingstill" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_seal1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_seal1" );
  cmn.CallEventHandler( "get_seal1" );

  if ( cmn.IsEventDone( "get_dnainfinityamulet1" ) ) then

    cmn.GotoRoom( "rm_lab" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_dnainfinityamulet1 ()

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_dnainfinityamulet1" );
  cmn.CallEventHandler( "get_dnainfinityamulet1" );

  if ( cmn.IsEventDone( "get_seal1" ) ) then

    cmn.GotoRoom( "rm_lab" );

  end;

end;
--*********************************************************************************************************************
function public.Reset ()

  private.current_state = 37;
  private.current_dir   = 5;

  ng_global.progress[ "std" ][ "win_distillatingstill" ].current_state = 37;
  ng_global.progress[ "std" ][ "win_distillatingstill" ].current_dir   = 5;

  
  ObjSet( "spr_distillatingstill_eternity_1", { 
    pos_x = private.pos[ private.current_state ].x, 
    pos_y = private.pos[ private.current_state ].y,
    ang   = private.angles [ private.current_dir ]
  } );

end;
--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  local func_end = function ()

    local current_state = 1;
    local current_dir   = 2;

    ObjSet ( "spr_distillatingstill_eternity_1", { 
      pos_x = private.pos[ current_state ].x, 
      pos_y = private.pos[ current_state ].y,
      ang   = private.angles [ current_dir ]
    } );

    ObjAnimate( "spr_distillatingstill_eternity_1", "alp", 0, 0, private.Win, { 0,3,0,  0.4,3,1 } );

  end

  common_impl.Lock( true );

  ObjAnimate( "spr_distillatingstill_eternity_1", "alp", 0, 0, func_end, { 0,3,1,  0.4,3,0 } );

end;
--*********************************************************************************************************************
function private.WinEnd ()

  common_impl.Lock( false );

  private.current_state = 1;
  private.current_dir   = 2;

  ng_global.progress[ "std" ][ "win_distillatingstill" ].current_state = 1;
  ng_global.progress[ "std" ][ "win_distillatingstill" ].current_dir   = 2;

  ObjSet( "spr_distillatingstill_eternity_1", { 
    pos_x = private.pos[ private.current_state ].x, 
    pos_y = private.pos[ private.current_state ].y,
    ang   = private.angles [ private.current_dir ]
  } );

  cmn.MiniGameHide();

  cmn.SetEventDone( "get_dnainfinityamulet1" );
  cmn.SetEventDone( "win_distillatingstill" );
  cmn.CallEventHandler( "win_distillatingstill" );

  common_impl.PassingMgWin();

end;
--*********************************************************************************************************************
function private.Win ()

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "aud_get_inv_sfx", 0, "", 0 );

  cmn.CallEventHandler( "get_dnainfinityamulet1" );

  ObjAnimate( "spr_distillatingstill_press_plate", "pos_y", 0, 0, private.WinEnd, { 0,3,900,  0.6,3,390 } );

end;
--*********************************************************************************************************************
-- function *** MG ***() end
--*********************************************************************************************************************
  function private.MEnter ( name )

    common_impl.SetCursor( CURSOR_HAND );

  end;
--*********************************************************************************************************************
  function private.MLeave ( name )

    common_impl.SetCursor( CURSOR_DEFAULT );

  end;
--*********************************************************************************************************************
  function private.Clk ( direction )

    local states = private.states[ private.current_state ].state;
    local dirs   = private.states[ private.current_state ].dir;

    local new_state = 0;
    local new_dir = 0;

    for i = 1, #dirs do
    
      if ( dirs[ i ] == direction ) then

        new_state = states[ i ];
        new_dir   = dirs[ i ];

        break;

      end;

    end;

    local old_ang = private.angles[ private.current_dir ];
    local old_pos = private.pos[ private.current_state ];

    if ( new_state ~= 0 ) then

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_clk_magnet", 0, "", 0 );

      local new_ang = private.angles[ new_dir ];
      local new_pos = private.pos[ new_state ];

      local func_end = function ()

        common_impl.Lock( false );
        private.ClkEnd( new_state, new_dir );

      end;

      common_impl.Lock( true );

      ObjAnimate( "spr_distillatingstill_eternity_1", "ang", 0, 0, "", { 
        0.0,  3,  old_ang,
        0.1,  3,  new_ang,
        0.2,  3,  new_ang + 0.2,
        0.3,  3,  new_ang - 0.2,
        0.4,  3,  new_ang + 0.2,
        0.5,  3,  new_ang - 0.2,
        0.6,  3,  new_ang 
      } );
  
      ObjAnimate( "spr_distillatingstill_eternity_1", "pos_xy", 0, 0, func_end, { 
        0.0,  3,  old_pos.x,  old_pos.y,
        0.6,  3,  new_pos.x,  new_pos.y
      } );
  
    else

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      local func_end = function ()

        common_impl.Lock( false );

      end;

      common_impl.Lock( true );

      ObjAnimate( "spr_distillatingstill_eternity_1", "ang", 0, 0, func_end, { 
        0.0,  3,  old_ang,
        0.1,  3,  old_ang + 0.2,
        0.3,  3,  old_ang - 0.2,
        0.4,  3,  old_ang 
      } );
  
    end;

  end;
--*********************************************************************************************************************
  function private.ClkEnd ( new_state, new_dir )

    private.current_state = new_state;
    private.current_dir   = new_dir;

    if ( private.current_state == 1 ) then

      private.Win();

    else

      ng_global.progress[ "std" ][ "win_distillatingstill" ].current_state = new_state;
      ng_global.progress[ "std" ][ "win_distillatingstill" ].current_dir   = new_dir;

    end;

  end;
--*********************************************************************************************************************