-- name=mg_superpuzzle2
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_superpuzzle2";

  ObjSet( "obj_superpuzzle2_hint", { 
    event_mdown  = private.PuszzleHintClk, 
    event_menter = private.PuszzleHintEnter, 
    event_mleave = private.PuszzleHintLeave
  } );

  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_superpuzzle2" ] = {
    type = "win",
    room = "rm_archives",
    zz = "mg_superpuzzle2",
    zz_gate = "gmg_archives_superpuzzle2"
  };

  local win_superpuzzle2_loc = function ()

    if ( cmn.IsEventDone( "win_superpuzzle2" ) ) then  

      ObjDelete( "gmg_archives_superpuzzle2" );

    else

    end;

  end;

  local win_superpuzzle2 = function ()

    local table_multiset = {};

    if ( cmn.IsEventDone( "win_superpuzzle2" ) ) then  

    else

      -----------------------------------------    

      private.numbers.index = ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.index;
      private.numbers.win   = ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.win;
      private.numbers.done_number  = ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.done_number;

      for i = 1, #private.numbers.current_list do
      
        for j = 1, #private.numbers.current_list[ i ] do
        
          private.numbers.current_list[ i ][ j ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list[ i ][ j ];

        end;

      end;

      -----------------------------------------    

      private.pictures.win = ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.win;

      for i = 1, #private.pictures.current_list do
      
        private.pictures.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.current_list[ i ];
      
      end;

      -----------------------------------------    

      private.maze.win = ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.win;

      for i = 1, #private.maze.current_list do
      
        private.maze.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.current_list[ i ];
      
      end;

      -----------------------------------------    

      private.bottles.win = ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.win;

      for i = 1, #private.bottles.current_list do
      
        private.bottles.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.current_list[ i ];
      
      end;

      -----------------------------------------    

      private.hexs.win = ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.win;

      for i = 1, #private.hexs.current_list do
      
        private.hexs.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.current_list[ i ];

      end;

      -----------------------------------------    

      private.match3.win    = ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.win;
      private.match3.points = ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.points;

      -----------------------------------------    

      private.levers.win = ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.win;

      for i = 1, #private.levers.current_list do
      
        private.levers.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.current_list[ i ];
      
      end;

      -----------------------------------------    

      private.squares.win = ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.win;

      for i = 1, #private.squares.current_list do
      
        private.squares.current_list[ i ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.current_list[ i ];
      
      end;

      --- Mini Progress Begin--------------------------

      if ( private.numbers.win ) then

      else

        if ( private.numbers.done_number <= 3 ) then

          for i = 1, #private.numbers.current_list[ 1 ] do

            if ( private.numbers.current_list[ private.numbers.done_number ][ i ] ~= 0 ) then

              local number_red = private.numbers.current_list[ private.numbers.done_number ][ i ];

              table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..number_red, { input = false, alp = 0 } } );
              table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..number_red.."_down", { alp = 1 } } );

            end;

          end;

        end;

      end;    

      -----------------------------------------    

      if ( private.pictures.win ) then

        private.PicturesWinSet();
        
      else

        for i = 1, #private.pictures.current_list do
              
          local number = private.pictures.current_list[ i ];
          local pos    = private.pictures_pos[ i ];

          table.insert( table_multiset, { "spr_superpuzzle2_mg_1_picture_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

        end;

      end;

      -----------------------------------------    

      if ( private.maze.win ) then

        private.MazeWinSet();
        
      else

        table.insert( table_multiset, { "spr_superpuzzle2_mg_2_syringe", { 
          pos_x = private.maze_beg_pos_x + ( private.maze.current_list[ 1 ] - 1 ) * private.maze_step, 
          pos_y = private.maze_beg_pos_y + ( private.maze.current_list[ 2 ] - 1 ) * private.maze_step 
        } } );

      end;

      -----------------------------------------    

      if ( private.bottles.win ) then

        private.BottlesWinSet();
        
      else

        for i = 1, #private.bottles.current_list do

          local volume = private.bottles.current_list[ i ];

          private.BottlesLevelSet( i, volume );

        end;

      end;

      -----------------------------

      if ( private.hexs.win ) then

        private.HexsWinSet();
        
      end;

      for i = 1, #private.hexs.current_list do
          
        if ( private.hexs.current_list[ i ] == 1 ) then

          table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hex_"..i, { input = false } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i, { alp = 0 } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_1", { alp = 1 } } );

          ObjAttach( "spr_superpuzzle2_mg_6_light", "obj_superpuzzle2_mg_6_hex_"..i );

        elseif ( private.hexs.current_list[ i ] == 2 ) then

          table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hex_"..i, { input = false } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i, { alp = 0 } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_1", { alp = 0 } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_over", { alp = 1 } } );

        else

          table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hex_"..i, { input = true } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i, { alp = 1 } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_1", { alp = 0 } } );
          table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_over", { alp = 0 } } );

        end;

      end;

    end;

    -----------------------------

    if ( private.match3.win ) then

      private.Match3WinSet();

    else

      private.Match3Load();

    end;

    -----------------------------------------    

    if ( private.levers.win ) then

      private.LeversWinSet();
      
    else

      for i = 1, #private.levers.current_list do
            
        local pos_y = private.levers.current_list[ i ];

        table.insert( table_multiset, { "spr_superpuzzle2_mg_5_lever_"..i, { pos_y = pos_y } } );

        private.LeversHolePos( i, pos_y );

      end;

    end;

    -----------------------------------------    

    if ( private.squares.win ) then

      private.SquaresWinSet();
      
    else

      for i = 1, #private.squares.current_list do
            
        local ang = private.squares_ang[ private.squares.current_list[ i ] ];

        table.insert( table_multiset, { "spr_superpuzzle2_mg_7_picture_"..i, { ang = ang } } );

      end;

    end;

    -----------------------------

    private.NumbersDoneCheck();
      
    --- Mini Progress End --------------------------

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_superpuzzle2", win_superpuzzle2, private.room_objname );
  cmn.AddSubscriber( "win_superpuzzle2", win_superpuzzle2_loc, "rm_archives" );

  --------------------------------------------------------------------------------------------

  local table_multiset = {};

  --------------------------------------

  private.numbers = {}
  private.numbers.current_list = { 
    { 0, 0, 0, 0 },         
    { 0, 0, 0, 0 },     
    { 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0 },
    { 0, 0, 0, 0, 0, 0 }
  };

  private.numbers.done_number = 1;
  private.numbers.index = 1;

  private.numbers_win_list = { 
    { 4, 1, 3, 2 },         
    { 1, 3, 4, 2 },     
    { 1, 2, 3, 4 },
    { 2, 4, 3, 1, 5 },
    { 4, 2, 1, 3, 6, 5 }
  };
  
  --------------------------------------

  private.pictures = {}
  private.pictures.current_list = { 4, 1, 6, 5, 2, 3 };
  private.pictures.prev_number = 0;

  private.pictures_win_list = { 1, 2, 3, 4, 5, 6 };
  
  private.pictures_pos = { { 234, 226 }, { 213, 133 }, { 104, 254 }, { 92, 139 }, { 243, 333 }, { 118, 314 } };

  for i = 1, #private.pictures.current_list do
        
    local number = private.pictures.current_list[ i ];
    local pos    = private.pictures_pos[ i ];

    table.insert( table_multiset, { "spr_superpuzzle2_mg_1_picture_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

  end;

  --------------------------------------

  private.maze = {}

  private.maze.current_list = { 1,1 };

  private.maze_dir = {
    { { 4 },     { 1,4 },   { 1,3 },   { 1,3 },     { 3,4 } },
    { { 1,2 },   { 2,3 },   { 1 },     { 1,3 },     { 2,3,4 } },
    { { 1,4 },   { 1,3 },   { 1,3 },   { 3,4 },     { 2,4 } },
    { { 1,2 },   { 1,3 },   { 3,4 },   { 1,2,4 },   { 2,3,4 } },
    { { 1 },     { 1,3 },   { 2,3,4 }, { 1,2 },     { 2,3 } }
  };  

  private.maze_beg_pos_x = 757;
  private.maze_beg_pos_y = 122;
  private.maze_step      = 54;

  private.maze_win_list  = { 3,6 };

  table.insert( table_multiset, { "spr_superpuzzle2_mg_2_syringe", { 
    pos_x = private.maze_beg_pos_x + ( private.maze.current_list[ 1 ] - 1 ) * private.maze_step, 
    pos_y = private.maze_beg_pos_y + ( private.maze.current_list[ 2 ] - 1 ) * private.maze_step 
  } } );

  --------------------------------------

  private.bottles = {}

  private.bottles.current_list = { 20, 0, 0, 0, 0 };
  private.bottles_size = { 20, 0, 3, 0, 5 };
  private.bottles_win_volume = 4;

  private.bottles_beg_pos = { { 267, 535 }, {}, { 487, 568 }, {}, { 381, 548 } };
  private.bottles_up_pos  = { { 323, 370 }, {}, { 539, 413 }, {}, { 433, 387 } };
  private.bottles_up_ang  = 2.37;

  --------------------------------------

  private.hexs = {};
  private.hexs.current_list = { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

  private.hexs_list   = { 1,  2, 3, 4, 5,  6, 7,  8, 9, 10, 11, 4, 12 };
  private.hexs_list_2 = { 5, 10, 7, 4, 2, 11, 8, 12, 9,  6,  3, 1,  9 };

  local active_hex = private.HexsFindActive();

  ObjAttach( "spr_superpuzzle2_mg_6_light", "obj_superpuzzle2_mg_6_hex_"..active_hex );

  --------------------------------------

  private.Match3Init();

  --------------------------------------

  private.levers = {}
  private.levers.current_list = { 165, 165, 165 };

  private.levers_first = true;

  private.levers_win_list = { 94, 165, 236 };
  
  private.levers_pos_up   = 94;
  private.levers_pos_down = 236;

  for i = 1, #private.levers.current_list do
        
    local pos_y = private.levers.current_list[ i ];

    table.insert( table_multiset, { "spr_superpuzzle2_mg_5_lever_"..i, { pos_y = pos_y } } );

    private.LeversHolePos( i, pos_y );

  end;

  --------------------------------------

  private.squares = {}
  private.squares.current_list = { 4, 2, 1, 4, 1, 1, 2, 2, 3 };

  private.squares_win_list = { 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  
  private.squares_ang = { 0, 1.57, 3.14, 4.71, 6.28 };

  for i = 1, #private.squares.current_list do
        
    local ang = private.squares_ang[ private.squares.current_list[ i ] ];

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_picture_"..i, { ang = ang } } );

  end;

  --------------------------------------

  for i = 1, 6 do
        
    table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i, { event_mdown = function () private.NumbersClk( i ); end } } );

  end;

  --------------------------------------

  for i = 1, 6 do
        
    table.insert( table_multiset, { "spr_superpuzzle2_mg_1_picture_"..i, { event_mdown = function () private.PicturesClk( i ); end } } );

  end;

  --------------------------------------

  for i = 1, 4 do
        
    table.insert( table_multiset, { "spr_superpuzzle2_mg_2_arrows_"..i, { 
      event_mdown  = function () private.MazeClk( i ) end,
      event_menter = function () private.MazeEnter( i ) end,
      event_mleave = function () private.MazeLeave( i ) end 
    } } );

  end;

  --------------------------------------

  local bottle_numbers = { 1, 3, 5 };

  for i = 1, #bottle_numbers do
        
    table.insert( table_multiset, { "obj_superpuzzle2_mg_3_bottle_"..bottle_numbers[ i ], { 
      event_dragdrop  = function () private.BottlesDrop( bottle_numbers[ i ] ) end,
      event_startdrag = function () private.BottlesStartDrag( bottle_numbers[ i ] ) end
    } } );

  end;

  --------------------------------------

  for s = 1, 13 do
    
    table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hex_"..s, { event_mdown = function () private.HexsClk( s ) end } } );

  end;
 
  --------------------------------------

  for i = 1, 3 do
        
    table.insert( table_multiset, { "obj_superpuzzle2_mg_5_lever_"..i.."_drag", { 
      event_drag     = function () private.LeversDrag( i ); end, 
      event_dragdrop = function () private.LeversDragDrop( i ); end 
    } } );
  
  end;

  --------------------------------------

  for s = 1, 9 do
        
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_picture_"..s, { event_mdown = function () private.SquaresClk( s ); end } } );

  end;

  --------------------------------------

  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open () 

  if not cmn.IsEventDone( "win_superpuzzle2" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()
  
  ObjSet("obj_int_button_info",{ pos_y = 0 });
  ObjSet("obj_int_button_reset",{ pos_y = 0 });
  
  if ( not cmn.IsEventStart( "win_superpuzzle2" ) ) then

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].state = {};

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.done_number  = private.numbers.done_number;
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.index = private.numbers.index;
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.win   = private.numbers.win;

    for i = 1, #private.numbers.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list[ i ] = {};

      for j = 1, #private.numbers.current_list[ i ] do
      
        ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list[ i ][ j ] = private.numbers.current_list[ i ][ j ];

      end;

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.win   = private.pictures.win;

    for i = 1, #private.pictures.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.current_list[ i ] = private.pictures.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.win   = private.maze.win;

    for i = 1, #private.maze.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.current_list[ i ] = private.maze.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.win   = private.bottles.win;

    for i = 1, #private.bottles.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.current_list[ i ] = private.bottles.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.win = private.hexs.win;

    for i = 1, #private.hexs.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.current_list[ i ] = private.hexs.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field  = { {}, {}, {}, {}, {}, {} };
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3 = {}
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.win    = private.match3.win;
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.points = private.match3.points;
    
    for i = 1, private.match3_cell_y do
 
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ] = { 0, 0, 0, 0, 0 };

    end;

    private.Match3GenerateField( true );

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.win   = private.levers.win;

    for i = 1, #private.levers.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.current_list[ i ] = private.levers.current_list[ i ];

    end;

    -----------------------------------------    

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.current_list = {};
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.win   = private.squares.win;

    for i = 1, #private.squares.current_list do
    
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.current_list[ i ] = private.squares.current_list[ i ];

    end;

    -----------------------------------------    

  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  ObjSet("obj_int_button_info",{ pos_y = -105 });
  ObjSet("obj_int_button_reset",{ pos_y = -105 });
  
  
  if not cmn.IsEventDone( "win_superpuzzle2" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset ()

  private.NumbersResetSet();
  private.PicturesResetSet();
  private.MazeResetSet();
  private.BottlesResetSet();
  private.HexsResetSet();
  private.Match3ResetSet();
  private.LeversResetSet();
  private.SquaresResetSet();

end;
--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  private.numbers.win   = true;
  private.pictures.win  = true;
  private.maze.win      = true;
  private.bottles.win   = true;
  private.hexs.win      = true;
  private.levers.win    = true;
  private.squares.win   = true;
  private.match3.win    = true;

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_superpuzzle2" );
  cmn.CallEventHandler( "win_superpuzzle2" );
  common_impl.PassingMgWin();

  if ( not ng_global.progress[ ng_global.currentprogress ][ "win_superpuzzle2" ].skip_clk ) then

    common_impl.CheckGiveCustomAchiev( "superpuzzle_no_skip" );

  end;

  cmn.GotoRoom( "rm_archives" );

end;
--*********************************************************************************************************************
function private.Win ()
  
  ObjSet("obj_int_button_info",{ pos_y = -105 });
  ObjSet("obj_int_button_reset",{ pos_y = -105 });
  
  private.WinEnd();

end;
--*********************************************************************************************************************
--  function *** Mmg Numbers ***() end
--*********************************************************************************************************************
  function private.NumbersClk ( number )

    common_impl.Lock( true );

    if ( ( number == 5 ) and ( ( not private.pictures.win ) or ( not private.maze.win )   or ( not private.bottles.win ) ) ) or
         ( number == 6 ) and ( ( not private.levers.win )   or ( not private.match3.win ) or ( not private.hexs.win ) ) then

      local func_end = function ()

        common_impl.Lock( false );

      end;
  
      ObjAnimate( "spr_superpuzzle2_mg_8_red_"..number, "alp", 0, 0, func_end, 
      { 
        0,   3,  1,  
        0.3, 3,  0, 
        0.6, 3,  1
      } );

      ObjAnimate( "spr_superpuzzle2_mg_8_red_"..number.."_down", "alp", 0, 0, "", 
      { 
        0,   3,  0,  
        0.3, 3,  1,
        0.6, 3,  0,  
      } );

      return;

    end;

    ObjSet( "spr_superpuzzle2_mg_8_red_"..number, { input = false } );

    local func_end = function ()

      common_impl.Lock( false );

      private.NumbersClkEnd( number );

    end;
  
    ObjAnimate( "spr_superpuzzle2_mg_8_red_"..number, "alp", 0, 0, func_end, 
    { 
      0,   3,  1,  
      0.3, 3,  0 
    } );

    ObjAnimate( "spr_superpuzzle2_mg_8_red_"..number.."_down", "alp", 0, 0, "", 
    { 
      0,   3,  0,  
      0.3, 3,  1 
    } );

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_numbers", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.NumbersClkEnd ( number )

    local comb = private.numbers.done_number;

    private.numbers.current_list[ comb ][ private.numbers.index ] = number;
    
    local flag_win = true;
    local flag_reset = false;

    for i = 1, private.numbers.index do
      
      if ( private.numbers.current_list[ comb ][ i ] ~= private.numbers_win_list[ comb ][ i ] ) then

        flag_reset = true;
        break;

      end;

    end;

    for i = 1, #private.numbers_win_list[ comb ] do
      
      if ( private.numbers.current_list[ comb ][ i ] ~= private.numbers_win_list[ comb ][ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.NumbersWinAnim();

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk1", 0, "", 0 );

    elseif ( flag_reset ) then

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk2", 0, "", 0 );
      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );
      private.NumbersResetAnim();

    else

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk1", 0, "", 0 );

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list[ comb ][ private.numbers.index ] = number;

      private.numbers.index = private.numbers.index + 1;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.index = private.numbers.index;

    end;

  end;
  --*********************************************************************************************************************
  function private.NumbersWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.numbers.done_number = private.numbers.done_number + 1;
      private.numbers.index = 1;

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.index       = private.numbers.index
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.done_number = private.numbers.done_number;

      private.NumbersDoneCheck();

    end;

    if ( private.numbers.done_number == 1 ) then

      ObjAnimate( "spr_superpuzzle2_door_2", "pos_x", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.7, 3, -360,  
      } );   

    elseif ( private.numbers.done_number == 2 ) then

      ObjAnimate( "spr_superpuzzle2_door_1", "pos_x", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.7, 3, 370,  
      } );   

    elseif ( private.numbers.done_number == 3 ) then

      ObjAnimate( "spr_superpuzzle2_door_3", "pos_y", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.7, 3, 200,  
      } );   

    elseif ( private.numbers.done_number == 4 ) then

      ObjAnimate( "spr_superpuzzle2_door_2", "pos_x", 0, 0, "", 
      { 
        0,   3, 0,  
        0.7, 3, -360,  
      } );   

      ObjAnimate( "spr_superpuzzle2_door_1", "pos_x", 0, 0, "", 
      { 
        0,   3, 0,  
        0.7, 3, 370,  
      } );   

      ObjAnimate( "spr_superpuzzle2_door_3", "pos_y", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.7, 3, 200,  
      } );   

    elseif ( private.numbers.done_number == 5 ) then

      ObjAnimate( "spr_superpuzzle2_mg_7_door_1", "pos_x", 0, 0, "", 
      { 
        0,   3, -70,  
        0.7, 3, -220,  
      } );   

      ObjAnimate( "spr_superpuzzle2_mg_7_door_2", "pos_x", 0, 0, func_end, 
      { 
        0,   3, 74,  
        0.7, 3, 240,  
      } );   

    end;

    if ( private.numbers.done_number < 3 ) then

      for i = 1, #private.numbers.current_list[ 1 ] do

        ObjSet( "spr_superpuzzle2_mg_8_red_"..i, { input = true } );

        ObjAnimate( "spr_superpuzzle2_mg_8_red_"..i, "alp", 0, 0, "", 
        { 
          0,   3, 0,  
          0.4, 3, 1 
        } );    

        ObjAnimate( "spr_superpuzzle2_mg_8_red_"..i.."_down", "alp", 0, 0, "", 
        { 
          0,   3, 1,  
          0.4, 3, 0 
        } );    

      end;

    end;

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.NumbersDoneCheck ()

    local table_multiset = {};

    if ( private.numbers.done_number >= 2 ) and ( not private.pictures.win ) then

      table.insert( table_multiset, { "spr_superpuzzle2_door_2",        { pos_x = -360 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_1_pictures", { input = true } } );

    end;

    if ( private.numbers.done_number >= 3 ) and ( not private.maze.win ) then

      table.insert( table_multiset, { "spr_superpuzzle2_door_1",      { pos_x = 370 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_2_arrows", { input = true } } );

    end;

    if ( private.numbers.done_number >= 4 ) and ( not private.bottles.win ) then

      table.insert( table_multiset, { "spr_superpuzzle2_door_3",       { pos_y = 200 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_3_bottles", { input = true } } );

      for i = 1, #private.numbers.current_list[ 1 ] do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = false, alp = 0 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 1 } } );   

      end;

    end;

    -------------------------------

    if ( private.numbers.done_number >= 5 ) and ( not private.hexs.win ) and ( not private.levers.win )and ( not private.match3.win ) then

      for i = 1, 5 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = false, alp = 0 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 1 } } );   

      end;

    end;

    -------------------------------

    if ( private.numbers.done_number >= 5 ) and ( not private.hexs.win ) then

      table.insert( table_multiset, { "spr_superpuzzle2_door_3",       { pos_y = 200 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hexs",    { input = true } } );

    end;

    if ( private.numbers.done_number >= 5 ) and ( not private.levers.win ) then

      table.insert( table_multiset, { "spr_superpuzzle2_door_1",       { pos_x = 370 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_5_levers",  { input = true } } );

    end;

    if ( private.numbers.done_number >= 5 ) and ( not private.match3.win ) then

      table.insert( table_multiset, { "spr_superpuzzle2_door_2",       { pos_x = -360 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_4_crop",    { input = true } } );

    end;

    -------------------------------

    if ( private.numbers.done_number >= 6 ) --[[and ( not private.hexs.win )]] then

      table.insert( table_multiset, { "spr_superpuzzle2_mg_7_door_1",    { pos_x = -220 } } );
      table.insert( table_multiset, { "spr_superpuzzle2_mg_7_door_2",    { pos_x = 240 } } );
      table.insert( table_multiset, { "obj_superpuzzle2_mg_7_squares",   { input = true } } );

      for i = 1, 6 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = false, alp = 0 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 1 } } );   

      end;

    end;

    if ( #table_multiset ~= 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;
  --*********************************************************************************************************************
  function private.NumbersResetAnim ()

    common_impl.Lock( true );
    
    local func_end = function ()

      common_impl.Lock( false );

      private.numbers.index = 1;

      private.numbers.current_list[ private.numbers.done_number ] = { 0, 0, 0, 0 };

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.index = 1;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list[ private.numbers.done_number ] = { 0, 0, 0, 0 };

    end;

    for i = 1, private.numbers.index do

      if ( i ~= 1 ) then

        func_end = "";

      end;

      local number_red = private.numbers.current_list[ private.numbers.done_number ][ i ];

      ObjSet( "spr_superpuzzle2_mg_8_red_"..number_red, { input = true } );

      ObjAnimate( "spr_superpuzzle2_mg_8_red_"..number_red, "alp", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.4, 3, 1 
      } );    

      ObjAnimate( "spr_superpuzzle2_mg_8_red_"..number_red.."_down", "alp", 0, 0, "", 
      { 
        0,   3, 1,  
        0.4, 3, 0 
      } );    

    end;

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_numbers_wrong", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.NumbersResetSet ()

    private.numbers.index = 1;
    private.numbers.done_number = 1;

    private.numbers.current_list = { 
      { 0, 0, 0, 0 },         
      { 0, 0, 0, 0 },     
      { 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0, 0 }
    };

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.index = 1;
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.done_number = 1;
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].numbers.current_list = { 
      { 0, 0, 0, 0 },         
      { 0, 0, 0, 0 },     
      { 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0 },
      { 0, 0, 0, 0, 0, 0 }
    };

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_1",       { pos_x = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_door_2",       { pos_x = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_door_3",       { pos_y = 0 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_door_1",  { pos_x = -70 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_door_2",  { pos_x = 74 } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_4_crop",    { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hexs",    { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_5_levers",  { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_7_squares", { input = false } } );

    for i = 1, #private.numbers_win_list[ 5 ] do 
      
      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i, { input = true, alp = 1 } } );
      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Pictures ***() end
--*********************************************************************************************************************
  function private.PicturesClk ( number )

    local cur_name = "spr_superpuzzle2_mg_1_picture_"..number;

    if ( private.pictures.prev_number == 0 ) then

      ObjSet( cur_name.."_light", { alp = 1 } );

      private.pictures.prev_number = number;

    elseif ( private.pictures.prev_number == number ) then

      ObjSet( cur_name.."_light", { alp = 0 } );

      private.pictures.prev_number = 0;

    else

      common_impl.Lock( true );

      local prev_name = "spr_superpuzzle2_mg_1_picture_"..private.pictures.prev_number;

      local func_end = function ()

        common_impl.Lock( false );

        private.PicturesClkEnd( number, private.pictures.prev_number );

        private.pictures.prev_number = 0;

      end;
  
      local index = private.PicturesGetPosToArray( number );

      local old_params = ObjGet( prev_name );
      local new_params = ObjGet( cur_name );
      
      ObjSet( prev_name.."_light", { alp = 0 } );

      ObjAnimate( prev_name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3,  old_params.pos_x,  old_params.pos_y,  
        0.4, 3,  new_params.pos_x,  new_params.pos_y
      } );

      ObjAnimate( cur_name, "pos_xy", 0, 0, "", 
      { 
        0,   3,  new_params.pos_x,  new_params.pos_y,  
        0.4, 3,  old_params.pos_x,  old_params.pos_y
      } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    end;  

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_menter1", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PicturesGetPosToArray ( number )

    for i = 1, #private.pictures.current_list do
    
      if ( private.pictures.current_list[ i ] == number ) then

        return i;

      end;
  
    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesAllLightOff ()

    for i = 1, #private.pictures.current_list do
    
      ObjSet( "spr_superpuzzle2_mg_1_picture_"..i.."_light", { alp = 0 } );
  
    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesClkEnd ( number, prev_number )

    local index      = private.PicturesGetPosToArray( number );
    local prev_index = private.PicturesGetPosToArray( prev_number );

    private.pictures.current_list[ index ], private.pictures.current_list[ prev_index ] = 
    private.pictures.current_list[ prev_index ], private.pictures.current_list[ index ];
    
    local flag_win = true;

    for i = 1, #private.pictures_win_list do
      
      if ( private.pictures.current_list[ i ] ~= private.pictures_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.PicturesWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.current_list[ index ] = private.pictures.current_list[ index ];
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.current_list[ prev_index ] = private.pictures.current_list[ prev_index ];

    end;

  end;
  --*********************************************************************************************************************
  function private.PicturesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.pictures.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.win = true;

      private.PicturesWinSet();

    end;

    local func_audio1 = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_beep", 0, "", 0 );

    end;

    local func_audio2 = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

    end;

    ObjAnimate( "spr_superpuzzle2_door_2", "pos_x", 0, 0, func_audio1, 
    { 
      0,   3, -360,  
      0.7, 3, -360,  
      1.5, 3, 0,  
    } );   

    ObjAnimate( "spr_superpuzzle2_door_2", "alp", 0, 0, func_audio2, 
    { 
      0,   3, 1,  
      0.7, 3, 1 
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_blue_1", "alp", 0, 0, "", 
    { 
      0,   3, 0,  
      1.5, 3, 0,  
      2.0, 3, 1,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_red_1", "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      1.5, 3, 1,  
      2.0, 3, 0,  
    } );   

  end;
  --*********************************************************************************************************************
  function private.PicturesWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_2",        { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_1_pictures", { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_1",          { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_4",          { alp = 1 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_1",    { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_1",   { alp = 1 } } );

    if ( private.pictures.win ) and ( private.maze.win ) and ( private.bottles.win ) then

      for i = 1, 5 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = true, alp = 1 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );   

      end;

      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_5_light", { alp = 1 } } );   

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.PicturesResetSet ()

    local table_multiset = {};

    private.PicturesAllLightOff();

    private.pictures.win = false;

    private.pictures.current_list = { 4, 1, 6, 5, 2, 3 }
    private.pictures.prev_number = 0;

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.current_list = { 4, 1, 6, 5, 2, 3 }
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].pictures.win = false;

    for i = 1, #private.pictures.current_list do
          
      local number = private.pictures.current_list[ i ];
      local pos_x  = private.pictures_pos[ i ][ 1 ];
      local pos_y  = private.pictures_pos[ i ][ 2 ];
      table.insert( table_multiset, { "spr_superpuzzle2_mg_1_picture_"..number, { pos_x = pos_x, pos_y = pos_y } } );

    end;

    table.insert( table_multiset, { "spr_superpuzzle2_door_2", { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_1_pictures", { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_1",          { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_4",          { alp = 0 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_1",    { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_1",   { alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Maze ***() end
--*********************************************************************************************************************
  function private.MazeEnter ( number )

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle2_mg_2_arrows_"..number.."_1", { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.MazeLeave ( number )

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle2_mg_2_arrows_"..number.."_1", { alp = 0 } );

  end;
--*********************************************************************************************************************
  function private.MazeClk ( direction )

    local cur_states = private.maze.current_list;
    local dirs       = private.maze_dir[ cur_states[ 2 ] ][ cur_states[ 1 ] ];

    local new_state = {};
    new_state[ 1 ] = cur_states[ 1 ];
    new_state[ 2 ] = cur_states[ 2 ];

    local new_dir = 0;

    for i = 1, #dirs do
    
      if ( dirs[ i ] == direction ) then

        new_dir   = dirs[ i ];
        break;

      end;

    end;

    local obj_name = "spr_superpuzzle2_mg_2_syringe";

    if ( new_dir ~= 0 ) then

      if     ( new_dir == 1 ) then new_state[ 1 ] = new_state[ 1 ] + 1;
      elseif ( new_dir == 2 ) then new_state[ 2 ] = new_state[ 2 ] - 1;
      elseif ( new_dir == 3 ) then new_state[ 1 ] = new_state[ 1 ] - 1;
      elseif ( new_dir == 4 ) then new_state[ 2 ] = new_state[ 2 ] + 1;
      end;

      local old_params = ObjGet( obj_name );

      local new_pos = {
        x = private.maze_beg_pos_x + ( new_state[ 1 ] - 1 ) * private.maze_step, 
        y = private.maze_beg_pos_y + ( new_state[ 2 ] - 1 ) * private.maze_step 
      };

      local func_end = function ()

        common_impl.Lock( false );
        private.MazeClkEnd( new_state );

      end;

      common_impl.Lock( true );

      ObjAnimate( obj_name, "pos_xy", 0, 0, func_end, { 
        0.0,  3,  old_params.pos_x,  old_params.pos_y,
        0.2,  3,  new_pos.x,     new_pos.y
      } );
  
      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk2", 0, "", 0 );

    else

      local func_end = function ()

        common_impl.Lock( false );

      end;

      common_impl.Lock( true );

      ObjAnimate( obj_name, "ang", 0, 0, func_end, { 
        0.0,  3,  0,
        0.1,  3,  0.2,
        0.3,  3,  - 0.2,
        0.4,  3,  0 
      } );
  
      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_maze", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.MazeClkEnd ( new_state )

    private.maze.current_list[ 1 ] = new_state[ 1 ];
    private.maze.current_list[ 2 ] = new_state[ 2 ];

    local flag_win = true;

    for i = 1, #private.maze_win_list do
      
      if ( private.maze.current_list[ i ] ~= private.maze_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.MazeWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.current_list[ 1 ] = new_state[ 1 ];
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.current_list[ 2 ] = new_state[ 2 ];

    end;

  end;
  --*********************************************************************************************************************
  function private.MazeWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.maze.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.win = true;

      private.MazeWinSet();

    end;

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_beep", 0, "", 0 );

    end;

    ObjAnimate( "spr_superpuzzle2_door_1", "pos_x", 0, 0, func_audio, 
    { 
      0,   3, 370,  
      0.7, 3, 0,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_blue_2", "alp", 0, 0, "", 
    { 
      0,   3, 0,  
      0.7, 3, 0,  
      1.2, 3, 1,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_red_2", "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.7, 3, 1,  
      1.2, 3, 0,  
    } );   

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.MazeWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_1",        { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_2_arrows",   { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_2",          { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_5",          { alp = 1 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_2",    { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_2",   { alp = 1 } } );

    if ( private.pictures.win ) and ( private.maze.win ) and ( private.bottles.win ) then

      for i = 1, 5 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = true, alp = 1 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );   

      end;

      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_5_light", { alp = 1 } } );   

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.MazeResetSet ()

    local table_multiset = {};

    private.maze.current_list = { 1,1 };
    private.maze.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.current_list = { 1,1 };
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].maze.win = false;

    table.insert( table_multiset, { "spr_superpuzzle2_mg_2_syringe", { 
      pos_x = private.maze_beg_pos_x + ( private.maze.current_list[ 1 ] - 1 ) * private.maze_step, 
      pos_y = private.maze_beg_pos_y + ( private.maze.current_list[ 2 ] - 1 ) * private.maze_step 
    } } );


    table.insert( table_multiset, { "spr_superpuzzle2_door_1", { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_2_arrows", { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_5_light", { alp = 0 } } );   

    table.insert( table_multiset, { "obj_superpuzzle2_mg_2",          { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_5",          { alp = 0 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_2",    { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_2",   { alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Bottles ***() end
--*********************************************************************************************************************
  function private.BottlesStartDrag ( number )

    local obj_name = "obj_superpuzzle2_mg_3_bottle_"..number;

    private.bottle_parent = ObjGetRelations( obj_name ).parent;
    private.bottle_pos_z  = ObjGet( obj_name ).pos_z;

    ObjAttach( obj_name, "mg_superpuzzle2" )
    ObjSet( obj_name, { pos_z = 20 } );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk4", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.BottlesDrop ( number_drop )

    local name = "obj_superpuzzle2_mg_3_bottle_";
    local drop_name = name..number_drop;

    ObjAttach( drop_name, private.bottle_parent )
    ObjSet( drop_name, { pos_z = private.bottle_pos_z } );

    local number_use = 0;

    if ( cmn.ApplyObj( drop_name, name.."use" ) ) then

      local volume_drop = private.bottles.current_list[ number_drop ];

      if ( volume_drop == private.bottles_win_volume ) then

        ObjSet( "obj_superpuzzle2_mg_3_bottle_5", { pos_x = 635, pos_y = 534 } );
        private.BottlesWinAnim();

      end;

    elseif ( cmn.ApplyObj( drop_name, name.."1" ) ) and ( drop_name ~= name.."1" ) then

      number_use = 1;

    elseif ( cmn.ApplyObj( drop_name, name.."3" ) ) and ( drop_name ~= name.."3" ) then

      number_use = 3;

    elseif ( cmn.ApplyObj( drop_name, name.."5" ) ) and ( drop_name ~= name.."5" ) then

      number_use = 5;

    end;

    if ( number_use ~= 0 ) then

      local volume_drop = private.bottles.current_list[ number_drop ];
      local volume_use  = private.bottles.current_list[ number_use ];
      local max_drop = private.bottles_size[ number_drop ];
      local max_use  = private.bottles_size[ number_use ];

      if ( volume_use ~= max_use ) and ( volume_drop ~= 0 ) then

        local volume_free = max_use - volume_use; 

        if ( volume_drop > volume_free ) then

          volume_drop = volume_drop - volume_free;
          volume_use  = volume_use + volume_free;
 
        else

          volume_use  = volume_use + volume_drop;
          volume_drop = 0;
          
        end;

        local func_end = function ()

          common_impl.Lock( false ); 

          private.BottlesDropEnd( number_drop, number_use, volume_drop, volume_use );

        end;

        common_impl.Lock( true ); 

        if ( number_use ~= 1 ) then

          local old_scale_use  = ObjGet( "spr_superpuzzle2_mg_3_bottle_"..number_use.."_fill" ).scale_y;
          local new_scale_use  = private.BottlesLevel( number_use, volume_use );

          ObjAnimate( "spr_superpuzzle2_mg_3_bottle_"..number_use.."_fill",  "scale_y", 0, 0, "", { 0,3,old_scale_use,  0.6,3,new_scale_use } );

        end;

        ObjAttach( drop_name, "mg_superpuzzle2" );
        ObjSet( drop_name, { pos_z = 20 } );

        local pos_x_beg = private.bottles_up_pos[ number_use ][ 1 ];
        local pos_y_beg = private.bottles_up_pos[ number_use ][ 2 ];

        local pos_x_end = private.bottles_beg_pos[ number_drop ][ 1 ];
        local pos_y_end = private.bottles_beg_pos[ number_drop ][ 2 ];

        ObjAnimate( drop_name, "pos_xy", 0, 0, func_end, { 0,3,pos_x_beg,pos_y_beg,      0.6,3,pos_x_beg,pos_y_beg,      1.2,3,pos_x_end,pos_y_end } );
        ObjAnimate( drop_name, "ang",    0, 0, "",       { 0,3,private.bottles_up_ang,   0.6,3,private.bottles_up_ang,   1.2,3,0 } );

        common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk5", 0, "", 0 );

        if ( number_drop ~= 1 ) then

          local old_scale_drop = ObjGet( "spr_superpuzzle2_mg_3_bottle_"..number_drop.."_fill" ).scale_y;
          local new_scale_drop = private.BottlesLevel( number_drop, volume_drop );

          ObjAnimate( "spr_superpuzzle2_mg_3_bottle_"..number_drop.."_fill", "scale_y", 0, 0, "", { 0,3,old_scale_drop,  0.6,3,new_scale_drop } );

        end;

      else

        common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      end;

    else

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.BottlesDropEnd ( number_drop, number_use, volume_drop, volume_use )

    local name = "obj_superpuzzle2_mg_3_bottle_";
    local drop_name = name..number_drop;

    local pos_x = private.bottles_beg_pos[ number_drop ][ 1 ];
    local pos_y = private.bottles_beg_pos[ number_drop ][ 2 ];

    ObjAttach( drop_name, private.bottle_parent )
    ObjSet( drop_name, { pos_z = private.bottle_pos_z, pos_x = pos_x, pos_y = pos_y, ang = 0 } );

    private.bottles.current_list[ number_drop ] = volume_drop;
    private.bottles.current_list[ number_use ]  = volume_use;

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.current_list[ number_drop ] = volume_drop;
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.current_list[ number_use ]  = volume_use;

    private.BottlesLevelSet( number_drop, volume_drop );
    private.BottlesLevelSet( number_use,  volume_use );

  end;
  --*********************************************************************************************************************
  function private.BottlesLevel ( number, volume )

    local max = private.bottles_size[ number ];

    if ( number == 3 ) then

      return 38 * volume / max;

    elseif ( number == 5 ) then

      return 46 * volume / max;

    end;

  end;
  --*********************************************************************************************************************
  function private.BottlesLevelSet ( number, volume )

    local obj_name = "spr_superpuzzle2_mg_3_bottle_"..number.."_fill";

    local max = private.bottles_size[ number ];

    local scale_y = private.BottlesLevel( number, volume );

    if ( scale_y ) then

      ObjSet( obj_name, { scale_y = scale_y } );

    end;

  end;
  --*********************************************************************************************************************
  function private.BottlesWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.bottles.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.win = true;

      private.BottlesWinSet();

    end;

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_beep", 0, "", 0 );

    end;

    ObjAnimate( "spr_superpuzzle2_door_3", "pos_y", 0, 0, func_audio, 
    { 
      0,   3, 200,  
      0.5, 3, 0,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_blue_3", "alp", 0, 0, "", 
    { 
      0,   3, 0,  
      0.5, 3, 0,  
      1.0, 3, 1,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_red_3", "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.5, 3, 1,  
      1.0, 3, 0,  
    } );   

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.BottlesWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_3",        { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_3_bottles",  { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_3_bottle_5", { pos_x = 635, pos_y = 534 } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_3",          { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_6",          { alp = 1 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_3",    { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_3",   { alp = 1 } } );

    if ( private.pictures.win ) and ( private.maze.win ) and ( private.bottles.win ) then

      for i = 1, 5 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = true, alp = 1 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );   

      end;

      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_5_light", { alp = 1 } } );   

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.BottlesResetSet ()

    local table_multiset = {};

    private.bottles.current_list = { 20, 0, 0, 0, 0 };
    private.bottles.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.current_list = { 20, 0, 0, 0, 0 };
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].bottles.win = false;


    for i = 1, #private.bottles.current_list do
    
      private.BottlesLevelSet ( i, 0 );

    end;

    table.insert( table_multiset, { "obj_superpuzzle2_mg_3_bottle_5", { pos_x = 381, pos_y = 548 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_door_3",       { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_3_bottles", { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_3",          { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_6",          { alp = 0 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_3",    { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_3",   { alp = 0 } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Mmg Hexs ***() end
--*********************************************************************************************************************
  function private.HexsClk ( number )

    common_impl.Lock( true );

    local func_unlock = function ()

      common_impl.Lock( false );

    end;

    local active_number  = private.HexsFindActive();
    local active_value   = private.hexs_list_2[ active_number ];
    local current_value  = private.hexs_list[ number ];

    if ( active_value == current_value ) then

      local obj_name      = "obj_superpuzzle2_mg_6_hex_"..number;
      local spr_name      = "spr_superpuzzle2_mg_6_picture_"..number;
      local spr_name_1    = "spr_superpuzzle2_mg_6_picture_"..number.."_1";

      local obj_active      = "obj_superpuzzle2_mg_6_hex_"..active_number;
      local spr_active_1    = "spr_superpuzzle2_mg_6_picture_"..active_number.."_1";
      local spr_active_over = "spr_superpuzzle2_mg_6_picture_"..active_number.."_over";
   
      if ( number == 9 ) then

        spr_name_1 = "spr_superpuzzle2_mg_6_picture_"..number.."_over";
        ObjSet( "spr_superpuzzle2_mg_6_light", { alp = 0 } );

      end;

      local func_end = function ()

        func_unlock();
        private.HexsClkEnd( active_number, number );

      end;

      ObjAnimate( obj_name,   "scale_x", 0, 0, func_end, { 0,3,1,  0.2,3,0, 0.4,3,1 } );
      ObjAnimate( spr_name,   "alp",     0, 0, "",       { 0,3,1,  0.2,3,1, 0.2,3,0 } );
      ObjAnimate( spr_name_1, "alp",     0, 0, "",       { 0,3,0,  0.2,3,0, 0.2,3,1 } );

      ObjAnimate( obj_active,      "scale_x", 0, 0, "", { 0,3,1,  0.2,3,0, 0.4,3,1 } );
      ObjAnimate( spr_active_1,    "alp",     0, 0, "", { 0,3,1,  0.2,3,1, 0.2,3,0 } );
      ObjAnimate( spr_active_over, "alp",     0, 0, "", { 0,3,0,  0.2,3,0, 0.2,3,1 } );

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk6", 0, "", 0 );

    else

      common_impl.PlayAudio( "sfx", "aud_wrong_apply", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle2_mg_6_light", "alp", 0, 0, func_unlock, { 0,3,1,  0.1,3,0,  0.2,3,1,  0.3,3,0,  0.4,3,1 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.HexsClkEnd ( active_number, number )
  
    private.hexs.current_list[ active_number ] = 2;
    private.hexs.current_list[ number ] = 1;

    local new_active_number  = private.HexsFindActive();
  
    ObjSet( "obj_superpuzzle2_mg_6_hex_"..number, { input = false } );

    if ( number == 9 ) then

      private.HexsWinAnim();

    else

      ObjAttach( "spr_superpuzzle2_mg_6_light", "obj_superpuzzle2_mg_6_hex_"..new_active_number );

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.current_list[ active_number ] = 2;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.current_list[ number ] = 1;

    end;

  end;
  --*********************************************************************************************************************
  function private.HexsFindActive ()
  
    for i = 1, #private.hexs.current_list do
      
      if ( private.hexs.current_list[ i ] == 1 ) then

        return i;

      end;

    end;

  end;
  --*********************************************************************************************************************
  function private.HexsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.hexs.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.win = true;

      private.HexsWinSet();

    end;

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_beep", 0, "", 0 );

    end;

    ObjAnimate( "spr_superpuzzle2_door_3", "pos_y", 0, 0, func_audio, 
    { 
      0,   3, 200,  
      0.5, 3, 0,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_blue_6", "alp", 0, 0, "", 
    { 
      0,   3, 0,  
      0.5, 3, 0,  
      1.0, 3, 1,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_red_6", "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.5, 3, 1,  
      1.0, 3, 0,  
    } );   

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.HexsWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_3",      { pos_y = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hexs",   { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_6",  { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_6", { alp = 1 } } );

    if ( private.levers.win ) and ( private.match3.win ) and ( private.hexs.win ) then

      for i = 1, 6 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = true, alp = 1 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );   

      end;

      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_6_light", { alp = 1 } } );   

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.HexsResetSet ()

    local table_multiset = {};
    private.hexs.current_list = { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

    private.hexs.win = false;                  

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.current_list = { 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].hexs.win = false;

    table.insert( table_multiset, { "spr_superpuzzle2_door_3",    { pos_y = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hexs", { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_6",  { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_6", { alp = 0 } } );

    ObjSet( "spr_superpuzzle2_mg_6_light", { alp = 1 } );

    for i = 1, #private.hexs.current_list do
        
      if ( private.hexs.current_list[ i ] == 1 ) then

        table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hex_"..i, { input = false } } );
        table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i, { alp = 0 } } );
        table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_1", { alp = 1 } } );
        table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_over", { alp = 0 } } );

        ObjAttach( "spr_superpuzzle2_mg_6_light", "obj_superpuzzle2_mg_6_hex_"..i );

      else
  
        table.insert( table_multiset, { "obj_superpuzzle2_mg_6_hex_"..i, { input = true } } );
        table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i, { alp = 1 } } );
        table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_1", { alp = 0 } } );
        table.insert( table_multiset, { "spr_superpuzzle2_mg_6_picture_"..i.."_over", { alp = 0 } } );

      end;

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--function *** Mmg Match3 *** ()
--*********************************************************************************************************************
  function private.Match3Init ()

    private.match3 = {};
    private.match3.points = 0;

    private.match3_cell_x = 5;
    private.match3_cell_y = 6;

    private.match3_points_win = 30;
    private.match3_first_chip = nil;

    private.match3_toremove = {};
    private.match3_field    = {};
    private.match3_weidth   = {};

    private.delta_pos_y = 100;

    private.start_pos_x = 104;

    private.chip_pos = { { 0, 52, 104, 156, 208 }, { 0, 52, 104, 156, 208, 260, 312 } };

    for i = 1, private.match3_cell_y do

      private.match3_field[ i ]  = { 0, 0, 0, 0, 0, 0, 0 };
      private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0 };

    end;

    private.Match3ProgressBarSet();

  end;
--*********************************************************************************************************************
  function private.Match3Load ()

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        ObjCreate( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j, "obj" );
        ObjCreate( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j, "spr" );
        ObjCreate( "spr_superpuzzle2_mg_4_chip_flash_"..i.."_"..j, "spr" );

        ObjAttach( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j, "obj_superpuzzle2_mg_4_chips" );
        ObjAttach( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j, "obj_superpuzzle2_mg_4_chip_"..i.."_"..j );
        ObjAttach( "spr_superpuzzle2_mg_4_chip_flash_"..i.."_"..j, "obj_superpuzzle2_mg_4_chip_"..i.."_"..j );

        local type = ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ];

        private.match3_field[ i ][ j ] = type;

        ObjSet( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j,
        {
          pos_x = private.chip_pos[ 1 ][ j ],
          pos_y = private.chip_pos[ 2 ][ i ],
          input   = true,
          active  = true,
          visible = true,
          event_mdown  = function () private.Match3ClickChip ( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
          inputrect_init = true,
          inputrect_x = -25,
          inputrect_y = -25,
          inputrect_w =  50,
          inputrect_h =  50,
        } );

        ObjSet( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j,
        {
          input = false,
          res = "assets/levels/level2/mg_superpuzzle2/layer/mg_4/chip_"..type,
        } );

        ObjSet( "spr_superpuzzle2_mg_4_chip_flash_"..i.."_"..j,
        {
          input = false,
          scale_x = 0.5,
          alp = 0,
          res = "assets/levels/level2/mg_superpuzzle2/layer/mg_4/chip_flash",
        } );

      end;

    end;

    private.Match3ProgressBarSet();
  
  end;
  --*********************************************************************************************************************
  function private.Match3ResetSet ()

    ObjSet( "spr_superpuzzle2_mg_7_blue_4", { alp = 0 } );
    ObjSet( "spr_superpuzzle2_mg_7_red_4",  { alp = 1 } );

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.points = 0;
    private.match3.points = 0;

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.win = false;

    private.match3.win = false;

    private.Match3GenerateField();

    private.Match3ProgressBarSet();

  end;
  ------------------------------------------------------------
  function private.Match3GenerateField ( is_first )

    local is_done = false;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        local type = private.Match3GetRandomChip();

        ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ] = type;

        if ( is_first ) then

          ObjCreate( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j, "obj" );
          ObjCreate( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j, "spr" );
          ObjCreate( "spr_superpuzzle2_mg_4_chip_flash_"..i.."_"..j, "spr" );

          ObjAttach( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j, "obj_superpuzzle2_mg_4_chips" );
          ObjAttach( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j, "obj_superpuzzle2_mg_4_chip_"..i.."_"..j );
          ObjAttach( "spr_superpuzzle2_mg_4_chip_flash_"..i.."_"..j, "obj_superpuzzle2_mg_4_chip_"..i.."_"..j );

        end;

      end;

    end;

    while ( not is_done ) do

      is_done = private.Match3ShuffleField();

    end;

    for i = 1, private.match3_cell_y do

      for j = 1,private.match3_cell_x do

        local type = ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ];

        ObjSet( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j,
        {
          pos_x = private.chip_pos[ 1 ][ j ],
          pos_y = private.chip_pos[ 2 ][ i ],
          input   = true,
          active  = true,
          visible = true,
          event_mdown  = function () private.Match3ClickChip ( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j ) end,
          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
          inputrect_init = true,
          inputrect_x = -25,
          inputrect_y = -25,
          inputrect_w =  50,
          inputrect_h =  50,
        } );

        ObjSet( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j,
        {
          input = false,
          res = "assets/levels/level2/mg_superpuzzle2/layer/mg_4/chip_"..type,
        } );

        ObjSet( "spr_superpuzzle2_mg_4_chip_flash_"..i.."_"..j,
        {
          input = false,
          scale_x = 0.5,
          alp = 0,
          res = "assets/levels/level2/mg_superpuzzle2/layer/mg_4/chip_flash",
        } );

      end;

    end;

  end;
------------------------------------------------------------
  function private.Match3ShuffleField ()

    local is_done = true;

    for i = 1, private.match3_cell_y do

      for j = 1, ( private.match3_cell_x - 2 ) do

        if ( ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j + 1 ] ) and
           ( ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j + 2 ] ) then

          ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j + 1 ] = private.Match3GetRandomChip();

          is_done = false;

        end;

      end;

    end;

    for i = 1, ( private.match3_cell_y - 2 ) do

      for j = 1, private.match3_cell_x do

        if ( ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i + 1 ][ j ] ) and
           ( ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ] == ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i + 2 ][ j ] ) then

          ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i + 1 ][ j ] = private.Match3GetRandomChip();

          is_done = false;

        end;

      end;

    end;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        private.match3_field[ i ][ j ] = ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ];

      end;

    end;

    return is_done;

  end;
------------------------------------------------------------
  function private.Match3GetRandomChip ()

    local type = math.random( 1, 100 );

    if     ( type > 0  and type < 21 ) then type = 2;
    elseif ( type > 21 and type < 41 ) then type = 3;
    elseif ( type > 41 and type < 61 ) then type = 4;
    elseif ( type > 61 and type < 81 ) then type = 5;
    else                                    type = 1;
    end;

    return type;
    
  end;
------------------------------------------------------------
  function private.Match3ClickChip ( chip )

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_clk_chip", 0, "", 0 );

    if ( not private.match3_first_chip ) then

      private.match3_first_chip = chip;

      local pos = ObjGet( chip );

      ObjSet("spr_superpuzzle2_mg_4_chip_light",
      {
        pos_x = pos.pos_x, 
        pos_y = pos.pos_y,
        visible = true
      } );

    else

      ObjSet( "spr_superpuzzle2_mg_4_chip_light", { visible = false } );


      if ( private.match3_first_chip == chip ) then

        private.match3_first_chip = nil;

        return;

      end;

      private.match3_second_chip = chip;

      local old_x = ObjGet( private.match3_first_chip ).pos_x;
      local old_y = ObjGet( private.match3_first_chip ).pos_y;
      local new_x = ObjGet( chip ).pos_x;
      local new_y = ObjGet( chip ).pos_y;

      local old_i_x = 0;
      local old_i_y = 0;
      local new_i_x = 0;
      local new_i_y = 0;

      for i = 1, private.match3_cell_x do

        if ( old_x == private.chip_pos[ 1 ][ i ] ) then

          old_i_y = i;

        end;

        if ( new_x == private.chip_pos[ 1 ][ i ] ) then

          new_i_y = i;

        end;

      end;

      for i = 1, private.match3_cell_y do

        if ( old_y == private.chip_pos[ 2 ][ i ] ) then

          old_i_x = i;

        end;

        if ( new_y == private.chip_pos[ 2 ][ i ] ) then

          new_i_x = i;

        end;

      end;

      if ( old_i_x == new_i_x ) and ( math.abs( old_i_y - new_i_y ) == 1 ) or
         ( old_i_y == new_i_y ) and ( math.abs( old_i_x - new_i_x ) == 1 ) then

        private.Match3SwapChips( new_x, new_y, old_x, old_y );

        local temp = private.match3_field[ old_i_x ][ old_i_y ];

        private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
        private.match3_field[ new_i_x ][ new_i_y ] = temp;

        if ( private.Match3Checking() ) then

          ObjSet( "tmr_superpuzzle2_mg_4_exchange", 
          {
            time = 0.2, 
            playing = true,
            endtrig = function ()

              private.Match3SetFieldState();

              private.Match3Disappearance();

            end;
          } );

        else

          local temp = private.match3_field[ old_i_x ][ old_i_y ];

          private.match3_field[ old_i_x ][ old_i_y ] = private.match3_field[ new_i_x ][ new_i_y ];
          private.match3_field[ new_i_x ][ new_i_y ] = temp; 

          ObjSet( "tmr_superpuzzle2_mg_4_exchange", 
          {
            time = 0.2, 
            playing = true,
            endtrig = function ()

              private.Match3SwapChips( old_x, old_y, new_x, new_y, true );

            end;
          } );


        end;

        private.match3_firstclk = nil;

      else

        private.match3_first_chip = chip;

        local pos = ObjGet( chip );

        ObjSet("spr_superpuzzle2_mg_4_chip_light",
        {
          pos_x = pos.pos_x, 
          pos_y = pos.pos_y,
          visible = true
        } );

      end;

    end;

  end;
------------------------------------------------------------
  function private.Match3SwapChips ( new_x, new_y, old_x, old_y, is_back )

    common_impl.Lock( true );

    ObjAnimate( private.match3_second_chip, "pos_xy", 0, 0,
    function ()

      if ( is_back ) then

        private.match3_first_chip = nil;

        common_impl.Lock( false );

      end;

    end,
    {
      0.0, 0, new_x, new_y,
      0.2, 0, old_x, old_y
    } );

    ObjAnimate( private.match3_first_chip, "pos_xy", 0, 0, "",
    {
      0.0, 0, old_x, old_y,
      0.2, 0, new_x, new_y
    } );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_swap_chip", 0, "", 0 );

  end;
------------------------------------------------------------
  function private.Match3Checking ()

    for i = 1, private.match3_cell_y do

      for j = 1, ( private.match3_cell_x - 2 ) do

        if ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 1 ] ) and
           ( private.match3_field[ i ][ j ] == private.match3_field[ i ][ j + 2 ] ) and
           ( private.match3_field[ i ][ j ] ~= 7) then

          if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j,     0 }; end;
          if ( private.Match3AddToQueue( i, j + 1 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 1, 0 }; end;
          if ( private.Match3AddToQueue( i, j + 2 ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i, j + 2, 0 }; end;

        end;

      end;

    end;

    for i = 1, ( private.match3_cell_y - 2 ) do

      for j = 1, private.match3_cell_x do

        if ( private.match3_field[ i ][ j ] == private.match3_field[ i + 1 ][ j ] ) and
           ( private.match3_field[ i ][ j ] == private.match3_field[ i + 2 ][ j ] )  and
           ( private.match3_field[ i ][ j ] ~= 7) then

          if ( private.Match3AddToQueue( i, j ) )     then private.match3_toremove[ #private.match3_toremove + 1 ] = { i,     j, math.pi / 2 }; end;
          if ( private.Match3AddToQueue( i + 1, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 1, j, math.pi / 2 }; end;
          if ( private.Match3AddToQueue( i + 2, j ) ) then private.match3_toremove[ #private.match3_toremove + 1 ] = { i + 2, j, math.pi / 2 }; end;

        end;

      end;

    end;

    private.match3.points = private.match3.points + #private.match3_toremove;

    private.Match3ProgressBarSet();

    if ( #private.match3_toremove == 0 ) then

      return false;

    end;

    return true;

  end;
------------------------------------------------------------
  function private.Match3AddToQueue ( pos_x, pos_y )

    for i = 1, #private.match3_toremove do

      if ( private.match3_toremove[ i ][ 1 ] == pos_x ) and
         ( private.match3_toremove[ i ][ 2 ] == pos_y ) then

        return false;

      end;

    end;

    return true;

  end;
------------------------------------------------------------
  function private.Match3SetFieldState ()

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        local type = private.match3_field[ i ][ j ];

        ObjSet( "obj_superpuzzle2_mg_4_chip_"..i.."_"..j,
        {
          pos_x = private.chip_pos[ 1 ][ j ],
          pos_y = private.chip_pos[ 2 ][ i ],
        } );

        ObjSet( "spr_superpuzzle2_mg_4_chip_"..i.."_"..j,
        {
          res = "assets/levels/level2/mg_superpuzzle2/layer/mg_4/chip_"..type,
        } );

      end;

    end;

  end;
------------------------------------------------------------
  function private.Match3Disappearance ()

    common_impl.Lock( true );

    if ( #private.match3_toremove ~= 0 ) then

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_disappearance_chip", 0, "", 0 );

      for i = 1, ( #private.match3_toremove ) do

        local x = private.match3_toremove[ i ][ 1 ];
        local y = private.match3_toremove[ i ][ 2 ];
        local a = private.match3_toremove[ i ][ 3 ];

        ObjAnimate( "spr_superpuzzle2_mg_4_chip_"..x.."_"..y, "alp", 0, 0, "",
        {
          0.0, 0, 1,
          0.3, 0, 0
        } );

        ObjSet( "spr_superpuzzle2_mg_4_chip_flash_"..x.."_"..y, { ang = a } );

        ObjAnimate( "spr_superpuzzle2_mg_4_chip_flash_"..x.."_"..y, "alp", 0, 0, "",
        {
          0.00, 0, 0,
          0.15, 0, 1,
          0.30, 0, 0
        } );

        private.match3_field[ private.match3_toremove[ i ][ 1 ] ][ private.match3_toremove[ i ][ 2 ] ] = 0;

      end;

      ObjSet( "tmr_superpuzzle2_mg_4_remove", 
      {
        time = 0.3, 
        playing = true,
        endtrig = function ()

          private.Match3FallChips();

        end;
      } );

    end;

  end;
------------------------------------------------------------
  function private.Match3FallChips ()

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_fairytale_fall_chip", 0, "", 0 );

    for j = private.match3_cell_x, 1, -1 do

      for i = private.match3_cell_y, 1, -1 do

        if ( private.match3_field[ i ][ j ] == 0 ) then

          local index = i;

          while ( index > 0 ) do

            if ( private.match3_field[ index ][ j ] ~= 0 ) then

              private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] + 1;

            else

              private.match3_weidth[ index ][ j ] = private.match3_weidth[ index ][ j ] - 1;

            end;

            index = index - 1;

          end;

        end;

      end;

    end;

    for j = private.match3_cell_x, 1, -1 do

      local count = 0;

      for i = private.match3_cell_y, 1, -1 do

        local pos = private.match3_weidth[ i ][ j ];

        if ( pos < 0 ) then

          local chip = "obj_superpuzzle2_mg_4_chip_"..i.."_"..j;

          ObjSet( chip, { pos_y = ( 51 * pos - private.delta_pos_y ), pos_x = private.start_pos_x } );

        end;

      end;

    end;

    for i = private.match3_cell_y, 1, -1 do

      for j = private.match3_cell_x, 1, -1 do

        if ( private.match3_weidth[ i ][ j ] > 0 ) then

          local chip = "obj_superpuzzle2_mg_4_chip_"..i.."_"..j;

          local pos_start = private.chip_pos[ 2 ][ i ];
          local pos_end   = pos_start + 51 * private.match3_weidth[ i ][ j ];

          ObjAnimate( chip, "pos_y", 0, 0, "",
          {
            0.0, 1, pos_start,
            0.3, 1, pos_end
          } );

          private.match3_field[ i + private.match3_weidth[ i ][ j ] ][ j ] = private.match3_field[ i ][ j ];
          private.match3_field[ i ][ j ] = 0;

        end;

      end;

    end;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        if ( private.match3_field[ i ][ j ] == 0 ) then

          private.match3_field[ i ][ j ] = private.Match3GetRandomChip();

          local x = 0;
          local y = 0;

          local loop = true;

          for i = 1, private.match3_cell_y do

            if ( loop ) then

              for j = 1, private.match3_cell_x do

                if ( private.match3_weidth[ i ][ j ] < 0 ) then

                  x = i;
                  y = j;

                  private.match3_weidth[ i ][ j ] = 0;

                  loop = false;

                  break;

                end;

              end;

            end;

          end;

          local chip = "obj_superpuzzle2_mg_4_chip_"..x.."_"..y;

          local pos_y = ObjGet( chip ).pos_y;

          ObjSet( "spr_superpuzzle2_mg_4_chip_"..x.."_"..y, { alp = 1, res = "assets/levels/level2/mg_superpuzzle2/layer/mg_4/chip_"..private.match3_field[ i ][ j ], } );

          ObjAnimate( chip, "pos_y", 0, 0, "",
          {
            0.00, 1, pos_y, 
            0.30, 1, private.chip_pos[ 2 ][ i ],
          } );

          ObjAnimate( chip, "pos_x", 0, 0, "",
          {
            0.00, 1, private.start_pos_x,
            0.05, 1, private.start_pos_x,
            0.30, 1, private.chip_pos[ 1 ][ j ],
          } );

        end;

      end;

    end;

    private.match3_toremove = {};
    private.match3_grain = {};

    for i = 1, private.match3_cell_y do 

      private.match3_weidth[ i ] = { 0, 0, 0, 0, 0, 0, 0 };

    end;

    ObjSet( "tmr_superpuzzle2_mg_4_fall", 
    {
      time = 0.3, 
      playing = true,
      endtrig = function ()

        private.Match3SetFieldState();

        local is_delete_chips = private.Match3Checking();

        if ( is_delete_chips ) then

          private.Match3Disappearance();

        else 

          private.Match3FallChipsEnd();

        end;

      end;
    } );

  end;
------------------------------------------------------------
  function private.Match3FallChipsEnd ()

    common_impl.Lock( false );

    private.match3_first_chip = nil;

    for i = 1, private.match3_cell_y do

      for j = 1, private.match3_cell_x do

        ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3_field[ i ][ j ] = private.match3_field[ i ][ j ];

      end;

    end;

    if ( private.match3.points >= private.match3_points_win ) then

      private.Match3WinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.points = private.match3.points;

    end;

  end;

  ------------------------------------------------------------

  function private.Match3ProgressBarSet ()

    local obj_name = "spr_superpuzzle2_mg_4_scale";
    local value    = private.match3.points;
    local max      = private.match3_points_win;

    ObjSet( obj_name, { croprect_y = 140 - ( 250 / max ) * value } );

  end;

  ------------------------------------------------------------

  function private.Match3WinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.match3.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].match3.win = true;

      private.Match3WinSet();

    end;

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_beep", 0, "", 0 );

    end;

    ObjAnimate( "spr_superpuzzle2_door_2", "pos_x", 0, 0, func_audio, 
    { 
      0,   3, -360,  
      0.5, 3, 0,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_blue_4", "alp", 0, 0, "", 
    { 
      0,   3, 0,  
      0.5, 3, 0,  
      1.0, 3, 1,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_red_4", "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.5, 3, 1,  
      1.0, 3, 0,  
    } );   

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Match3WinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_2",    { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_4_crop", { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_4", { alp = 1 } } );   
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_4",  { alp = 0 } } );   

    if ( private.levers.win ) and ( private.match3.win ) and ( private.hexs.win ) then

      for i = 1, 6 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = true, alp = 1 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );   

      end;

      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_6_light", { alp = 1 } } );   

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Levers ***() end
--*********************************************************************************************************************
  function private.LeversDrag ( number )

    local name = "spr_superpuzzle2_mg_5_lever_"..number;

    if ( private.levers_first ) then

      private.levers_pos_y_begin = {};
      
      local pos = GetZoomCursorPos();
      
      private.levers_cursor_pos_y_begin = pos[ 2 ];

      for i = 1, 3 do
     
        private.levers_pos_y_begin[ i ] = ObjGet( "spr_superpuzzle2_mg_5_lever_"..i ).pos_y;

      end;

      private.levers_first = false;

      common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk1", 0, "", 0 );

    end;
      local pos = GetZoomCursorPos();
      
      local cursor_pos_y = pos[ 2 ];

    local delta_pos_y = private.LeversCorrectPos( cursor_pos_y - private.levers_cursor_pos_y_begin + private.levers_pos_y_begin[ number ] );

    ObjSet( name, { pos_y = delta_pos_y } );

    private.LeversHolePos( number, delta_pos_y );

    if ( number == 1 ) then

      local pos_y_3 = private.LeversCorrectPos( cursor_pos_y - private.levers_cursor_pos_y_begin + private.levers_pos_y_begin[ 3 ], 3 );

      ObjSet( "spr_superpuzzle2_mg_5_lever_3", { pos_y = pos_y_3 } );

      private.LeversHolePos( 3, pos_y_3 );

    elseif ( number == 3 ) then

      local pos_y_2 = private.LeversCorrectPos( - cursor_pos_y + private.levers_cursor_pos_y_begin + private.levers_pos_y_begin[ 2 ], 2 );

      ObjSet( "spr_superpuzzle2_mg_5_lever_2", { pos_y = pos_y_2 } );

      private.LeversHolePos( 2, pos_y_2 );

    end;

  end;
  --*********************************************************************************************************************
  function private.LeversDragDrop ()

    private.levers_first = true;

    for i = 1, #private.levers.current_list do
    
      private.levers.current_list[ i ] = ObjGet( "spr_superpuzzle2_mg_5_lever_"..i ).pos_y;

    end;

    local flag_win = true;

    for i = 1, #private.levers_win_list do
      
      local delta = math.abs( private.levers.current_list[ i ] - private.levers_win_list[ i ] );

      if ( delta > 20 ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.LeversWinAnim();

    else

      for i = 1, #private.levers.current_list do
      
        ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.current_list[ i ] = private.levers.current_list[ i ];

      end;

    end;

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LeversCorrectPos ( pos_y, number_correct )

    local old_pos_y = pos_y;

    if ( pos_y < private.levers_pos_up ) then

      pos_y = private.levers_pos_up;

    elseif ( pos_y > private.levers_pos_down ) then

      pos_y = private.levers_pos_down;

    end;

    if ( number_correct ) and 
       ( pos_y == private.levers_pos_up or pos_y == private.levers_pos_down ) then
       
       local pos = GetZoomCursorPos();
      
      private.levers_cursor_pos_y_begin = pos[ 2 ];

      for i = 1, 3 do
     
        private.levers_pos_y_begin[ i ] = ObjGet( "spr_superpuzzle2_mg_5_lever_"..i ).pos_y;

      end;

    end;

    return pos_y;

  end;
  --*********************************************************************************************************************
  function private.LeversHolePos ( number, pos_y_lever )

    local name_hole = "spr_superpuzzle2_mg_5_metal_"..number;

    local array_pos = { { 0, -50 }, { 50, -50 }, { 50, 0 } };

    local delta = ( pos_y_lever - private.levers_pos_up ) / ( private.levers_pos_down - private.levers_pos_up );

    local pos_x = array_pos[ number ][ 1 ] + delta * ( array_pos[ number ][ 2 ] - array_pos[ number ][ 1 ] );

    ObjSet( name_hole, { pos_x = pos_x } );

  end;
  --*********************************************************************************************************************
  function private.LeversWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.levers.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.win = true;

      private.LeversWinSet();

    end;

    local func_audio = function ()

      common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_beep", 0, "", 0 );

    end;

    ObjAnimate( "spr_superpuzzle2_door_1", "pos_x", 0, 0, func_audio, 
    { 
      0,   3, 370,  
      0.5, 3, 0,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_blue_5", "alp", 0, 0, "", 
    { 
      0,   3, 0,  
      0.5, 3, 0,  
      1.0, 3, 1,  
    } );   

    ObjAnimate( "spr_superpuzzle2_mg_7_red_5", "alp", 0, 0, func_end, 
    { 
      0,   3, 1,  
      0.5, 3, 1,  
      1.0, 3, 0,  
    } );   

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_well_clk3", 0, "", 0 );

    common_impl.PlayAudio( "sfx", "level2/sfx/aud_superpuzzle2_clk3", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.LeversWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_superpuzzle2_door_1",        { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_5_levers",   { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_5",   { alp = 1 } } );   
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_5",    { alp = 0 } } );   

    if ( private.levers.win ) and ( private.match3.win ) and ( private.hexs.win ) then

      for i = 1, 6 do

        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i,          { input = true, alp = 1 } } ); 
        table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_"..i.."_down", { alp = 0 } } );   

      end;

      table.insert( table_multiset, { "spr_superpuzzle2_mg_8_red_6_light", { alp = 1 } } );   

    end;

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.LeversResetSet ()

    local table_multiset = {};

    private.levers.win = false;

    private.levers.current_list = { 165, 165, 165 };

    private.levers_first = true;

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.current_list = { 165, 165, 165 };
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].levers.win = false;

    for i = 1, #private.levers.current_list do
          
      local pos_y = private.levers.current_list[ i ];

      table.insert( table_multiset, { "spr_superpuzzle2_mg_5_lever_"..i, { pos_y = pos_y } } );

      private.LeversHolePos( i, pos_y );

    end;

    table.insert( table_multiset, { "spr_superpuzzle2_door_1",      { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_5_levers", { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle2_mg_5",        { alp = 0 } } );

    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_blue_5", { alp = 0 } } );   
    table.insert( table_multiset, { "spr_superpuzzle2_mg_7_red_5",  { alp = 1 } } );   

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Squares ***() end
--*********************************************************************************************************************
  function private.SquaresClk ( number )

    common_impl.Lock( true );

    local number_ang_old = private.squares.current_list[ number ]; 
    
    local number_ang_new = number_ang_old + 1;

    local ang_anim = private.squares_ang[ number_ang_new ];

    if ( number_ang_new == 5 ) then

      number_ang_new = 1;

    end;

    local ang_old = private.squares_ang[ number_ang_old ];
    local ang_new = private.squares_ang[ number_ang_new ];

    local func_end = function ()

      common_impl.Lock( false );

      private.SquaresClkEnd( number, number_ang_new );

    end;

    ObjAnimate( "spr_superpuzzle2_mg_7_picture_"..number, "ang", 0, 0, func_end, { 0,3,ang_old,  0.3,3,ang_anim,  0.3,3,ang_new } );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_mg_superpuzzle1_clk2", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SquaresClkEnd ( number, number_ang_new )

    private.squares.current_list[ number ] = number_ang_new;
    
    local flag_win = true;

    for i = 1, #private.squares.current_list do
      
      if ( private.squares.current_list[ i ] ~= private.squares_win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.SquaresWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.current_list[ number ] = number_ang_new;

    end;

  end;
  --*********************************************************************************************************************
  function private.SquaresWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.squares.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.win = true;

      private.SquaresWinSet();

      private.Win();

    end;

    func_end(); 

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_squares_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.SquaresWinSet ()

    local table_multiset = {};

    --table.insert( table_multiset, { "spr_superpuzzle2_door_2",        { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_7_squares", { input = false } } );

    ObjMultiSet( table_multiset );

  end;
  --*********************************************************************************************************************
  function private.SquaresResetSet ()

    local table_multiset = {};

    private.squares.win = false;
    private.squares.current_list = { 4, 2, 1, 4, 1, 1, 2, 2, 3 };

    ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.current_list = { 4, 2, 1, 4, 1, 1, 2, 2, 3 };
    ng_global.progress[ "std" ][ "win_superpuzzle2" ].squares.win = false;

    for i = 1, #private.squares.current_list do
          
      local ang = private.squares_ang[ private.squares.current_list[ i ] ];

      table.insert( table_multiset, { "spr_superpuzzle2_mg_7_picture_"..i, { ang = ang } } );

    end;

    --table.insert( table_multiset, { "spr_superpuzzle2_door_2", { pos_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle2_mg_7_squares", { input = false } } );

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
  --*********************************************************************************************************************
  function private.PuszzleHintClk ()

    local postfix = private.GetHintPostfix();

    interface.DialogShow( "ifo_superpuzzle2_hint_"..postfix );

    common_impl.PlayAudio( "sfx", "level1/sfx/aud_puzzle_hint", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PuszzleHintEnter ()

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle2_hint_1", { alp = 1 } );

  end;
  --*********************************************************************************************************************
  function private.PuszzleHintLeave ()

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle2_hint_1", { alp = 0 } );

  end;
  --*********************************************************************************************************************
  function private.GetHintPostfix ()

    local postfix;

    if     ( private.numbers.done_number == 1 ) or 
           ( private.numbers.done_number == 2 and private.pictures.win ) or 
           ( private.numbers.done_number == 3 and private.maze.win ) or 
           ( private.numbers.done_number == 4 and private.bottles.win ) or 
           ( private.numbers.done_number == 5 and private.hexs.win and private.match3.win and private.levers.win ) then 

      postfix = "1";

    elseif ( not private.pictures.win ) then    

      postfix = "2";

    elseif ( not private.maze.win ) then 

      postfix = "3";

    elseif ( not private.bottles.win ) then

      postfix = "4";

    elseif ( not private.match3.win ) then    

      postfix = "5";

    elseif ( not private.levers.win ) then    

      postfix = "6";

    elseif ( not private.hexs.win ) then    

      postfix = "7";

    elseif ( not private.squares.win ) then    

      postfix = "8";

    end;

    return postfix or 1;

  end;
  --*********************************************************************************************************************
