-- name=mg_minelabyrinth
--*********************************************************************************************************************
function public.Init ()

  private.room_objname = "mg_minelabyrinth";

--  ObjMultiSet({ 
--
--  });

  ObjAnimate( "spr_minelabyrinth_button_light",   "alp", 1, 0, "", { 0,3,0,  0.2,3,1,  0.4,3,0 } );
  ObjAnimate( "spr_minelabyrinth_button_light_2", "alp", 1, 0, "", { 0,3,0,  0.2,3,1,  0.4,3,0 } );
  --------------------------------------------------------------------------------------------
  -- function use_mapsheet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mapsheet" ] = {
    type = "use",
    inv_obj = "inv_mapsheet",
    use_place = "obj_minelabyrinth_use_mapsheet",
    room = private.room_objname
  };
  local use_mapsheet_inv = function ()
  
    interface.InventoryItemRemove( "inv_mapsheet" );
  
  end;
  local use_mapsheet_beg = function ()
  
    ObjDelete( "obj_minelabyrinth_use_mapsheet" );

  end;
  local use_mapsheet_end = function ()
  
    ObjSet( "obj_minelabyrinth_hand_card", { input = true, alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mapsheet", use_mapsheet_beg, private.room_objname );
  cmn.AddSubscriber( "use_mapsheet", use_mapsheet_inv );
  cmn.AddSubscriber( "use_mapsheet", use_mapsheet_end, private.room_objname );
  cmn.AddSubscriber( "use_mapsheet_inv", use_mapsheet_inv, private.room_objname );
  cmn.AddSubscriber( "use_mapsheet_beg", use_mapsheet_beg, private.room_objname );
  cmn.AddSubscriber( "use_mapsheet_end", use_mapsheet_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_minelabyrinth () end;
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "win_minelabyrinth" ] = {
    type = "win",
    room = "rm_archives_3",
    zz = "mg_minelabyrinth",
    zz_gate = "gmg_archives_3_minelabyrinth"
  };

  local win_minelabyrinth = function ()

    local table_multiset = {};

    if ( cmn.IsEventDone( "win_minelabyrinth" ) ) then  

    else

      if ( ng_global.progress[ "std" ][ "win_minelabyrinth" ].current_state ) then

        private.win           = ng_global.progress[ "std" ][ "win_minelabyrinth" ].win;
        private.current_state = ng_global.progress[ "std" ][ "win_minelabyrinth" ].current_state;

        private.SetLocation( private.current_state );

      end;

    end;

    -----------------------------

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  local win_minelabyrinth_delete = function ()

    if ( cmn.IsEventDone( "win_minelabyrinth" ) ) then  

      ObjDelete( "gmg_archives_3_minelabyrinth" );

    end;

  end;

  cmn.AddSubscriber( "win_minelabyrinth", win_minelabyrinth, private.room_objname );
  cmn.AddSubscriber( "win_minelabyrinth", win_minelabyrinth_delete, "rm_archives_3" );
   
  --------------------------------------------------------------------------------------------

  local table_multiset = {};

  ------------------------------------------------------------------------------------

  private.current_state = 1;
  private.win_state     = 36;

  private.states = {};  
  --                      directions           new state
  private.states[ 1 ]  = { dir = { 2 },        state = { 2 } };
  private.states[ 2 ]  = { dir = { 1,2,3,4 },  state = { 3,11,5,1 } };
  private.states[ 3 ]  = { dir = { 3,4 },      state = { 4,2 } };
  private.states[ 4 ]  = { dir = { 4 },        state = { 3 } };
  private.states[ 5 ]  = { dir = { 1,2,4 },    state = { 6,7,2 } };
  private.states[ 6 ]  = { dir = { 4 },        state = { 5 } };
  private.states[ 7 ]  = { dir = { 1,4 },      state = { 8,5 } };
  private.states[ 8 ]  = { dir = { 1,2,4 },    state = { 10,9,7 } };
  private.states[ 9 ]  = { dir = { 4 },        state = { 8 } };
  private.states[ 10 ] = { dir = { 4 },        state = { 8 } };
  private.states[ 11 ] = { dir = { 1,2,3,4 },  state = { 12,13,17,2 } };
  private.states[ 12 ] = { dir = { 4 },        state = { 11 } };
  private.states[ 13 ] = { dir = { 1,2,3,4 },  state = { 16,15,14,11 } };
  private.states[ 14 ] = { dir = { 4 },        state = { 13 } };
  private.states[ 15 ] = { dir = { 4 },        state = { 13 } };
  private.states[ 16 ] = { dir = { 4 },        state = { 13 } };
  private.states[ 17 ] = { dir = { 1,2,3,4 },  state = { 20,19,18,11 } };
  private.states[ 18 ] = { dir = { 4 },        state = { 17 } };
  private.states[ 19 ] = { dir = { 4 },        state = { 17 } };
  private.states[ 20 ] = { dir = { 1,2,3,4 },  state = { 21,26,22,17 } };
  private.states[ 21 ] = { dir = { 4 },        state = { 20 } };
  private.states[ 22 ] = { dir = { 1,3,4 },    state = { 24,23,20 } };
  private.states[ 23 ] = { dir = { 4 },        state = { 22 } };
  private.states[ 24 ] = { dir = { 1,4 },      state = { 25,22 } };
  private.states[ 25 ] = { dir = { 4 },        state = { 24 } };
  private.states[ 26 ] = { dir = { 1,3,4 },    state = { 28,27,20 } };
  private.states[ 27 ] = { dir = { 4 },        state = { 26 } };
  private.states[ 28 ] = { dir = { 1,2,4 },    state = { 29,30,26 } };
  private.states[ 29 ] = { dir = { 4 },        state = { 28 } };
  private.states[ 30 ] = { dir = { 1,4 },      state = { 31,28 } };
  private.states[ 31 ] = { dir = { 1,2,4 },    state = { 32,33,30 } };
  private.states[ 32 ] = { dir = { 4 },        state = { 31 } };
  private.states[ 33 ] = { dir = { 1,2,3,4 },  state = { 34,35,36,31 } };
  private.states[ 34 ] = { dir = { 4 },        state = { 33} };
  private.states[ 35 ] = { dir = { 4 },        state = { 33 } };
  private.states[ 36 ] = { dir = { 4 },        state = { 33} };

  private.zoom_pos = { { 50,-100 }, { -230,-100 }, { -560,-100 } };

  ------------------------------------------------------------------------------------

  for a = 1, 4 do
    
    table.insert( table_multiset, { "obj_minelabyrinth_arrows_"..a, { 
      event_mdown  = function () private.Clk( a ) end
    } } );

  end;

  table.insert( table_multiset, { "obj_minelabyrinth_hand_card", { 
    event_mdown  = function () private.ClkHand() end
  } } );

  --------------------------------------
  if ( #table_multiset > 0 ) then

    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function public.Load ()

end;
--*********************************************************************************************************************
function public.Open () 

  if ( not cmn.IsEventDone( "win_minelabyrinth" ) ) and ( cmn.IsEventDone( "use_mapsheet" ) ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart( "minelabyrinth" );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen ()

  common_impl.EnvPlay( { "level3/env/aud_labyrinth_env" }, "", 0.5 );

  if ( not cmn.IsEventStart( "win_minelabyrinth" ) ) and ( cmn.IsEventDone( "use_mapsheet" ) ) then

    ng_global.progress[ "std" ][ "win_minelabyrinth" ].win           = private.win;
    ng_global.progress[ "std" ][ "win_minelabyrinth" ].current_state = private.current_state;

  end;

end;
--*********************************************************************************************************************
function public.Close ()
end;
--*********************************************************************************************************************
function public.PreClose ()

  --common_impl.EnvPlay( { "level3/env/aud_labyrinth_env" }, "", 0.5 );

  if not cmn.IsEventDone( "win_minelabyrinth" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop( "minelabyrinth" );

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_mapsheet ()

  local item = "inv_mapsheet";

  if ( cmn.ApplyObj( item, "obj_minelabyrinth_use_mapsheet" ) ) then

    cmn.CallEventHandler( "use_mapsheet_inv" );
    cmn.CallEventHandler( "use_mapsheet_beg" );

    local func_end = function ()

      cmn.Lock( false );

      cmn.SetEventDone( "use_mapsheet" );
      cmn.CallEventHandler( "use_mapsheet_end" );

      cmn.MiniGameShow();
      common_impl.PassingMgStart( "minelabyrinth" );

    end;

    cmn.Lock( true );

    common_impl.PlayAudio( "sfx", "aud_paper", 0, "", 0 );

    ObjAnimate( "obj_minelabyrinth_hand_card", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );
    
    return true;

  end;
  
  return false;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset ()

  private.current_state = 1;
  private.win_state     = 36;

  ng_global.progress[ "std" ][ "win_minelabyrinth" ].current_state = 1;
  ng_global.progress[ "std" ][ "win_minelabyrinth" ].win_state     = 36;

  private.SetLocation( private.current_state );

end;
--*********************************************************************************************************************
function public.Skip ()

port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd ()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_minelabyrinth" );
  cmn.CallEventHandler( "win_minelabyrinth" );
  common_impl.PassingMgWin( "minelabyrinth" );

  cmn.GotoRoom( "rm_ventilationshaft" );

end;
--*********************************************************************************************************************
function private.Win ()

  local func_end = function ()

    common_impl.Lock( false );

    private.WinEnd();

  end;

  common_impl.Lock( true );

  private.SetLocation( private.win_state );

  ObjAnimate( "obj_minelabyrinth_zoom", "pos_xy", 0, 0, "", { 
    0.0,  3,  0,  0,
    0.4,  3,  0,  0,
    2.0,  3,  private.zoom_pos[ 2 ][ 1 ],  private.zoom_pos[ 2 ][ 2 ],
  } );

  ObjAnimate( "obj_minelabyrinth_zoom", "scale_xy", 0, 0, func_end, { 
    0.0,  3,  1.0,  1.0,
    0.4,  3,  1.0,  1.0,
    2.0,  3,  1.5,  1.5
  } );

  AnimPlay( "anm_minelabyrinth_hands_move", "DoAnim", "" );

end;
--*********************************************************************************************************************
-- function *** MG ***() end
--*********************************************************************************************************************
  function private.Clk ( direction )

    local states = private.states[ private.current_state ].state;
    local dirs   = private.states[ private.current_state ].dir;

    local new_state = 0;
    local new_dir = 0;

    for i = 1, #dirs do
    
      if ( dirs[ i ] == direction ) then

        new_state = states[ i ];
        new_dir   = dirs[ i ];

        break;

      end;

    end;

    if ( new_state ~= 0 ) then

      local func_end = function ()

        common_impl.Lock( false );

        private.SetLocation( new_state );

        ObjSet( "obj_minelabyrinth_zoom", { pos_x = 0, pos_y = 0, scale_x = 1, scale_y = 1 } );
        ObjSet( "obj_minelabyrinth_arrows", { alp = 1 } );

        private.ClkEnd( new_state );

      end;

      common_impl.Lock( true );

      if ( new_dir ~= 4 ) then

        ObjAnimate( "obj_minelabyrinth_zoom", "pos_xy", 0, 0, "", { 
          0.0,  3,  0,  0,
          0.6,  3,  private.zoom_pos[ new_dir ][ 1 ],  private.zoom_pos[ new_dir ][ 2 ],
        } );
    
        ObjAnimate( "obj_minelabyrinth_zoom", "scale_xy", 0, 0, "", { 
          0.0,  3,  1.0,  1.0,
          0.6,  3,  1.5,  1.5,
        } );
    
      end;

      private.SetLocation2( new_state );

      ObjSet( "obj_minelabyrinth_arrows", { alp = 0 } );

      ObjAnimate( "obj_minelabyrinth_zoom", "alp", 0, 0, "", { 
        0.0,  3,  1,
        0.4,  3,  1,
        0.6,  3,  0
      } );
    
      ObjAnimate( "spr_minelabyrinth_back_2", "alp", 0, 0, "", { 
        0.0,  3,  0,
        0.2,  3,  0,
        0.6,  3,  1
      } );

      AnimPlay( "anm_minelabyrinth_hands_move", "DoAnim", func_end );

    end;

    local rnd = math.random( 1,3 );

        if rnd == 1 then common_impl.PlayAudio( "sfx", "level3/sfx/aud_creep1", 0, "", 0 );
    elseif rnd == 2 then common_impl.PlayAudio( "sfx", "level3/sfx/aud_creep2", 0, "", 0 );
    elseif rnd == 3 then common_impl.PlayAudio( "sfx", "level3/sfx/aud_creep3", 0, "", 0 );
    end;

  end;
--*********************************************************************************************************************
  function private.ClkEnd ( new_state )

    --local func_end = function ()

      private.current_state = new_state;

      if ( private.current_state == private.win_state ) then

        private.Win();

      else

        ng_global.progress[ "std" ][ "win_minelabyrinth" ].current_state = new_state;

      end;

    --end;

    ObjSet( "obj_minelabyrinth_zoom",   { alp = 1 } );
    ObjSet( "spr_minelabyrinth_back_2", { alp = 0 } );
    --ObjAnimate( "obj_minelabyrinth_zoom", "alp", 0, 0, func_end, { 
    --  0.0,  3,  0,
    --  0.1,  3,  1
    --} );

  end;
--*********************************************************************************************************************
  function private.ClkHand ()

    local func_end = function ()

      common_impl.Lock( false );

      ObjSet( "obj_minelabyrinth_hand_card",    { input = false } );
      ObjSet( "obj_minelabyrinth_arrows",       { input = true } );

    end;

    common_impl.Lock( true );

    ObjAnimate( "obj_minelabyrinth_hand_card", "alp", 0, 0, "", { 
      0.0,  3,  1,
      0.6,  3,  0,
    } );


    ObjAnimate( "obj_minelabyrinth_hands", "alp", 0, 0, "", { 
      0.0,  3,  0,
      0.6,  3,  1,
    } );

    ObjAnimate( "obj_minelabyrinth_arrows", "alp", 0, 0, func_end, { 
      0.0,  3,  0,
      0.6,  3,  1,
    } );
    
  end;
--*********************************************************************************************************************
  function private.SetLocation ( current_state )

    local new_directions = private.states[ current_state ].dir;

    ObjSet( "spr_minelabyrinth_left",         { alp = 0 } );
    ObjSet( "spr_minelabyrinth_block",        { alp = 1 } );
    ObjSet( "spr_minelabyrinth_right",        { alp = 0 } );
    ObjSet( "spr_minelabyrinth_exit",         { alp = 0 } );
    ObjSet( "spr_minelabyrinth_game_up_side", { alp = 0 } );
    ObjSet( "obj_minelabyrinth_hand_card",    { alp = 0, input = false } );
    ObjSet( "obj_minelabyrinth_hands",        { alp = 1 } );
    ObjSet( "obj_minelabyrinth_arrows",       { alp = 1, input = true } );

    for i = 1, #new_directions do

      if ( new_directions[ i ] == 1 ) then

        ObjSet( "spr_minelabyrinth_left", { alp = 1 } );

      end;

      if ( new_directions[ i ] == 2 ) then

        ObjSet( "spr_minelabyrinth_block", { alp = 0 } );

      end;

      if ( new_directions[ i ] == 3 ) then

        ObjSet( "spr_minelabyrinth_right", { alp = 1 } );

      end;

    end;

    if ( current_state == 1 ) then

      ObjSet( "spr_minelabyrinth_game_up_side", { alp = 1 } );
      ObjSet( "obj_minelabyrinth_hand_card",    { alp = 1, input = true } );
      ObjSet( "obj_minelabyrinth_hands",        { alp = 0 } );
      ObjSet( "obj_minelabyrinth_arrows",       { alp = 0, input = false } );

    end;

    if ( current_state == private.win_state ) then

      ObjSet( "spr_minelabyrinth_exit",   { alp = 1 } );
      ObjSet( "spr_minelabyrinth_block",  { alp = 0 } );
      ObjSet( "obj_minelabyrinth_arrows", { alp = 0, input = false } );

    end;

    private.SetArrow( current_state );

  end;
--*********************************************************************************************************************
  function private.SetLocation2 ( current_state )

    local new_directions = private.states[ current_state ].dir;

    ObjSet( "spr_minelabyrinth_left_2",         { alp = 0 } );
    ObjSet( "spr_minelabyrinth_block_2",        { alp = 1 } );
    ObjSet( "spr_minelabyrinth_right_2",        { alp = 0 } );
    ObjSet( "spr_minelabyrinth_exit_2",         { alp = 0 } );

    for i = 1, #new_directions do

      if ( new_directions[ i ] == 1 ) then

        ObjSet( "spr_minelabyrinth_left_2", { alp = 1 } );

      end;

      if ( new_directions[ i ] == 2 ) then

        ObjSet( "spr_minelabyrinth_block_2", { alp = 0 } );

      end;

      if ( new_directions[ i ] == 3 ) then

        ObjSet( "spr_minelabyrinth_right_2", { alp = 1 } );

      end;

    end;

    if ( current_state == private.win_state ) then

      ObjSet( "spr_minelabyrinth_exit_2",  { alp = 1 } );
      ObjSet( "spr_minelabyrinth_block_2", { alp = 0 } );

    end;

  end;
--*********************************************************************************************************************
  function private.SetArrow ( current_state )

    local dirs = private.states[ current_state ].dir;

    for a = 1, 4 do
    
      ObjSet( "obj_minelabyrinth_arrows_"..a, { alp = 0, input = 0, active = 0 } );

    end;

    for d = 1, #dirs do
    
      local number = dirs[ d ];

      ObjSet( "obj_minelabyrinth_arrows_"..number, { alp = 1, input = 1, active = 1 } );

    end;

  end;
--*********************************************************************************************************************